'
' ####################
' #####  PROLOG  #####
' ####################
'
' An WinX GUI program
'
VERSION	"0.0000"
'CONSOLE
'
	IMPORT	"xst"   		' standard library	: required by most programs
	IMPORT  "xsx"				' extended std library
'	IMPORT	"xio"				' console io library
	IMPORT	"msimg32"
	IMPORT	"gdi32"     ' gdi32.dll
	IMPORT  "user32"    ' user32.dll
	IMPORT  "kernel32"  ' kernel32.dll
	IMPORT  "comctl32"	' comctl32.dll			: common controls library
	IMPORT	"advapi32"
'	IMPORT	"comdlg32"  ' comdlg32.dll	    : common dialog library
'	IMPORT	"xma"   		' math library			: Sin/Asin/Sinh/Asinh/Log/Exp/Sqrt...
'	IMPORT	"xcm"				' complex math library
'	IMPORT  "msvcrt"		' msvcrt.dll				: C function library
'	IMPORT  "shell32"   ' shell32.dll
	IMPORT	"WinX"			' The WinX GUI library
	IMPORT	"ADT"
	
	IMPORT	"calculate"
	IMPORT	"BetterCalcDefs.dec"
	
	
$$LV_SYMBOLS		= 1000
$$PANEL_CONSOLE	= 1001
$$PANEL_KEYPAD	= 1002
$$BT_KEYPADITEM	= 2000

$$MENU_FILE		= 3000
$$MENU_EDIT		= 3001
$$MENU_WINDOW	= 3002
$$MENU_HELP		= 3003

$$CMD_CLEAR		= 3100
$$CMD_OPEN		= 3101
$$CMD_SAVE		= 3102
$$CMD_SAVEAS	= 3103
$$CMD_CONFIG	= 3104
$$CMD_EXIT		= 3105

$$CMD_CUT				= 3200
$$CMD_COPY			= 3201
$$CMD_COPYLAST	= 3202
$$CMD_PASTE			= 3203
$$CMD_SELECTALL	= 3204

$$CMD_NEWGRAPH	= 3300
$$CMD_ALWAYSONTOP = 3301

$$CMD_HELP		= 3400
$$CMD_ABOUT		= 3401

$$CMD_INSERT		= 3500
$$CMD_DELETE		= 3501
$$CMD_DELETEALL	= 3502

$$CONFIG_RB_RAD		= 4000
$$CONFIG_RB_DEG		= 4001
$$CONFIG_RB_GRAD	= 4002
$$CONFIG_RB_NONE	= 4003
$$CONFIG_RB_FIX		= 4004
$$CONFIG_RB_SCI		= 4005
$$CONFIG_EB_FIX		= 4006
$$CONFIG_EB_SCI		= 4007
$$CONFIG_RB_BIN		= 4008
$$CONFIG_RB_OCT		= 4009
$$CONFIG_RB_DEC		= 4010
$$CONFIG_RB_HEX		= 4011
$$CONFIG_EB_BITS	= 4012
$$CONFIG_BT_FONT	= 4013
$$CONFIG_BT_COL		= 4014

TYPE LINE
	XLONG				.beforeSel
	XLONG				.sel
	XLONG				.adterSel
END TYPE
TYPE CONSOLESTATE
	LINKEDLIST	.lines
	LINKEDLIST	.lineData
	LINE				.currentLine
	LINKEDLIST	.history
	XLONG				.historyPos
	
	LOGFONT			.font
	XLONG				.hFont
	XLONG				.forCol
	XLONG				.backCol
	
	XLONG				.maxWidth
	XLONG				.promptWidth
	XLONG				.stringPos
	XLONG				.scrollX
	XLONG				.scrollY
	
	XLONG				.selStartLine
	XLONG				.selLineCount
	XLONG				.selStartChar
	XLONG				.selCharCount
END TYPE
TYPE GUISTATE
	XLONG				.changed
	XLONG				.mainSeries
	XLONG				.secondSeries
	XLONG				.hToolbar
	XLONG				.hCon
	XLONG				.hPad
	XLONG				.hLV
	XLONG				.debug
	
	XLONG				.alwaysOnTop
	
	XLONG				.hSelBrush
	XLONG				.hIcon
	XLONG				.hMainMenu
	XLONG				.hAccelerators
	XLONG				.hToolbarBMP
	STRING*1		.trigPrefix
	STRING*2		.trigSuffix
	
	XLONG				.hListContextMenu
	XLONG				.iContextItem
END TYPE
TYPE CONFIGSTATE
	XLONG				.dialogVisible
	XLONG				.hDlg
	XLONG				.outputMode
	XLONG				.rounding
	XLONG				.roundParam
	XLONG				.angleMode
	XLONG				.precision
	LOGFONT			.newFont
	XLONG				.forCol
	XLONG				.backCol
END TYPE

DECLARE FUNCTION Entry ()
DECLARE FUNCTION initApp ()
DECLARE FUNCTION initWindow ()
DECLARE FUNCTION cleanUp ()
DECLARE FUNCTION onCommand (id, code, hWnd)
DECLARE FUNCTION BuildKeypad (hPad)
DECLARE FUNCTION onScrollPad (pos, hWnd, direction)
DECLARE FUNCTION onScrollConsole (pos, hWnd, direction)
DECLARE FUNCTION onMouseWheel (hWnd, delta, x, y)
DECLARE FUNCTION Console_Redraw (hCon, deltaX, deltaY)
DECLARE FUNCTION onFocusChange (hWnd, hasFocus)
DECLARE FUNCTION onChar (hWnd, char)
DECLARE FUNCTION onKeyDown (hWnd, key)
DECLARE FUNCTION isNum (char)
DECLARE FUNCTION isHexit (char)
DECLARE FUNCTION isAlpha (char)
DECLARE FUNCTION isAlphaNum (char)
DECLARE FUNCTION isWhitespace (char)
DECLARE FUNCTION UpdateCaretPos (hWnd, checkCaretPos)
DECLARE FUNCTION UpdateConsoleWidth (hWnd, newWidth, scrollRight)
DECLARE FUNCTION UpdateConsoleHeight (hWnd)
DECLARE FUNCTION UpdateSymbolList ()
DECLARE FUNCTION onMainFocusChange (hWnd, hasFocus)
DECLARE FUNCTION InsertText (text$)
DECLARE FUNCTION onClose (hWnd)
DECLARE FUNCTION ShowConfigDialog ()
DECLARE FUNCTION onCommandConfig(id, code, hWnd)
DECLARE FUNCTION onCloseConfig (hWnd)
DECLARE FUNCTION UpdateStatus ()
DECLARE FUNCTION onClipChange ()
DECLARE FUNCTION SaveEnvironment ()
DECLARE FUNCTION RestoreEnvironment ()
DECLARE FUNCTION onSelectionChanged ()
DECLARE FUNCTION onMouseDown (hWnd, button, x, y)
DECLARE FUNCTION onMouseMove (hWnd, x, y)
DECLARE FUNCTION onMouseUp (hWnd, button, x, y)
DECLARE FUNCTION RemoveSelection ()
DECLARE FUNCTION onLVItem (idControl, event, parameter)
DECLARE FUNCTION onLVLabelEdit (control, code, item, text$)

'
'
' ######################
' #####  Entry ()  #####
' ######################
'
FUNCTION Entry ()
	SHARED GUISTATE guiState
	
	'make sure WinX is properly initialised
	IF WinX() THEN QUIT(0)
	
	'quit if either of these fail
  IF initApp () THEN QUIT(0)
	IF initWindow () THEN QUIT(0)
	
	WinXDoEvents (guiState.hAccelerators)
	
	cleanUp ()
END FUNCTION
'
' #####################
' #####  initApp  #####
' #####################
' 
'
'
FUNCTION initApp ()
	SHARED CONSOLESTATE conState
	SHARED GUISTATE guiState
	SHARED currentLine$
	SHARED currentFileName$
	
	ADT ()
	calculate_init ()
	
	LinkedList_Init (@conState.lines)
	LinkedList_Init (@conState.history)
	LinkedList_Append (@conState.lines, STRING_New("# A Better Calculator"))
	LinkedList_Append (@conState.lines, STRING_New("# Version 3.00"))
	LinkedList_Append (@conState.lines, STRING_New(""))
	
	' these are default settings.  Normally they will be replaced by the real settings from the registry
	conState.font = WinXDraw_MakeLogFont ("Courier New", 16, 0)
	conState.hFont = CreateFontIndirectA (&conState.font)
	conState.forCol = 0x000000
	conState.backCol = 0xFFFFFF
	
	conState.promptWidth = WinXDraw_GetTextWidth (conState.hFont, "Enter Expression: ", -1)
	
	currentFileName$ = ""
	guiState.changed = $$FALSE
	guiState.trigSuffix = " "
	
	guiState.hSelBrush = CreateSolidBrush (GetSysColor ($$COLOR_HIGHLIGHT))
	guiState.hIcon = LoadIconA (GetModuleHandleA (0), $$ICON_MAIN)
	guiState.hToolbarBMP = LoadBitmapA (GetModuleHandleA (0), $$BMP_TOOLBAR)
	
	'XioCreateConsole ("Debugging console", 25)
	'XioHideConsole ()
	
	RETURN 0
END FUNCTION
'
' ########################
' #####  initWindow  #####
' ########################
'
'
'
FUNCTION initWindow ()
	SHARED CONSOLESTATE conState
	SHARED GUISTATE guiState
	ACCEL accel[]
	
	' The menu
	guiState.hMainMenu = WinXNewMenu ("&File,&Edit,&Window,&Help", $$MENU_FILE, $$FALSE)
	hMenu = WinXNewMenu ("&New\tCtrl+N,&Open\tCtrl+O,&Save\tCtrl+S,Save &As,,&Config\tF2,,E&xit\tCtrl+Q", $$CMD_CLEAR, $$TRUE) :	WinXMenu_Attach (hMenu, guiState.hMainMenu, $$MENU_FILE)
	hMenu = WinXNewMenu ("Cu&t\tCtrl+X,&Copy\tCtrl+C,Copy &Last Answer\tCtrl+L,&Paste\tCtrl+V,,Select &All\tCtrl+A", $$CMD_CUT, $$TRUE) :	WinXMenu_Attach (hMenu, guiState.hMainMenu, $$MENU_EDIT)
	hMenu = WinXNewMenu ("New &Graph\tCtrl+G,,Always on top\tF5", $$CMD_NEWGRAPH, $$TRUE) :	WinXMenu_Attach (hMenu, guiState.hMainMenu, $$MENU_WINDOW)
	hMenu = WinXNewMenu ("&Contents\tF1,&About", $$CMD_HELP, $$TRUE) :	WinXMenu_Attach (hMenu, guiState.hMainMenu, $$MENU_HELP)
	
	EnableMenuItem (guiState.hMainMenu, $$CMD_SAVE, $$MF_BYCOMMAND|$$MF_GRAYED)
	EnableMenuItem (guiState.hMainMenu, $$CMD_CUT, $$MF_BYCOMMAND|$$MF_GRAYED)
	EnableMenuItem (guiState.hMainMenu, $$CMD_COPY, $$MF_BYCOMMAND|$$MF_GRAYED)
	EnableMenuItem (guiState.hMainMenu, $$CMD_COPYLAST, $$MF_BYCOMMAND|$$MF_GRAYED)
	IF !WinXClip_IsString () THEN EnableMenuItem (guiState.hMainMenu, $$CMD_PASTE, $$MF_BYCOMMAND|$$MF_GRAYED)
	
	#hMain = WinXNewWindow (0, "A Better Calculator 3", 0, 0, 0, 0, $$XWSS_APP, 0, guiState.hIcon, guiState.hMainMenu)
	? "hMain: ";#hMain
	WinXSetMinSize (#hMain, 290, 230)
	
	' The accelerators
	WinXAddAccelerator (@accel[], $$CMD_CLEAR, 'N', $$TRUE, $$FALSE, $$FALSE)
	WinXAddAccelerator (@accel[], $$CMD_OPEN, 'O', $$TRUE, $$FALSE, $$FALSE)
	WinXAddAccelerator (@accel[], $$CMD_SAVE, 'S', $$TRUE, $$FALSE, $$FALSE)
	WinXAddAccelerator (@accel[], $$CMD_CONFIG, $$VK_F2, $$FALSE, $$FALSE, $$FALSE)
	WinXAddAccelerator (@accel[], $$CMD_EXIT, 'Q', $$TRUE, $$FALSE, $$FALSE)
	WinXAddAccelerator (@accel[], $$CMD_CUT, 'X', $$TRUE, $$FALSE, $$FALSE)
	WinXAddAccelerator (@accel[], $$CMD_COPY, 'C', $$TRUE, $$FALSE, $$FALSE)
	WinXAddAccelerator (@accel[], $$CMD_COPYLAST, 'L', $$TRUE, $$FALSE, $$FALSE)
	WinXAddAccelerator (@accel[], $$CMD_PASTE, 'V', $$TRUE, $$FALSE, $$FALSE)
	WinXAddAccelerator (@accel[], $$CMD_SELECTALL, 'A', $$TRUE, $$FALSE, $$FALSE)
	WinXAddAccelerator (@accel[], $$CMD_NEWGRAPH, 'G', $$TRUE, $$FALSE, $$FALSE)
	WinXAddAccelerator (@accel[], $$CMD_ALWAYSONTOP, $$VK_F5, $$FALSE, $$FALSE, $$FALSE)
	WinXAddAccelerator (@accel[], $$CMD_HELP, $$VK_F1, $$FALSE, $$FALSE, $$FALSE)
	guiState.hAccelerators = CreateAcceleratorTableA (&accel[], UBOUND(accel[])+1)

	' The toolbar
	guiState.hToolbar = WinXNewToolbar (32, 32, 7, guiState.hToolbarBMP, 0, 0, 0xFF00FF, $$TRUE, $$FALSE)
	WinXToolbar_AddButton (guiState.hToolbar, $$CMD_CLEAR, 0, "Clear the history", $$FALSE, $$FALSE)
	WinXToolbar_AddButton (guiState.hToolbar, $$CMD_SAVE, 1, "Save the history", $$FALSE, $$FALSE)
	WinXToolbar_EnableButton (guiState.hToolbar, $$CMD_SAVE, $$FALSE)
	WinXToolbar_AddButton (guiState.hToolbar, $$CMD_OPEN, 2, "Open a previously saved history file", $$FALSE, $$FALSE)
	WinXToolbar_AddButton (guiState.hToolbar, $$CMD_COPYLAST, 3, "Copy last answer", $$FALSE, $$FALSE)
	WinXToolbar_EnableButton (guiState.hToolbar, $$CMD_COPYLAST, $$FALSE)
	WinXToolbar_AddButton (guiState.hToolbar, $$CMD_NEWGRAPH, 4, "Create a new graphing window", $$FALSE, $$FALSE)
	WinXToolbar_AddButton (guiState.hToolbar, $$CMD_CONFIG, 5, "Display the configuration dialog box", $$FALSE, $$FALSE)
	WinXToolbar_AddButton (guiState.hToolbar, $$CMD_HELP, 6, "Show the manual", $$FALSE, $$FALSE)
	WinXSetWindowToolbar (#hMain, guiState.hToolbar)
	
	' The status bar
	WinXAddStatusBar (#hMain, "Angle = Radians,Output Rounding = None,Output Display = Decimal,Presicion (Bits) = 256", 0)
	UpdateStatus ()
	
	' The main series
	guiState.mainSeries = WinXNewAutoSizerSeries ($$DIR_HORIZ)
	WinXAutoSizer_SetSimpleInfo (guiState.mainSeries, WinXAutoSizer_GetMainSeries (#hMain), 0, 1.0, $$SIZER_SERIES)
	
	' The left pane
	guiState.hLV = WinXAddListView (#hMain, 0, 0, $$TRUE, $$LVS_REPORT, $$LV_SYMBOLS)
	WinXSetStyle (guiState.hLV, 0, $$WS_EX_CLIENTEDGE, 0, 0)
	WinXAutoSizer_SetSimpleInfo (guiState.hLV, guiState.mainSeries, 0, 200, $$SIZER_SPLITTER)
	WinXSplitter_SetProperties (guiState.mainSeries, guiState.hLV, 40, 0, $$TRUE)
	
	WinXListView_AddColumn (guiState.hLV, 0, 50, "Symbol", 0)
	WinXListView_AddColumn (guiState.hLV, 1, 138, "Definition", 1)
	UpdateSymbolList ()
	
	guiState.hListContextMenu = WinXNewMenu ("&Insert,&Delete,Delete &All", $$CMD_INSERT, $$TRUE)
	
	' The right panes
	guiState.secondSeries = WinXNewAutoSizerSeries ($$DIR_VERT|$$DIR_REVERSE)
	WinXAutoSizer_SetSimpleInfo (guiState.secondSeries, guiState.mainSeries, 0, 1.0, $$SIZER_SIZERELREST|$$SIZER_SERIES)

	' The keypad
	guiState.hPad = WinXNewChildWindow (#hMain, "", $$WS_CLIPSIBLINGS, $$WS_EX_CLIENTEDGE, $$PANEL_KEYPAD)
	? "hPad: ";guiState.hPad
	WinXAutoSizer_SetSimpleInfo (guiState.hPad, guiState.secondSeries, 0, 140, $$SIZER_SPLITTER)
	WinXSplitter_SetProperties (guiState.secondSeries, guiState.hPad, 40, 140, $$TRUE)
	
	WinXScroll_SetPage (guiState.hPad, $$DIR_HORIZ, 1.0, 0, 10)
	WinXScroll_SetPage (guiState.hPad, $$DIR_VERT, 1.0, 0, 10)
	WinXScroll_SetRange (guiState.hPad, $$DIR_HORIZ, 0, 574)
	WinXScroll_SetRange (guiState.hPad, $$DIR_VERT, 0, 110)
	WinXScroll_Show (guiState.hPad, $$TRUE, $$TRUE)
	BuildKeypad (guiState.hPad)
	
	' The console
	guiState.hCon = WinXNewChildWindow (#hMain, "", $$WS_CLIPSIBLINGS, $$WS_EX_CLIENTEDGE, $$PANEL_CONSOLE)
	WinXSetCursor (guiState.hCon, LoadCursorA (0, $$IDC_IBEAM))
	? "hCon: ";guiState.hCon
	WinXAutoSizer_SetSimpleInfo (guiState.hCon, guiState.secondSeries, 0, 1.0, $$SIZER_SIZERELREST)
	'EnableWindow (hCon, $$TRUE)
	Console_Redraw (guiState.hCon, delta, 0)
	WinXSetWindowColour (guiState.hCon, 0xFFFFFF)
	WinXScroll_SetPage (guiState.hCon, $$DIR_HORIZ, 1.0, 0, 10)
	WinXScroll_SetPage (guiState.hCon, $$DIR_VERT, 1.0, 0, conState.font.height)
	WinXScroll_SetRange (guiState.hCon, $$DIR_HORIZ, 0, 350)
	WinXScroll_SetRange (guiState.hCon, $$DIR_VERT, 0, conState.font.height*3)
	WinXScroll_Show (guiState.hCon, $$TRUE, $$TRUE)

	'remember to register callbacks
	WinXRegOnCommand (#hMain, &onCommand())
	WinXRegOnFocusChange (#hMain, &onMainFocusChange())
	WinXRegOnClose (#hMain, &onClose())
	WinXRegOnClipChange (#hMain, &onClipChange())
	WinXRegOnItem (#hMain, &onLVItem())
	WinXRegOnLabelEdit (#hMain, &onLVLabelEdit())

	WinXRegOnCommand (guiState.hPad, &onCommand())
	WinXRegOnScroll (guiState.hPad, &onScrollPad ())
	WinXRegOnMouseWheel (guiState.hPad, &onMouseWheel ())
	WinXRegOnMouseDown (guiState.hPad, &onMouseDown())

	WinXRegOnMouseWheel (guiState.hCon, &onMouseWheel ())
	WinXRegOnFocusChange (guiState.hCon, &onFocusChange ())
	WinXRegOnScroll (guiState.hCon, &onScrollConsole())
	WinXRegOnChar (guiState.hCon, &onChar())
	WinXRegOnKeyDown (guiState.hCon, &onKeyDown())
	WinXRegOnMouseDown (guiState.hCon, &onMouseDown())
	WinXRegOnMouseMove (guiState.hCon, &onMouseMove())
	WinXRegOnMouseUp (guiState.hCon, &onMouseUp())

	WinXDisplay (#hMain)
	
	RestoreEnvironment ()
	
	RETURN 0
END FUNCTION
'
' #####################
' #####  cleanUp  #####
' #####################
'
'
'
FUNCTION cleanUp ()
	SHARED CONSOLESTATE conState
	SHARED GUISTATE guiState
	
	DeleteObject (guiState.hIcon)
	DeleteObject (guiState.hToolbarBMP)
	DeleteObject (conState.hFont)
END FUNCTION
'
' #######################
' #####  onCommand  #####
' #######################
'
'
'
FUNCTION onCommand (id, code, hWnd)
	SHARED CONSOLESTATE conState
	SHARED GUISTATE guiState
	SHARED currentFileName$
	SHARED currentLine$
	SHARED lastResult$
	
	hCon = GetDlgItem (#hMain, $$PANEL_CONSOLE)
	
	SELECT CASE id
		CASE $$CMD_CLEAR
			IF conState.lines.cItems THEN
				IF guiState.changed THEN
					SELECT CASE WinXDialog_Question (#hMain, "Save history before clearing?", "Question", $$TRUE, 0)
						CASE $$IDYES
							onCommand ($$CMD_SAVE, 0, 0)
							GOSUB ClearHistory
						CASE $$IDNO
							GOSUB ClearHistory
						CASE $$IDCANCEL
					END SELECT
				ELSE
					GOSUB ClearHistory
				END IF
			END IF
		CASE $$CMD_OPEN
			IF guiState.changed THEN
					SELECT CASE WinXDialog_Question (#hMain, "Save history before overwriting?", "Question", $$TRUE, 0)
						CASE $$IDYES
							onCommand ($$CMD_SAVE, 0, 0)
							GOSUB OpenFile
						CASE $$IDNO
							GOSUB OpenFile
						CASE $$IDCANCEL
					END SELECT
			ELSE
				GOSUB OpenFile
			END IF
		CASE $$CMD_SAVE
			IF guiState.changed THEN
				IF currentFileName$ = "" THEN
					currentFileName$ = WinXDialog_SaveFile$ (#hMain, "Save As ...", "Text files (*.txt)\0*.txt\0All Files (*.*)\0*.*\0\0", "", $$TRUE)
				END IF
				IF currentFileName$ THEN
					fh = OPEN (currentFileName$, $$WRNEW)
					hWalk = LinkedList_StartWalk (conState.lines)
					DO WHILE LinkedList_Walk (hWalk, @iData)
						STRING_Get (iData, @line$)
						line$ = line$+"\r\n"
						WRITE[fh], line$
					LOOP
					LinkedList_EndWalk (hWalk)
					CLOSE (fh)
					
					guiState.changed = $$FALSE
					WinXToolbar_EnableButton (guiState.hToolbar, $$CMD_SAVE, $$FALSE)
					EnableMenuItem (guiState.hMainMenu, $$CMD_SAVE, $$MF_BYCOMMAND|$$MF_GRAYED)
					EnableMenuItem (guiState.hMainMenu, $$CMD_COPYLAST, $$MF_BYCOMMAND|$$MF_GRAYED)
					WinXToolbar_EnableButton (guiState.hToolbar, $$CMD_COPYLAST, $$FALSE)
				END IF
			END IF
		CASE $$CMD_SAVEAS
			newFile$ = WinXDialog_SaveFile$ (#hMain, "Save As ...", "Text files (*.txt)\0*.txt\0All Files (*.*)\0*.*\0\0", "", $$TRUE)
			IF newFile$ THEN
				currentFileName$ = newFile$
				onCommand ($$CMD_SAVE, 0, 0)
			END IF
		CASE $$CMD_CONFIG
			ShowConfigDialog ()
		CASE $$CMD_EXIT
			onClose (#hMain)
		CASE $$CMD_CUT
			WinXClip_PutString (MID$(currentLine$, conState.selStartChar+1, conState.selCharCount))
			InsertText ("")
			
			onSelectionChanged ()
			UpdateCaretPos (hCon, $$TRUE)
			Console_Redraw (hCon, 0, 0)
		CASE $$CMD_COPY
			IF conState.selLineCount THEN
				i = conState.selStartLine
				text$ = ""
				hWalk = LinkedList_StartWalk (conState.lines)
				LinkedList_Jump (hWalk, conState.selStartLine)
				cLines = 0
				DO WHILE LinkedList_Walk (hWalk, @iData)
					STRING_Get (iData, @line$)
					
					IF cLines = conState.selLineCount THEN
						IF conState.selLineCount > 1 THEN text$ = text$+"\r\n"+MID$(line$, 1, conState.selCharCount)
						EXIT DO
					END IF
					
					IFZ cLines THEN
						IF conState.selLineCount = 1 THEN
							text$ = text$+"\r\n"+MID$(line$, conState.selStartChar+1, conState.selCharCount)
						ELSE
							text$ = text$+"\r\n"+MID$(line$, conState.selStartChar+1)
						END IF
					ELSE
						IF cLines+1 = conState.selLineCount THEN
							text$ = text$+"\r\n"+MID$(line$, 1, conState.selCharCount)
						ELSE
							text$ = text$+"\r\n"+line$
						END IF
					END IF
					
					INC cLines
				LOOP
				LinkedList_EndWalk (hWalk)
				
				WinXClip_PutString (LCLIP$(text$,2))
			ELSE
				WinXClip_PutString (MID$(currentLine$, conState.selStartChar+1, conState.selCharCount))
			END IF
		CASE $$CMD_COPYLAST
			WinXClip_PutString (lastResult$)
		CASE $$CMD_PASTE
			InsertText (WinXClip_GetString$ ())
			
			UpdateCaretPos (hCon, $$TRUE)
			Console_Redraw (hCon, 0, 0)
		CASE $$CMD_SELECTALL
			conState.selStartChar = 0
			conState.selCharCount = LEN(currentLine$)
			conState.stringPos = conState.selCharCount
			
			UpdateCaretPos (hCon, $$TRUE)
			Console_Redraw (hCon, 0, 0)
		CASE $$CMD_NEWGRAPH
		CASE $$CMD_ALWAYSONTOP
			IF guiState.alwaysOnTop THEN
				SetWindowPos (#hMain, $$HWND_NOTOPMOST, 0, 0, 0, 0, $$SWP_NOMOVE|$$SWP_NOSIZE)
				guiState.alwaysOnTop = $$FALSE
				CheckMenuItem (guiState.hMainMenu, $$CMD_ALWAYSONTOP, $$MF_BYCOMMAND|$$MF_UNCHECKED)
			ELSE
				SetWindowPos (#hMain, $$HWND_TOPMOST, 0, 0, 0, 0, $$SWP_NOMOVE|$$SWP_NOSIZE)
				CheckMenuItem (guiState.hMainMenu, $$CMD_ALWAYSONTOP, $$MF_BYCOMMAND|$$MF_CHECKED)
				guiState.alwaysOnTop = $$TRUE
			END IF
		CASE $$CMD_HELP
		CASE $$CMD_ABOUT
			text$ = _
			"A Better Calculator\n" + _
			"Version 3.00\n" + _
			"Copyright (C) Callum Lowcay 2008\n\n" + _
			"This program is free software; you can redistribute it and/or modify\n" + _
			"it under the terms of the GNU General Public License as published by\n" + _
			"the Free Software Foundation; either version 2 of the License, or\n" + _
			"(at your option) any later version.\n\n" + _
			"This program is distributed in the hope that it will be useful,\n" + _
			"but WITHOUT ANY WARRANTY; without even the implied warranty of\n" + _
			"MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.\nSee the " + _
			"GNU General Public License for more details."
			
			WinXDialog_Message (#hMain, text$, "About A Better Calculator", $$ICON_MAIN, 0)
			
		CASE $$CMD_INSERT
			WinXListView_GetItemText (guiState.hLV, guiState.iContextItem, 1, @text$[])
			InsertText (text$[0])
			
			SetFocus (guiState.hCon)
			UpdateCaretPos (guiState.hCon, $$TRUE)
			Console_Redraw (guiState.hCon, 0, 0)
		CASE $$CMD_DELETE
			WinXListView_GetItemText (guiState.hLV, guiState.iContextItem, 1, @text$[])
			iExpr = calculate_parse ("CLEAR "+text$[0], @errorString$)
			IF iExpr THEN
				calculate_execute (iExpr, 0, @exception, @resultString$)
			END IF
			UpdateSymbolList ()
		CASE $$CMD_DELETEALL
			IF WinXDialog_Question (#hMain, "Really delete all symbols?", "Confirm", $$FALSE, 1) = $$IDYES THEN
				i = 0
				DO WHILE WinXListView_GetItemText (guiState.hLV, i, 1, @text$[])
					iExpr = calculate_parse ("CLEAR "+text$[0], @errorString$)
					IF iExpr THEN
						calculate_execute (iExpr, 0, @exception, @resultString$)
					END IF
					INC i
				LOOP
				
				UpdateSymbolList ()
			END IF
		CASE $$BT_KEYPADITEM+00 : InsertText ("7")		: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+01 : InsertText ("8")		: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+02 : InsertText ("9")		: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+03 : InsertText ("4")		: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+04 : InsertText ("5")		: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+05 : InsertText ("6")		: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+06 : InsertText ("1")		: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+07 : InsertText ("2")		: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+08 : InsertText ("3")		: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+09 : InsertText ("0")		: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+10 : InsertText (".")		: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+11 : InsertText ("e")		: GOSUB CheckCon
			
		CASE $$BT_KEYPADITEM+12 : InsertText ("/")		: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+13 : InsertText (" rt")		: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+14 : InsertText ("!")		: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+15 : InsertText (" per ")	: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+16 : InsertText ("*")		: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+17 : InsertText ("^")		: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+18 : InsertText ("frac ")		: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+19 : InsertText (" com ")	: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+20 : InsertText ("-")		: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+21 : InsertText ("cbr ")	: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+22 : InsertText ("int ")		: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+23 : InsertText ("mod (")	: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+24 : InsertText ("+")		: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+25 : InsertText ("sqr ")	: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+26 : InsertText ("ans")	: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+27 : InsertText ("abs (")	: GOSUB CheckCon
		
		CASE $$BT_KEYPADITEM+28 : InsertText ("(")		: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+29 : InsertText ("[")		: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+30 : InsertText ("<<")		: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+31 : InsertText (")")		: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+32 : InsertText ("]")		: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+33 : InsertText (">>")		: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+34 : InsertText (",")		: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+35 : InsertText (".")		: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+36 : InsertText ("=")		: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+37 : onChar (hCon, '\b')	: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+38 : onChar (hCon, '\n')	: GOSUB CheckCon
			
		CASE $$BT_KEYPADITEM+39	: IF WinXButton_GetCheck (hWnd) THEN guiState.trigPrefix = "A" ELSE guiState.trigPrefix = ""
		CASE $$BT_KEYPADITEM+40	: IF WinXButton_GetCheck (hWnd) THEN guiState.trigSuffix = "h " ELSE guiState.trigSuffix = " "
		CASE $$BT_KEYPADITEM+41 : InsertText ("e")		: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+42 : InsertText (guiState.trigPrefix+"sin"+guiState.trigSuffix)		: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+43 : InsertText (guiState.trigPrefix+"cos"+guiState.trigSuffix)		: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+44 : InsertText ("pi")		: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+45 : InsertText (guiState.trigPrefix+"tan"+guiState.trigSuffix)		: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+46 : InsertText (guiState.trigPrefix+"cot"+guiState.trigSuffix)		: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+47 : InsertText ("exp ")		: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+48 : InsertText (guiState.trigPrefix+"sec"+guiState.trigSuffix)		: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+49 : InsertText (guiState.trigPrefix+"cosec"+guiState.trigSuffix)	: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+50 : InsertText ("ln ")		: GOSUB CheckCon
		
		CASE $$BT_KEYPADITEM+51 : InsertText ("conj ")	: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+52 : InsertText ("re ")		: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+53 : InsertText ("im ")		: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+54 : InsertText ("i")			: GOSUB CheckCon
		
		CASE $$BT_KEYPADITEM+55 : InsertText ("AND ")		: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+56 : InsertText ("OR ")		: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+57 : InsertText ("NOT ")		: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+58 : InsertText ("D")			: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+59 : InsertText ("E")			: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+60 : InsertText ("F")			: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+61 : InsertText ("A")			: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+62 : InsertText ("B")			: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+63 : InsertText ("C")			: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+64 : InsertText ("b")			: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+65 : InsertText ("o")			: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+66 : InsertText ("h")			: GOSUB CheckCon
		
		CASE $$BT_KEYPADITEM+67 : InsertText ("{")		: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+68 : InsertText (":")		: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+69 : InsertText ("=")		: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+70 : InsertText ("}")			: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+71 : InsertText (";")			: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+72 : InsertText (">")			: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+73 : InsertText ("||")			: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+74 : InsertText ("|")			: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+75 : InsertText ("<")			: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+76 : InsertText ("&&")			: GOSUB CheckCon
		CASE $$BT_KEYPADITEM+77 : InsertText ("self (")			: GOSUB CheckCon
	END SELECT
	
	RETURN
	
	SUB ClearHistory
		currentFileName$ = ""
		guiState.changed = $$FALSE
		WinXToolbar_EnableButton (guiState.hToolbar, $$CMD_SAVE, $$FALSE)
		EnableMenuItem (guiState.hMainMenu, $$CMD_SAVE, $$MF_BYCOMMAND|$$MF_GRAYED)
		EnableMenuItem (guiState.hMainMenu, $$CMD_COPYLAST, $$MF_BYCOMMAND|$$MF_GRAYED)
		WinXToolbar_EnableButton (guiState.hToolbar, $$CMD_COPYLAST, $$FALSE)
		
		hWalk = LinkedList_StartWalk (conState.lines)
		DO WHILE LinkedList_Walk (hWalk, @iData)
			STRING_Delete(iData)
		LOOP
		LinkedList_EndWalk (hWalk)
		LinkedList_DeleteAll (@conState.lines)
		
		hWalk = LinkedList_StartWalk (conState.history)
		DO WHILE LinkedList_Walk (hWalk, @iData)
			STRING_Delete(iData)
		LOOP
		LinkedList_EndWalk (hWalk)
		LinkedList_DeleteAll (@conState.history)
		
		UpdateConsoleHeight (hCon)
		UpdateCaretPos (hCon, $$TRUE)
		Console_Redraw (hCon, 0, 0)
		'InvalidateRect (hCon, 0, $$TRUE)
	END SUB
	
	SUB OpenFile
		newFile$ = WinXDialog_OpenFile$ (#hMain, "Open File ...", "Text files (*.txt)\0*.txt\0All Files (*.*)\0*.*\0\0", "", $$FALSE)
		IF newFile$ THEN
			currentLine$ = "include "+newFile$
			onChar (hCon, '\r')
			
			GOSUB ClearHistory
			
			currentFileName$ = newFile$
			
			fh = OPEN (currentFileName$, $$RD)
			DO
				LinkedList_Append (@conState.lines, STRING_New (INFILE$ (fh)))
			LOOP UNTIL EOF (fh)
			CLOSE (fh)
			
			UpdateConsoleHeight (hCon)
			UpdateCaretPos (hCon, $$TRUE)
			Console_Redraw (hCon, 0, 0)
			'InvalidateRect (hCon, 0, $$TRUE)
		END IF
	END SUB
	
	SUB CheckCon
		SetFocus (hCon)
		UpdateCaretPos (hCon, $$TRUE)
		Console_Redraw (hCon, 0, 0)
	END SUB
END FUNCTION
'
' #########################
' #####  BuildKeypad  #####
' #########################
' Construct the keypad pane
FUNCTION BuildKeypad (hPad)
	' The decimal block
	
	base = 0
	WinXAddButton (hPad, "7", 0, $$BT_KEYPADITEM+base+0)
	WinXAddButton (hPad, "8", 0, $$BT_KEYPADITEM+base+1)
	WinXAddButton (hPad, "9", 0, $$BT_KEYPADITEM+base+2)
	WinXAddButton (hPad, "4", 0, $$BT_KEYPADITEM+base+3)
	WinXAddButton (hPad, "5", 0, $$BT_KEYPADITEM+base+4)
	WinXAddButton (hPad, "6", 0, $$BT_KEYPADITEM+base+5)
	WinXAddButton (hPad, "1", 0, $$BT_KEYPADITEM+base+6)
	WinXAddButton (hPad, "2", 0, $$BT_KEYPADITEM+base+7)
	WinXAddButton (hPad, "3", 0, $$BT_KEYPADITEM+base+8)
	WinXAddButton (hPad, "0", 0, $$BT_KEYPADITEM+base+9)
	WinXAddButton (hPad, ".", 0, $$BT_KEYPADITEM+base+10)
	WinXAddButton (hPad, "exp", 0, $$BT_KEYPADITEM+base+11)
	FOR y = 0 TO 3
		FOR x = 0 TO 2
			MoveWindow (GetDlgItem (hPad, $$BT_KEYPADITEM+(y*3)+x+base), 04+(26*x), 04+(26*y), 26, 26, $$TRUE)
		NEXT
	NEXT
	
	' The arithmetic block
	base = 12
	WinXAddTooltip (WinXAddButton (hPad, "/", 0, $$BT_KEYPADITEM+base+0), "Divide")
	WinXAddTooltip (WinXAddButton (hPad, "rt", 0, $$BT_KEYPADITEM+base+1), "xth root of y")
	WinXAddTooltip (WinXAddButton (hPad, "!", 0, $$BT_KEYPADITEM+base+2), "Factorial")
	WinXAddTooltip (WinXAddButton (hPad, "Per", 0, $$BT_KEYPADITEM+base+3), "Permutation")
	WinXAddTooltip (WinXAddButton (hPad, "x", 0, $$BT_KEYPADITEM+base+4), "Multiply")
	WinXAddTooltip (WinXAddButton (hPad, "^", 0, $$BT_KEYPADITEM+base+5), "x to the power y")
	WinXAddTooltip (WinXAddButton (hPad, "frac", 0, $$BT_KEYPADITEM+base+6), "Get the fractional component of x")
	WinXAddTooltip (WinXAddButton (hPad, "Com", 0, $$BT_KEYPADITEM+base+7), "Combination")
	WinXAddTooltip (WinXAddButton (hPad, "-", 0, $$BT_KEYPADITEM+base+8), "Subtraction/Negation")
	WinXAddTooltip (WinXAddButton (hPad, "cbr", 0, $$BT_KEYPADITEM+base+9), "Cube root")
	WinXAddTooltip (WinXAddButton (hPad, "int", 0, $$BT_KEYPADITEM+base+10), "Get the integer component of x")
	WinXAddTooltip (WinXAddButton (hPad, "mod", 0, $$BT_KEYPADITEM+base+11), "Remainder from division (library function)")
	WinXAddTooltip (WinXAddButton (hPad, "+", 0, $$BT_KEYPADITEM+base+12), "Addition")
	WinXAddTooltip (WinXAddButton (hPad, "sqr", 0, $$BT_KEYPADITEM+base+13), "Square root")
	WinXAddTooltip (WinXAddButton (hPad, "ans", 0, $$BT_KEYPADITEM+base+14), "Result of last calculation")
	WinXAddTooltip (WinXAddButton (hPad, "abs", 0, $$BT_KEYPADITEM+base+15), "Absolute value (library function)")
	FOR x = 0 TO 3
		FOR y = 0 TO 3
			MoveWindow (GetDlgItem (hPad, $$BT_KEYPADITEM+(y*4)+x+base), 090+26*x, 04+26*y, 26, 26, $$TRUE)
		NEXT
	NEXT
	
	' The first auxillary block
	base = 28
	WinXAddTooltip (WinXAddButton (hPad, "(", 0, $$BT_KEYPADITEM+base+0), "Open bracket")
	WinXAddTooltip (WinXAddButton (hPad, "[", 0, $$BT_KEYPADITEM+base+1), "Start vector")
	WinXAddTooltip (WinXAddButton (hPad, "<<", 0, $$BT_KEYPADITEM+base+2), "Downshift (divide x by 2 ^ y)")
	WinXAddTooltip (WinXAddButton (hPad, ")", 0, $$BT_KEYPADITEM+base+3), "Close bracket")
	WinXAddTooltip (WinXAddButton (hPad, "]", 0, $$BT_KEYPADITEM+base+4), "End vector")
	WinXAddTooltip (WinXAddButton (hPad, ">>", 0, $$BT_KEYPADITEM+base+5), "Upshift (multiply x by 2 ^ y)")
	WinXAddTooltip (WinXAddButton (hPad, ",", 0, $$BT_KEYPADITEM+base+6), "Comma - used for seperating parameters")
	WinXAddTooltip (WinXAddButton (hPad, ".", 0, $$BT_KEYPADITEM+base+7), "Dot Product")
	WinXAddTooltip (WinXAddButton (hPad, "=", 0, $$BT_KEYPADITEM+base+8), "Assignment, use to define new symbols")
	WinXAddTooltip (WinXAddButton (hPad, "<-", 0, $$BT_KEYPADITEM+base+9), "Backspace")
	WinXAddTooltip (WinXAddButton (hPad, "enter", 0, $$BT_KEYPADITEM+base+10), "Perform calculation")
	FOR x = 0 TO 2
		FOR y = 0 TO 3
			MoveWindow (GetDlgItem (hPad, $$BT_KEYPADITEM+(y*3)+x+base), 200+26*x, 04+26*y, 26, 26, $$TRUE)
		NEXT
	NEXT
	MoveWindow (GetDlgItem (hPad, $$BT_KEYPADITEM+base+10), 200+26, 04+26*3, 52, 26, $$TRUE)
	
	
	' The scientific block
	base = 39
	WinXAddTooltip (WinXAddCheckButton (hPad, "inv", $$TRUE, $$TRUE, $$BT_KEYPADITEM+base+0), "Enable inverse trig")
	WinXAddTooltip (WinXAddCheckButton (hPad, "hyp", $$FALSE, $$TRUE, $$BT_KEYPADITEM+base+1), "Enable hypoerbolic trig")
	WinXAddTooltip (WinXAddButton (hPad, "e", 0, $$BT_KEYPADITEM+base+2), "Euler's number e ~= 2.71")
	WinXAddTooltip (WinXAddButton (hPad, "sin", 0, $$BT_KEYPADITEM+base+3), "Sine")
	WinXAddTooltip (WinXAddButton (hPad, "cos", 0, $$BT_KEYPADITEM+base+4), "Cosine")
	WinXAddTooltip (WinXAddButton (hPad, "pi", 0, $$BT_KEYPADITEM+base+5), "pi ~= 3.14")
	WinXAddTooltip (WinXAddButton (hPad, "tan", 0, $$BT_KEYPADITEM+base+6), "Tangent")
	WinXAddTooltip (WinXAddButton (hPad, "cot", 0, $$BT_KEYPADITEM+base+7), "Cotangent")
	WinXAddTooltip (WinXAddButton (hPad, "exp", 0, $$BT_KEYPADITEM+base+8), "Exponential (e^x)")
	WinXAddTooltip (WinXAddButton (hPad, "sec", 0, $$BT_KEYPADITEM+base+9), "Secant")
	WinXAddTooltip (WinXAddButton (hPad, "csc", 0, $$BT_KEYPADITEM+base+10), "Cosecant")
	WinXAddTooltip (WinXAddButton (hPad, "ln", 0, $$BT_KEYPADITEM+base+11), "Natural logarithm")
	FOR x = 0 TO 2
		FOR y = 0 TO 3
			MoveWindow (GetDlgItem (hPad, $$BT_KEYPADITEM+3*y+x+base), 286+26*x, 04+26*y, 26, 26, $$TRUE)
		NEXT
	NEXT
	
	' The complex block
	base = 51
	WinXAddTooltip (WinXAddButton (hPad, "conj", 0, $$BT_KEYPADITEM+base+0), "Complex conjugation")
	WinXAddTooltip (WinXAddButton (hPad, "re", 0, $$BT_KEYPADITEM+base+1), "Real Component")
	WinXAddTooltip (WinXAddButton (hPad, "im", 0, $$BT_KEYPADITEM+base+2), "Imaginary component")
	WinXAddTooltip (WinXAddButton (hPad, "i", 0, $$BT_KEYPADITEM+base+3), "Imaginary unit")
	FOR y = 0 TO 3
		MoveWindow (GetDlgItem (hPad, $$BT_KEYPADITEM+y+base), 372, 04+26*y, 26, 26, $$TRUE)
	NEXT
	
	' The logical block
	base = 55
	WinXAddTooltip (WinXAddButton (hPad, "and", 0, $$BT_KEYPADITEM+base+0), "Bitwise logical AND")
	WinXAddTooltip (WinXAddButton (hPad, "or", 0, $$BT_KEYPADITEM+base+1), "Bitwise logical OR")
	WinXAddTooltip (WinXAddButton (hPad, "not", 0, $$BT_KEYPADITEM+base+2), "Bitwise logical NOT")
	WinXAddTooltip (WinXAddButton (hPad, "D", 0, $$BT_KEYPADITEM+base+3), "Hex digit D")
	WinXAddTooltip (WinXAddButton (hPad, "E", 0, $$BT_KEYPADITEM+base+4), "Hex digit E")
	WinXAddTooltip (WinXAddButton (hPad, "F", 0, $$BT_KEYPADITEM+base+5), "Hex digit F")
	WinXAddTooltip (WinXAddButton (hPad, "A", 0, $$BT_KEYPADITEM+base+6), "Hex digit A")
	WinXAddTooltip (WinXAddButton (hPad, "B", 0, $$BT_KEYPADITEM+base+7), "Hex digit B")
	WinXAddTooltip (WinXAddButton (hPad, "C", 0, $$BT_KEYPADITEM+base+8), "Hex digit C")
	WinXAddTooltip (WinXAddButton (hPad, "b", 0, $$BT_KEYPADITEM+base+9), "Binary suffix")
	WinXAddTooltip (WinXAddButton (hPad, "o", 0, $$BT_KEYPADITEM+base+10), "Octal suffix")
	WinXAddTooltip (WinXAddButton (hPad, "h", 0, $$BT_KEYPADITEM+base+11), "Hexidecimal suffix")
	FOR x = 0 TO 2
		FOR y = 0 TO 3
			MoveWindow (GetDlgItem (hPad, $$BT_KEYPADITEM+3*y+x+base), 406+26*x, 04+26*y, 26, 26, $$TRUE)
		NEXT
	NEXT
	
	' The function block
	base = 67
	WinXAddTooltip (WinXAddButton (hPad, "{", 0, $$BT_KEYPADITEM+base+0), "Start function")
	WinXAddTooltip (WinXAddButton (hPad, ":", 0, $$BT_KEYPADITEM+base+1), "Expression-condition seperator")
	WinXAddTooltip (WinXAddButton (hPad, "=", 0, $$BT_KEYPADITEM+base+2), "Equality")
	WinXAddTooltip (WinXAddButton (hPad, "}", 0, $$BT_KEYPADITEM+base+3), "End function")
	WinXAddTooltip (WinXAddButton (hPad, ";", 0, $$BT_KEYPADITEM+base+4), "Case seperator")
	WinXAddTooltip (WinXAddButton (hPad, ">", 0, $$BT_KEYPADITEM+base+5), "Greater than")
	WinXAddTooltip (WinXAddButton (hPad, "||", 0, $$BT_KEYPADITEM+base+6), "Logical OR")
	WinXAddTooltip (WinXAddButton (hPad, "|", 0, $$BT_KEYPADITEM+base+7), "Parameter-expression seperator")
	WinXAddTooltip (WinXAddButton (hPad, "<", 0, $$BT_KEYPADITEM+base+8), "Less than")
	WinXAddTooltip (WinXAddButton (hPad, "&&&&", 0, $$BT_KEYPADITEM+base+9), "Logical and")
	WinXAddTooltip (WinXAddButton (hPad, "self", 0, $$BT_KEYPADITEM+base+10), "Recursion")
	FOR x = 0 TO 2
		FOR y = 0 TO 3
			MoveWindow (GetDlgItem (hPad, $$BT_KEYPADITEM+(y*3)+x+base), 492+26*x, 04+26*y, 26, 26, $$TRUE)
		NEXT
	NEXT
	MoveWindow (GetDlgItem (hPad, $$BT_KEYPADITEM+base+10), 492+26, 04+26*3, 52, 26, $$TRUE)
	
	
END FUNCTION

FUNCTION onScrollPad (pos, hWnd, direction)
	RECT rect
	RECT parentRect
	RECT check
	
	STATIC X
	STATIC Y
	
	GetWindowRect (hWnd, &parentRect)
	SELECT CASE direction
		CASE $$DIR_HORIZ
			delta = X-pos
			X = pos
			hWinPosInfo = BeginDeferWindowPos (92)
			FOR i = 0 TO 92
				hBt = GetDlgItem (hWnd, $$BT_KEYPADITEM+i)
				GetWindowRect (hBt, &rect)
				
				check.right = 0
				check.bottom = 0
				AdjustWindowRectEx (&check, GetWindowLongA (hWnd, $$GWL_STYLE), $$FALSE, GetWindowLongA (hWnd, $$GWL_EXSTYLE))
				
				rect.left = rect.left-parentRect.left-check.right
				rect.top = rect.top-parentRect.top-check.bottom
				DeferWindowPos (hWinPosInfo, hBt, 0, rect.left+delta, rect.top, 0, 0, $$SWP_SHOWWINDOW|$$SWP_NOZORDER|$$SWP_NOSIZE)
			NEXT
			EndDeferWindowPos (hWinPosInfo)
		CASE $$DIR_VERT
			delta = Y-pos
			Y = pos
			hWinPosInfo = BeginDeferWindowPos (92)
			FOR i = 0 TO 92
				hBt = GetDlgItem (hWnd, $$BT_KEYPADITEM+i)
				GetWindowRect (hBt, &rect)
				
				check.right = 0
				check.bottom = 0
				AdjustWindowRectEx (&check, GetWindowLongA (hWnd, $$GWL_STYLE), $$FALSE, GetWindowLongA (hWnd, $$GWL_EXSTYLE))
				
				rect.left = rect.left-parentRect.left-check.right
				rect.top = rect.top-parentRect.top-check.bottom
				DeferWindowPos (hWinPosInfo, hBt, 0, rect.left, rect.top+delta, 0, 0, $$SWP_SHOWWINDOW|$$SWP_NOZORDER|$$SWP_NOSIZE)
			NEXT
			EndDeferWindowPos (hWinPosInfo)
	END SELECT
END FUNCTION

FUNCTION onScrollConsole (pos, hWnd, direction)
	SHARED CONSOLESTATE conState
	
	GetWindowRect (hWnd, &parentRect)
	SELECT CASE direction
		CASE $$DIR_HORIZ
			delta = conState.scrollX-pos
			conState.scrollX = pos
			IF delta THEN Console_Redraw (hWnd, delta, 0)
			UpdateCaretPos (hWnd, $$FALSE)
		CASE $$DIR_VERT
			delta = conState.scrollY-pos
			conState.scrollY = pos
			IF delta THEN Console_Redraw (hWnd, 0, delta)
			UpdateCaretPos (hWnd, $$FALSE)
	END SELECT
END FUNCTION

FUNCTION onMouseWheel (hWnd, delta, x, y)
	SHARED GUISTATE guiState
	STATIC deltaSoFar
	
	'delta accumalates over mouse wheel events
	deltaSoFar = deltaSoFar + delta
	
	'scroll one line for every 120 deltas
	IF deltaSoFar > 0 THEN
		DO WHILE deltaSoFar >= 120
			deltaSoFar = deltaSoFar - 120
			IF hWnd = guiState.hPad THEN WinXScroll_Scroll (hWnd, $$DIR_HORIZ, $$UNIT_LINE, -1) ELSE WinXScroll_Scroll (hWnd, $$DIR_VERT, $$UNIT_LINE, -1)
		LOOP
	ELSE
		DO WHILE deltaSoFar <= 120
			deltaSoFar = deltaSoFar + 120
			IF hWnd = guiState.hPad THEN WinXScroll_Scroll (hWnd, $$DIR_HORIZ, $$UNIT_LINE, +1) ELSE WinXScroll_Scroll (hWnd, $$DIR_VERT, $$UNIT_LINE, +1)
		LOOP
	END IF
END FUNCTION
'
' ############################
' #####  Console_Redraw  #####
' ############################
' hCon = the handle to the console
FUNCTION Console_Redraw (hCon, deltaX, deltaY)
	SHARED CONSOLESTATE conState
	SHARED currentLine$
	
	STATIC oldSelLine
	STATIC oldSelLineCount
	STATIC oldSelChar
	STATIC oldSelCharCount
	RECT rect
	WinXClear (hCon)
	
	y = 0
	inSelection = $$FALSE
	line = 0
	hWalk = LinkedList_StartWalk (conState.lines)
	DO WHILE LinkedList_Walk (hWalk, @iData)
		STRING_Get (iData, @stri$)
		iSel = 0
		iTail = 0
		
		IF inSelection THEN
			IF line = conState.selStartLine+conState.selLineCount-1 THEN
				strSel$ = MID$(stri$, 1, conState.selCharCount)
				strAfterSel$ = MID$(stri$, conState.selCharCount+1)
				
				IF strSel$ THEN
					XstReplace (@strSel$, "\t", "  ", 0)
					WinXDrawText (hCon, conState.hFont, strSel$, 3-conState.scrollX, y-conState.scrollY, GetSysColor ($$COLOR_HIGHLIGHT), GetSysColor ($$COLOR_HIGHLIGHTTEXT))
				END IF
				IF strAfterSel$ THEN
					XstReplace (@strAfterSel$, "\t", "  ", 0)
					iSel = WinXDraw_GetTextWidth (conState.hFont, strSel$, -1)+3-conState.scrollX
					WinXDrawText (hCon, conState.hFont, strAfterSel$, iSel, y-conState.scrollY, conState.backCol, conState.forCol)
				END IF
				
				inSelection = $$FALSE
			ELSE
				XstReplace (@stri$, "\t", "  ", 0)
				WinXDrawText (hCon, conState.hFont, stri$, 3-conState.scrollX, y-conState.scrollY, GetSysColor ($$COLOR_HIGHLIGHT), GetSysColor ($$COLOR_HIGHLIGHTTEXT))
			END IF
		ELSE
			' Start the selection
			IF conState.selLineCount && line = conState.selStartLine THEN
				strBeforeSel$ = MID$(stri$, 1, conState.selStartChar)
				IF conState.selLineCount = 1 THEN
					strSel$ = MID$(stri$, conState.selStartChar+1, conState.selCharCount)
					strAfterSel$ = MID$(stri$, conState.selStartChar+conState.selCharCount+1)
				ELSE
					strSel$ = MID$(stri$, conState.selStartChar+1)
				END IF
				
				IF strBeforeSel$ THEN
					XstReplace (@strBeforeSel$, "\t", "  ", 0)
					WinXDrawText (hCon, conState.hFont, strBeforeSel$, 3-conState.scrollX, y-conState.scrollY, conState.backCol, conState.forCol)
				END IF
				iSel = WinXDraw_GetTextWidth (conState.hFont, strBeforeSel$, -1)+3-conState.scrollX
				inSelection = $$TRUE
				IF strSel$ THEN
					XstReplace (@strSel$, "\t", "  ", 0)
					WinXDrawText (hCon, conState.hFont, strSel$, iSel, y-conState.scrollY, GetSysColor ($$COLOR_HIGHLIGHT), GetSysColor ($$COLOR_HIGHLIGHTTEXT))
				END IF
				IF strAfterSel$ THEN
					inSelection = $$FALSE
					XstReplace (@strAfterSel$, "\t", "  ", 0)
					iTail = iSel + WinXDraw_GetTextWidth (conState.hFont, strSel$, -1)
					WinXDrawText (hCon, conState.hFont, strAfterSel$, iTail, y-conState.scrollY, conState.backCol, conState.forCol)
				END IF
				
				IF conState.selLineCount = 1 THEN inSelection = $$FALSE 
			ELSE
				XstReplace (@stri$, "\t", "  ", 0)
				WinXDrawText (hCon, conState.hFont, stri$, 3-conState.scrollX, y-conState.scrollY, conState.backCol, conState.forCol)
			END IF
		END IF
		
		y = y+conState.font.height
		INC line
	LOOP
	LinkedList_EndWalk (hWalk)
	
	IF conState.selCharCount && conState.selLineCount = 0 THEN
		strBeforeSel$ = MID$(currentLine$, 1, conState.selStartChar)
		strSel$ = MID$(currentLine$, conState.selStartChar+1, conState.selCharCount)
		strAfterSel$ = MID$(currentLine$, conState.selStartChar+conState.selCharCount+1)
		XstReplace (@strBeforeSel$, "\t", "  ", 0)
		XstReplace (@strSel$, "\t", "  ", 0)
		
		iSel = WinXDraw_GetTextWidth (conState.hFont, "Enter Expression: "+strBeforeSel$, -1)+3-conState.scrollX
		
		IF strAfterSel$ THEN
			XstReplace (@strAfterSel$, "\t", "  ", 0)
			iTail = iSel + WinXDraw_GetTextWidth (conState.hFont, strSel$, -1)
		END IF
	ELSE
		strBeforeSel$ = currentLine$
		XstReplace (@strBeforeSel$, "\t", "  ", 0)
	END IF
	
	WinXDrawText (hCon, conState.hFont, "Enter Expression: "+strBeforeSel$, 3-conState.scrollX, y-conState.scrollY, conState.backCol, conState.forCol)
	SELECT CASE ALL TRUE
		CASE iSel
			WinXDrawText (hCon, conState.hFont, strSel$, iSel, y-conState.scrollY, GetSysColor ($$COLOR_HIGHLIGHT), GetSysColor ($$COLOR_HIGHLIGHTTEXT))
		CASE iTail
			WinXDrawText (hCon, conState.hFont, strAfterSel$, iTail, y-conState.scrollY, conState.backCol, conState.forCol)
	END SELECT
	
	
	
	
	IF deltaX || deltaY THEN
		WinXScroll_Update (hCon, deltaX, deltaY)
	ELSE
		WinXUpdate (hCon)
		'GetClientRect (hCon, &rect)
		'rect.top = y-conState.scrollY
		'rect.bottom = rect.top+conState.font.height
		'InvalidateRect (hCon, &rect, $$TRUE)
	END IF
END FUNCTION

FUNCTION onFocusChange (hWnd, hasFocus)
	SHARED CONSOLESTATE conState
	
	IF hasFocus THEN
		CreateCaret (hWnd, 0, 1, conState.font.height)
		ShowCaret (hWnd)
		
		UpdateCaretPos (hWnd, $$FALSE)
	ELSE
		HideCaret (hWnd)
		DestroyCaret ()
	END IF
END FUNCTION

FUNCTION onChar (hWnd, char)
	SHARED CONSOLESTATE conState
	SHARED GUISTATE guiState
	SHARED currentLine$
	SHARED lastResult$
	
	WinXScroll_Scroll (hWnd, $$DIR_VERT, $$UNIT_END, +1)
	SELECT CASE char
		CASE '\b'
			IF (conState.selCharCount=0)||(conState.selLineCount!=0)
				IF conState.stringPos > 0 THEN
					currentLine$ = MID$(currentLine$, 1, conState.stringPos-1)+MID$(currentLine$, conState.stringPos+1)
					DEC conState.stringPos
				END IF
			ELSE
				currentLine$ = MID$(currentLine$, 1, conState.selStartChar)+MID$(currentLine$, conState.selStartChar+conState.selCharCount+1)
				conState.stringPos = conState.selStartChar
			END IF
			
			RemoveSelection ()
		CASE '\r', '\n'
			IF (conState.selCharCount=0)||(conState.selLineCount!=0)
				' Process the command
				guiState.changed = $$TRUE
				WinXToolbar_EnableButton (guiState.hToolbar, $$CMD_SAVE, $$TRUE)
				EnableMenuItem (guiState.hMainMenu, $$CMD_SAVE, $$MF_BYCOMMAND|$$MF_ENABLED)
				EnableMenuItem (guiState.hMainMenu, $$CMD_COPYLAST, $$MF_BYCOMMAND|$$MF_ENABLED)
				WinXToolbar_EnableButton (guiState.hToolbar, $$CMD_COPYLAST, $$TRUE)
				
				LinkedList_Insert (@conState.history, 0, STRING_New(currentLine$))
				conState.historyPos = -1
				
				LinkedList_Append (@conState.lines, STRING_New (currentLine$))
				IF UCASE$(TRIM$(currentLine$))="SET DEBUG=ON" && guiState.debug=$$FALSE THEN
					'XioShowConsole ()
					'SetFocus (#hMain)
					guiState.debug = $$TRUE
				END IF
				IF UCASE$(TRIM$(currentLine$))="SET DEBUG=OFF" && guiState.debug=$$TRUE THEN
					'XioHideConsole ()
					guiState.debug=$$FALSE
				END IF
				
				iExpr = calculate_parse (currentLine$, @errorString$)
				IFZ iExpr THEN
					LinkedList_Append (@conState.lines, STRING_New ("# "+errorString$))
					UpdateConsoleWidth (hWnd, WinXDraw_GetTextWidth (conState.hFont, errorString$, -1), $$FALSE)
				ELSE
					calculate_execute (iExpr, 0, @exception, @resultString$)
					
					SELECT CASE exception
						CASE $$EXCEPTION_UNDEFINED
							lastResult$ = "Undefined"
							LinkedList_Append (@conState.lines, STRING_New ("# Undefined"))
						CASE ELSE
							lastResult$ = resultString$
							LinkedList_Append (@conState.lines, STRING_New ("# "+resultString$))
							UpdateConsoleWidth (hWnd, WinXDraw_GetTextWidth (conState.hFont, resultString$, -1), $$FALSE)
					END SELECT
					
					calculate_clearExpression (iExpr)
				END IF
				LinkedList_Append (@conState.lines, STRING_New (""))
				
				UpdateSymbolList ()
				
				currentLine$ = ""
				conState.stringPos = 0
				conState.selLineCount = 0
				Console_Redraw (hWnd, 0, 0)
				'InvalidateRect (hWnd, 0, $$TRUE)
			ELSE
				RemoveSelection ()
			END IF
			
			UpdateConsoleHeight (hWnd)
			WinXScroll_Scroll (hWnd, $$DIR_HORIZ, $$UNIT_END, -1)
			Console_Redraw (hWnd, 0, 0)
			'InvalidateRect (hWnd, 0, $$TRUE)
			
			UpdateStatus ()
		CASE ELSE
			InsertText (CHR$(char))
	END SELECT
	
	onSelectionChanged ()
	UpdateCaretPos (hWnd, $$TRUE)
	Console_Redraw (hWnd, 0, 0)
END FUNCTION

FUNCTION onKeyDown (hWnd, key)
	SHARED CONSOLESTATE conState
	SHARED currentLine$
	
	$NUM		= 0
	$ALPHA	= 1
	$SYM		= 2
	$SPACE	= 3
	
	SELECT CASE key
		CASE $$VK_LEFT
			oldPos = conState.stringPos
			IF conState.stringPos > 0 THEN
				IF WinXIsKeyDown ($$VK_CONTROL) THEN
					DEC conState.stringPos
					
					SELECT CASE TRUE
						CASE isNum (currentLine${conState.stringPos})
							state = $NUM
						CASE isAlpha (currentLine${conState.stringPos})
							state = $ALPHA
						CASE isWhitespace (currentLine${conState.stringPos})
							state = $SPACE
						CASE ELSE
							state = $SYM
					END SELECT
					
					DO
						SELECT CASE state
							CASE $NUM
								IF !isNum (currentLine${conState.stringPos}) THEN EXIT DO
							CASE $ALPHA
								IF !isAlpha (currentLine${conState.stringPos}) THEN EXIT DO
							CASE $SYM
								IF isNum (currentLine${conState.stringPos})||isAlpha (currentLine${conState.stringPos})||isWhitespace (currentLine${conState.stringPos}) THEN EXIT DO
							CASE $SPACE
								IF !isWhitespace (currentLine${conState.stringPos})
									SELECT CASE TRUE
										CASE isNum (currentLine${conState.stringPos})
											state = $NUM
										CASE isAlpha (currentLine${conState.stringPos})
											state = $ALPHA
										CASE ELSE
											state = $SYM
									END SELECT
									INC conState.stringPos
								END IF
						END SELECT
						DEC conState.stringPos
					LOOP WHILE conState.stringPos >= 0
					INC conState.stringPos
					
				ELSE
					DEC conState.stringPos
				END IF
				
				IF WinXIsKeyDown ($$VK_SHIFT) && oldPos != conState.stringPos THEN
					IFZ conState.selCharCount THEN
						conState.selStartChar = conState.stringPos
						conState.selCharCount = oldPos-conState.stringPos
					ELSE
						IF conState.selStartChar = oldPos THEN
							conState.selCharCount = conState.selCharCount+oldPos-conState.stringPos
							conState.selStartChar = conState.stringPos
						ELSE
							conState.selCharCount = conState.selCharCount-oldPos+conState.stringPos
							IF conState.selCharCount < 0 THEN
								conState.selStartChar = conState.selStartChar+conState.selCharCount
								conState.selCharCount = -conState.selCharCount
							END IF
						END IF
					END IF
				ELSE
					RemoveSelection ()
				END IF
				
				onSelectionChanged ()
				Console_Redraw (hWnd, 0, 0)
			END IF
			
		CASE $$VK_RIGHT
			oldPos = conState.stringPos
			
			IF conState.stringPos < LEN(currentLine$) THEN
				IF WinXIsKeyDown ($$VK_CONTROL) THEN
					IF conState.stringPos < UBOUND(currentLine$) THEN
						SELECT CASE TRUE
							CASE isNum (currentLine${conState.stringPos})
								state = $NUM
							CASE isAlpha (currentLine${conState.stringPos})
								state = $ALPHA
							CASE isWhitespace (currentLine${conState.stringPos})
								state = $SPACE
							CASE ELSE
								state = $SYM
						END SELECT
						DO
							IF isWhitespace (currentLine${conState.stringPos}) THEN
								state = $SPACE
							ELSE
								SELECT CASE state
									CASE $NUM
										IF !isNum (currentLine${conState.stringPos}) THEN EXIT DO
									CASE $ALPHA
										IF !isAlphaNum (currentLine${conState.stringPos}) THEN EXIT DO
									CASE $SYM
										IF isNum (currentLine${conState.stringPos})||isAlphaNum (currentLine${conState.stringPos}) THEN EXIT DO
									CASE $SPACE
										IF !isWhitespace (currentLine${conState.stringPos}) THEN EXIT DO
								END SELECT
							END IF
							INC conState.stringPos
						LOOP WHILE conState.stringPos < UBOUND (currentLine$)
					ELSE
						INC conState.stringPos
					END IF
				ELSE
					INC conState.stringPos
				END IF
				
				IF WinXIsKeyDown ($$VK_SHIFT) && oldPos != conState.stringPos THEN
					IFZ conState.selCharCount THEN
						conState.selStartChar = oldPos
						conState.selCharCount = conState.selCharCount-oldPos+conState.stringPos
					ELSE
						IF conState.selStartChar = oldPos THEN
							conState.selStartChar = conState.selStartChar-oldPos+conState.stringPos
							conState.selCharCount = conState.selCharCount+oldPos-conState.stringPos
							IF conState.selCharCount < 0 THEN
								conState.selStartChar = conState.selStartChar+conState.selCharCount
								conState.selCharCount = -conState.selCharCount
							END IF
						ELSE
							conState.selCharCount = conState.selCharCount-oldPos+conState.stringPos
						END IF
					END IF
				ELSE
					RemoveSelection ()
				END IF
				
				onSelectionChanged ()
				Console_Redraw (hWnd, 0, 0)
			END IF
			
		CASE $$VK_UP
			IF conState.historyPos < conState.history.cItems-1 THEN
				INC conState.historyPos
				LinkedList_GetItem (conState.history, conState.historyPos, @iData)
				STRING_Get (iData, @currentLine$)
				conState.stringPos = LEN(currentLine$)
			END IF
			RemoveSelection ()
			
			onSelectionChanged ()
			Console_Redraw (hWnd, 0, 0)
		CASE $$VK_DOWN
			IF conState.historyPos > 0 THEN
				DEC conState.historyPos
				IF conState.historyPos < 0 THEN conState.historyPos = 0
				LinkedList_GetItem (conState.history, conState.historyPos, @iData)
				STRING_Get (iData, @currentLine$)
				conState.stringPos = LEN(currentLine$)
			END IF
			RemoveSelection ()
			
			onSelectionChanged ()
			Console_Redraw (hWnd, 0, 0)
		CASE $$VK_F3
			LinkedList_GetItem (conState.history, 0, @iData)
			STRING_Get (iData, @currentLine$)
			conState.stringPos = LEN(currentLine$)
			conState.historyPos = 0
			RemoveSelection ()
			
			onSelectionChanged ()
			Console_Redraw (hWnd, 0, 0)
		CASE $$VK_DELETE
			IFZ conState.selCharCount THEN
				currentLine$ = MID$(currentLine$, 1, conState.stringPos)+MID$(currentLine$, conState.stringPos+2)
			ELSE
				currentLine$ = MID$(currentLine$, 1, conState.selStartChar)+MID$(currentLine$, conState.selStartChar+conState.selCharCount+1)
				conState.stringPos = conState.selStartChar
				RemoveSelection ()
			END IF
			
			onSelectionChanged ()
			Console_Redraw (hWnd, 0, 0)
		CASE $$VK_HOME
			WinXScroll_Scroll (hWnd, $$DIR_HORIZ, $$UNIT_END, -1)
			IF WinXIsKeyDown ($$VK_SHIFT) && conState.stringPos > 0 THEN
				conState.selCharCount = conState.stringPos-conState.selCharCount
				conState.selStartChar = 0
			ELSE
				RemoveSelection ()
			END IF
			
			onSelectionChanged ()
			Console_Redraw (hWnd, 0, 0)
			
			conState.stringPos = 0
		CASE $$VK_END
			IF WinXIsKeyDown ($$VK_SHIFT) && conState.stringPos < LEN(currentLine$) THEN
				IFZ conState.selCharCount THEN
					conState.selStartChar = conState.stringPos
				ELSE
					conState.selStartChar = conState.selStartChar+conState.selCharCount
				END IF
				conState.selCharCount = LEN(currentLine$)-conState.selStartChar
			ELSE
				RemoveSelection ()
			END IF
			
			onSelectionChanged ()
			Console_Redraw (hWnd, 0, 0)
			
			conState.stringPos = LEN(currentLine$)
	END SELECT
	
	UpdateCaretPos (hWnd, $$TRUE)
END FUNCTION

FUNCTION isNum (char)
	IF (char >= '0' && char <= '9') THEN RETURN $$TRUE ELSE RETURN $$FALSE
END FUNCTION
FUNCTION isHexit (char)
	IF isNum (char) || (char >= 'a' && char <= 'f') || (char >= 'A' && char <='F') THEN RETURN $$TRUE ELSE RETURN $$FALSE
END FUNCTION
FUNCTION isAlpha (char)
	IF (char >= 'A' && char <= 'Z')||(char >= 'a' && char <= 'z')||(char = '_') THEN RETURN $$TRUE ELSE RETURN $$FALSE
END FUNCTION
FUNCTION isAlphaNum (char)
	IF isNum(char)||isAlpha(char) THEN RETURN $$TRUE ELSE RETURN $$FALSE
END FUNCTION
FUNCTION isWhitespace (char)
	IF (char = ' ')||(char = '\t')||(char = '\v')||(char = '\f')||(char = '\r')||(char = '\n') THEN RETURN $$TRUE ELSE RETURN $$FALSE
END FUNCTION
'
' ############################
' #####  UpdateCaretPos  #####
' ############################
'
'
'
FUNCTION UpdateCaretPos (hWnd, checkCaretPos)
	SHARED CONSOLESTATE conState
	SHARED currentLine$
	
	RECT rect
	GetClientRect (hWnd, &rect)
	
	stri$ = MID$(currentLine$, 1, conState.stringPos)
	IF stri$ THEN cTabs = XstReplace (@stri$, "\t", "  ", 0)
	stri$ = stri$ + MID$(currentLine$, conState.stringPos+cTabs+1)
	XstReplace (@stri$, "\t", "  ", 0)
	
	partialSize = conState.promptWidth+WinXDraw_GetTextWidth (conState.hFont, MID$(stri$, 1, conState.stringPos+cTabs), -1)
	fullSize = partialSize+WinXDraw_GetTextWidth (conState.hFont, MID$(stri$, conState.stringPos+cTabs+1), -1)
	UpdateConsoleWidth (hWnd, fullSize, $$TRUE)

	IF checkCaretPos THEN
		IF partialSize-conState.scrollX+3 < 0 THEN
			WinXScroll_Scroll (hWnd, $$DIR_HORIZ, $$UNIT_PAGE, -1)
		ELSE
			IF partialSize-conState.scrollX+3 > rect.right THEN WinXScroll_Scroll (hWnd, $$DIR_HORIZ, $$UNIT_PAGE, +1)
		END IF
		IF conState.lines.cItems*conState.font.height-conState.scrollY > rect.bottom THEN
			WinXScroll_Scroll (hWnd, $$DIR_VERT, $$UNIT_END, +1)
		END IF
	END IF

	SetCaretPos (partialSize-conState.scrollX+3, conState.lines.cItems*conState.font.height-conState.scrollY)
END FUNCTION
'
' ################################
' #####  UpdateConsoleWidth  #####
' ################################
'
'
'
FUNCTION UpdateConsoleWidth (hWnd, newWidth, scrollRight)
	SHARED CONSOLESTATE conState
	SHARED GUISTATE guiState
	
	IF newWidth > conState.maxWidth THEN
		conState.maxWidth = newWidth+100
		WinXScroll_SetRange (guiState.hCon, $$DIR_HORIZ, 0, conState.maxWidth)
		WinXScroll_SetPage (guiState.hCon, $$DIR_HORIZ, 1.0, 0, 10)
		
		IF scrollRight THEN WinXScroll_Scroll (guiState.hCon, $$DIR_HORIZ, $$UNIT_END, +1)
	END IF
END FUNCTION
'
' #################################
' #####  UpdateConsoleHeight  #####
' #################################
'
'
'
FUNCTION UpdateConsoleHeight (hWnd)
	SHARED CONSOLESTATE conState
	
	WinXScroll_SetRange (hWnd, $$DIR_VERT, 0, (conState.lines.cItems+1)*conState.font.height)
	WinXScroll_SetPage (hWnd, $$DIR_VERT, 1.0, 0, conState.font.height)
	WinXScroll_Scroll (hWnd, $$DIR_VERT, $$UNIT_END, +1)
	
END FUNCTION
'
' ##############################
' #####  UpdateSymbolList  #####
' ##############################
'
'
'
FUNCTION UpdateSymbolList ()
	hLV = GetDlgItem (#hMain, $$LV_SYMBOLS)

	' Parse up the output
	Symbols$ = calculate_getSymbols$ ()
	XstParseStringToStringArray (Symbols$, "\n", @Symbol$[])
	Symbols$ = ""
	DIM name$[UBOUND(Symbol$[])]
	DIM value$[UBOUND(Symbol$[])]
	FOR i = 0 TO UBOUND(Symbol$[])
		name$[i] = TRIM$(XstParse$ (Symbol$[i], "=", 1))
		value$[i] = TRIM$(XstParse$ (Symbol$[i], "=", 2))
	NEXT
	DIM Symbol$[]
	
	i = 0
	DO WHILE WinXListView_GetItemText (hLV, i, 1, @text$[])
		keep = $$FALSE
		
		FOR j = 0 TO UBOUND(name$[])
			IF UCASE$(text$[0]) = UCASE$(name$[j]) THEN
				WinXListView_SetItemText (hLV, i, 1, value$[j])
				name$[j] = ""
				keep = $$TRUE
			END IF
		NEXT
		
		IFF keep THEN
			WinXListView_DeleteItem (hLV, i)
		ELSE
			INC i
		END IF
	LOOP
	
	FOR j = 0 TO UBOUND(name$[])
		IF name$[j] THEN
			WinXListView_AddItem (hLV, 0, LCASE$(name$[j])+"\0"+value$[j], -1)
		END IF
	NEXT
	
	WinXListView_Sort (hLV, 0, $$FALSE)
END FUNCTION

FUNCTION onMainFocusChange (hWnd, hasFocus)
	
	IF hasFocus && hWnd = #hMain THEN
		SetFocus (GetDlgItem (#hMain, $$PANEL_CONSOLE))
	END IF
END FUNCTION
'
' ########################
' #####  InsertText  #####
' ########################
' Insert text into the current line
'
'
FUNCTION InsertText (text$)
	SHARED CONSOLESTATE conState
	SHARED currentLine$
	
	IF (conState.selCharCount=0)||(conState.selLineCount!=0)
		IF conState.selLineCount THEN RemoveSelection ()
		currentLine$ = MID$(currentLine$, 1, conState.stringPos)+text$+MID$(currentLine$, conState.stringPos+1)
		conState.stringPos = conState.stringPos + LEN(text$)
		conState.selLineCount = 0
	ELSE
		currentLine$ = MID$(currentLine$, 1, conState.selStartChar)+text$+MID$(currentLine$, conState.selStartChar+conState.selCharCount+1)
		conState.stringPos = conState.selStartChar + LEN(text$)
		RemoveSelection ()
	END IF
END FUNCTION

FUNCTION onClose (hWnd)
	SHARED GUISTATE guiState
	
	SELECT CASE hWnd
		CASE #hMain
			IF guiState.changed THEN 
				SELECT CASE WinXDialog_Question (#hMain, "Would you like to save before quitting?", "Question", $$TRUE, 0)
					CASE $$IDYES
						'save
						onCommand ($$CMD_SAVE, 0, 0)
						SaveEnvironment ()
						DestroyWindow (hWnd)
						PostQuitMessage (0)
					CASE $$IDNO
						SaveEnvironment ()
						DestroyWindow (hWnd)
						PostQuitMessage (0)
					CASE $$IDCANCEL
				END SELECT
			ELSE
				SaveEnvironment ()
				DestroyWindow (hWnd)
				PostQuitMessage (0)
			END IF
	END SELECT
END FUNCTION
'
' ##############################
' #####  ShowConfigDialog  #####
' ##############################
' Creates and displays the config dialog box
FUNCTION ShowConfigDialog ()
	SHARED CONFIGSTATE configState
	SHARED CONSOLESTATE conState
	SHARED GUISTATE guiState
	
	IF configState.dialogVisible THEN RETURN
	configState.dialogVisible = $$TRUE
	
	configState.hDlg = WinXNewWindow (#hMain, "Configure A Better Calculator", -1, -1, 236, 216, $$XWSS_POPUP, 0, guiState.hIcon, 0)
	WinXRegOnClose (configState.hDlg, &onCloseConfig())
	WinXRegOnCommand (configState.hDlg, &onCommandConfig())
	
	WinXEnableDialogInterface (configState.hDlg, $$TRUE)
	
	MoveWindow(WinXAddGroupBox (configState.hDlg, "Angle Mode", 0), 4, 4, 80, 92, $$TRUE)
	MoveWindow(WinXAddRadioButton (configState.hDlg, "Radians", $$TRUE, $$FALSE, $$CONFIG_RB_RAD), 10, 18, 60, 22, $$TRUE)
	MoveWindow(WinXAddRadioButton (configState.hDlg, "Degrees", $$FALSE, $$FALSE, $$CONFIG_RB_DEG), 10, 42, 60, 22, $$TRUE)
	MoveWindow(WinXAddRadioButton (configState.hDlg, "Grads", $$FALSE, $$FALSE, $$CONFIG_RB_GRAD), 10, 66, 60, 22, $$TRUE)
	
	MoveWindow(WinXAddGroupBox (configState.hDlg, "Rounding", 0), 88, 4, 140, 92, $$TRUE)
	MoveWindow(WinXAddRadioButton (configState.hDlg, "None", $$TRUE, $$FALSE, $$CONFIG_RB_NONE), 94, 18, 64, 22, $$TRUE)
	MoveWindow(WinXAddRadioButton (configState.hDlg, "Fixed", $$FALSE, $$FALSE, $$CONFIG_RB_FIX), 94, 42, 64, 22, $$TRUE)
	MoveWindow(WinXAddRadioButton (configState.hDlg, "Scientific", $$FALSE, $$FALSE, $$CONFIG_RB_SCI), 94, 66, 64, 22, $$TRUE)
	MoveWindow(WinXAddEdit (configState.hDlg, "3", $$ES_LEFT|$$ES_AUTOHSCROLL|$$ES_NUMBER, $$CONFIG_EB_FIX), 158, 42, 64, 22, $$TRUE)
	MoveWindow(WinXAddEdit (configState.hDlg, "3", $$ES_LEFT|$$ES_AUTOHSCROLL|$$ES_NUMBER, $$CONFIG_EB_SCI), 158, 66, 64, 22, $$TRUE)
	
	MoveWindow(WinXAddGroupBox (configState.hDlg, "Output Mode", 0), 4, 100, 100, 110, $$TRUE)
	MoveWindow(WinXAddRadioButton (configState.hDlg, "Binary", $$TRUE, $$FALSE, $$CONFIG_RB_BIN), 10, 114, 80, 22, $$TRUE)
	MoveWindow(WinXAddRadioButton (configState.hDlg, "Octal", $$FALSE, $$FALSE, $$CONFIG_RB_OCT), 10, 138, 80, 22, $$TRUE)
	MoveWindow(WinXAddRadioButton (configState.hDlg, "Decimal", $$FALSE, $$FALSE, $$CONFIG_RB_DEC), 10, 162, 80, 22, $$TRUE)	
	MoveWindow(WinXAddRadioButton (configState.hDlg, "Hexadecimal", $$FALSE, $$FALSE, $$CONFIG_RB_HEX), 10, 186, 80, 22, $$TRUE)
	
	MoveWindow(WinXAddStatic (configState.hDlg, "Precision (Bits)", 0, $$SS_LEFT|$$SS_CENTERIMAGE, 0), 108, 102, 80, 22, $$TRUE)
	MoveWindow(WinXAddEdit (configState.hDlg, "256", $$ES_LEFT|$$ES_AUTOHSCROLL|$$ES_NUMBER, $$CONFIG_EB_BITS), 188, 102, 40, 22, $$TRUE)
	
	MoveWindow (WinXAddButton (configState.hDlg, "Console Font", 0, $$CONFIG_BT_FONT), 108, 132, 120, 22, $$TRUE)
	MoveWindow (WinXAddButton (configState.hDlg, "Console Background", 0, $$CONFIG_BT_COL), 108, 160, 120, 22, $$TRUE)
	
	MoveWindow (WinXAddButton (configState.hDlg, "OK", 0, $$IDOK), 108, 188, 50, 22, $$TRUE)
	WinXSetStyle (GetDlgItem (configState.hDlg, $$IDOK), $$BS_DEFPUSHBUTTON, 0, 0, 0)
	MoveWindow (WinXAddButton (configState.hDlg, "Cancel", 0, $$IDCANCEL), 168, 188, 60, 22, $$TRUE)
	
	configState.precision = calculate_getPrecision ()
	configState.angleMode = calculate_getAngle ()
	configState.outputMode = calculate_getOutMode ()
	configState.rounding = calculate_getRounding (@param)
	configState.roundParam = param
	
	configState.newFont = conState.font
	configState.forCol = conState.forCol
	configState.backCol = conState.backCol
	
	WinXSetText (GetDlgItem (configState.hDlg, $$CONFIG_EB_BITS), STRING$(configState.precision))
	SELECT CASE configState.angleMode
		CASE $$ANGLE_RADIANS
			WinXButton_SetCheck (GetDlgItem (configState.hDlg, $$CONFIG_RB_RAD), $$TRUE)
		CASE $$ANGLE_DEGREES
			WinXButton_SetCheck (GetDlgItem (configState.hDlg, $$CONFIG_RB_DEG), $$TRUE)
		CASE $$ANGLE_GRADS
			WinXButton_SetCheck (GetDlgItem (configState.hDlg, $$CONFIG_RB_GRAD), $$TRUE)
	END SELECT
	SELECT CASE configState.outputMode
		CASE $$OUT_BIN
			WinXButton_SetCheck (GetDlgItem (configState.hDlg, $$CONFIG_RB_BIN), $$TRUE)
		CASE $$OUT_OCT
			WinXButton_SetCheck (GetDlgItem (configState.hDlg, $$CONFIG_RB_OCT), $$TRUE)
		CASE $$OUT_DEC
			WinXButton_SetCheck (GetDlgItem (configState.hDlg, $$CONFIG_RB_DEC), $$TRUE)
		CASE $$OUT_HEX
			WinXButton_SetCheck (GetDlgItem (configState.hDlg, $$CONFIG_RB_HEX), $$TRUE)
	END SELECT
	SELECT CASE configState.rounding
		CASE $$ROUND_NONE
			WinXButton_SetCheck (GetDlgItem (configState.hDlg, $$CONFIG_RB_NONE), $$TRUE)
			EnableWindow (GetDlgItem (configState.hDlg, $$CONFIG_EB_FIX), $$FALSE)
			EnableWindow (GetDlgItem (configState.hDlg, $$CONFIG_EB_SCI), $$FALSE)
		CASE $$ROUND_FIXED
			WinXButton_SetCheck (GetDlgItem (configState.hDlg, $$CONFIG_RB_FIX), $$TRUE)
			EnableWindow (GetDlgItem (configState.hDlg, $$CONFIG_EB_SCI), $$FALSE)
			WinXSetText (GetDlgItem (configState.hDlg, $$CONFIG_EB_FIX), STRING$(configState.roundParam))
		CASE $$ROUND_SCIENTIFIC
			WinXButton_SetCheck (GetDlgItem (configState.hDlg, $$CONFIG_RB_SCI), $$TRUE)
			EnableWindow (GetDlgItem (configState.hDlg, $$CONFIG_EB_FIX), $$FALSE)
			WinXSetText (GetDlgItem (configState.hDlg, $$CONFIG_EB_SCI), STRING$(configState.roundParam))
	END SELECT
	
	WinXDisplay (configState.hDlg)
END FUNCTION

FUNCTION onCommandConfig(id, code, hWnd)
	SHARED CONFIGSTATE configState
	SHARED CONSOLESTATE conState
	SHARED GUISTATE guiState
	
	LOGFONT font
	
	SELECT CASE id
		CASE $$IDOK
			' Set in the changes
			configState.precision = GetDlgItemInt (configState.hDlg, $$CONFIG_EB_BITS, 0, $$FALSE)
			SELECT CASE configState.rounding
				CASE $$ROUND_FIXED
					configState.roundParam = GetDlgItemInt (configState.hDlg, $$CONFIG_EB_FIX, 0, $$FALSE)
				CASE $$ROUND_SCIENTIFIC
					configState.roundParam = GetDlgItemInt (configState.hDlg, $$CONFIG_EB_SCI, 0, $$FALSE)
					IFZ configState.roundParam THEN
						WinXDialog_Error ("Invalid number of significant figures", "Error", 0)
						RETURN
					END IF
			END SELECT
			
			IFZ configState.precision THEN
				WinXDialog_Error ("Invalid precision", "Error", 0)
				RETURN
			END IF
			
			calculate_setPrecision (configState.precision)
			calculate_setAngle (configState.angleMode)
			calculate_setOutMode (configState.outputMode)
			calculate_setRounding (configState.rounding, configState.roundParam)
			UpdateStatus ()
			
			conState.font = configState.newFont
			conState.forCol = configState.forCol
			conState.backCol = configState.backCol
			
			DeleteObject (conState.hFont)
			conState.hFont = CreateFontIndirectA (&conState.font)
			WinXSetWindowColour (guiState.hCon, conState.backCol)
			
			conState.promptWidth = WinXDraw_GetTextWidth (conState.hFont, "Enter Expression: ", -1)
			
			UpdateConsoleHeight (guiState.hCon)
			Console_Redraw (guiState.hCon, 0, 0)
			'InvalidateRect (guiState.hCon, 0, $$TRUE)
			UpdateCaretPos (guiState.hCon, $$FALSE)
			
			onCloseConfig (configState.hDlg)
		CASE $$IDCANCEL
			onCloseConfig (configState.hDlg)
		CASE $$CONFIG_RB_RAD
			configState.angleMode = $$ANGLE_RADIANS
		CASE $$CONFIG_RB_DEG
			configState.angleMode = $$ANGLE_DEGREES
		CASE $$CONFIG_RB_GRAD
			configState.angleMode = $$ANGLE_GRADS
		CASE $$CONFIG_RB_NONE
			configState.rounding = $$ROUND_NONE
			EnableWindow (GetDlgItem (configState.hDlg, $$CONFIG_EB_FIX), $$FALSE)
			EnableWindow (GetDlgItem (configState.hDlg, $$CONFIG_EB_SCI), $$FALSE)
		CASE $$CONFIG_RB_FIX
			configState.rounding = $$ROUND_FIXED
			EnableWindow (GetDlgItem (configState.hDlg, $$CONFIG_EB_FIX), $$TRUE)
			EnableWindow (GetDlgItem (configState.hDlg, $$CONFIG_EB_SCI), $$FALSE)
		CASE $$CONFIG_RB_SCI
			configState.rounding = $$ROUND_SCIENTIFIC
			EnableWindow (GetDlgItem (configState.hDlg, $$CONFIG_EB_FIX), $$FALSE)
			EnableWindow (GetDlgItem (configState.hDlg, $$CONFIG_EB_SCI), $$TRUE)
		CASE $$CONFIG_RB_BIN
			configState.outputMode = $$OUT_BIN
		CASE $$CONFIG_RB_OCT
			configState.outputMode = $$OUT_OCT
		CASE $$CONFIG_RB_DEC
			configState.outputMode = $$OUT_DEC
		CASE $$CONFIG_RB_HEX
			configState.outputMode = $$OUT_HEX
		CASE $$CONFIG_BT_FONT
			font = configState.newFont
			forCol = configState.forCol
			WinXDraw_GetFontDialog (configState.hDlg, @font, @forCol)
			configState.forCol = forCol
			configState.newFont = font
		CASE $$CONFIG_BT_COL
			configState.backCol = WinXDraw_GetColour (configState.hDlg, configState.backCol)
	END SELECT

END FUNCTION

FUNCTION onCloseConfig (hWnd)
	SHARED CONFIGSTATE configState
	
	IF hWnd = configState.hDlg THEN
		DestroyWindow (hWnd)
		configState.dialogVisible = $$FALSE
	END IF
END FUNCTION
'
' ##########################
' #####  UpdateStatus  #####
' ##########################
' Update the status bar
FUNCTION UpdateStatus ()
	SELECT CASE calculate_getAngle ()
		CASE $$ANGLE_RADIANS
			WinXStatus_SetText (#hMain, 0, "Angle = Radians")
		CASE $$ANGLE_DEGREES
			WinXStatus_SetText (#hMain, 0, "Angle = Degrees")
		CASE $$ANGLE_GRADS
			WinXStatus_SetText (#hMain, 0, "Angle = Grads")
	END SELECT
	SELECT CASE calculate_getRounding (@param)
		CASE $$ROUND_NONE
			WinXStatus_SetText (#hMain, 1, "Output Rounding = None")
		CASE $$ROUND_FIXED
			WinXStatus_SetText (#hMain, 1, "Output Rounding = Fixed ("+STRING$(param)+" digits)")
		CASE $$ROUND_SCIENTIFIC
			WinXStatus_SetText (#hMain, 1, "Output Rounding = Scientific ("+STRING$(param)+" sf)")
	END SELECT
	SELECT CASE calculate_getOutMode ()
		CASE $$OUT_BIN
			WinXStatus_SetText (#hMain, 2, "Output Display = Binary")
		CASE $$OUT_OCT
			WinXStatus_SetText (#hMain, 2, "Output Display = Octal")
		CASE $$OUT_DEC
			WinXStatus_SetText (#hMain, 2, "Output Display = Decimal")
		CASE $$OUT_HEX
			WinXStatus_SetText (#hMain, 2, "Output Display = Hexadecimal")
	END SELECT
	WinXStatus_SetText (#hMain, 3, "Precision = "+STRING$(calculate_getPrecision())+" bits")
END FUNCTION

FUNCTION onClipChange ()
	SHARED GUISTATE guiState
	
	IF !WinXClip_IsString () THEN
		EnableMenuItem (guiState.hMainMenu, $$CMD_PASTE, $$MF_BYCOMMAND|$$MF_GRAYED)
	ELSE
		EnableMenuItem (guiState.hMainMenu, $$CMD_PASTE, $$MF_BYCOMMAND|$$MF_ENABLED)
	END IF
END FUNCTION
'
' #############################
' #####  SaveEnvironment  #####
' #############################
'
'
'
FUNCTION SaveEnvironment ()
	SHARED CONSOLESTATE conState
	SHARED GUISTATE guiState
	
	WINDOWPLACEMENT wp
	RECT rect
	SECURITY_ATTRIBUTES sa
	
	sa = WinXNewACL ($$ACL_REG_STANDARD, $$TRUE)
	' Save the state
	WinXRegistry_WriteInt ($$HKEY_LOCAL_MACHINE, "Software\\Callumscode\\BtCalc\\3.00", "angle", sa, calculate_getAngle ())
	WinXRegistry_WriteInt ($$HKEY_LOCAL_MACHINE, "Software\\Callumscode\\BtCalc\\3.00", "rounding", sa, calculate_getRounding (@roundParam))
	WinXRegistry_WriteInt ($$HKEY_LOCAL_MACHINE, "Software\\Callumscode\\BtCalc\\3.00", "roundParam", sa, roundParam)
	WinXRegistry_WriteInt ($$HKEY_LOCAL_MACHINE, "Software\\Callumscode\\BtCalc\\3.00", "outMode", sa, calculate_getOutMode ())
	WinXRegistry_WriteInt ($$HKEY_LOCAL_MACHINE, "Software\\Callumscode\\BtCalc\\3.00", "precision", sa, calculate_getPrecision ())
	
	buffer$ = NULL$(SIZE(LOGFONT))
	RtlMoveMemory (&buffer$, &conState.font, SIZE(LOGFONT))
	WinXRegistry_WriteBin ($$HKEY_LOCAL_MACHINE, "Software\\Callumscode\\BtCalc\\3.00", "font", sa, buffer$)
	WinXRegistry_WriteInt ($$HKEY_LOCAL_MACHINE, "Software\\Callumscode\\BtCalc\\3.00", "forCol", sa, conState.forCol)
	WinXRegistry_WriteInt ($$HKEY_LOCAL_MACHINE, "Software\\Callumscode\\BtCalc\\3.00", "backCol", sa, conState.backCol)
	
	IF IsZoomed (#hMain) || IsIconic (#hMain) THEN
		wp.length = SIZE(WINDOWPLACEMENT)
		GetWindowPlacement (#hMain, &wp)
		rect = wp.rcNormalPosition
		IF IsZoomed (#hMain) THEN zoomed = $$TRUE
	ELSE
		GetWindowRect (#hMain, &rect)
		zoomed = $$FALSE
	END IF
	
	buffer$ = NULL$(SIZE(RECT))
	RtlMoveMemory (&buffer$, &rect, SIZE(RECT))
	WinXRegistry_WriteBin ($$HKEY_LOCAL_MACHINE, "Software\\Callumscode\\BtCalc\\3.00", "windowSize", sa, buffer$)
	WinXRegistry_WriteInt ($$HKEY_LOCAL_MACHINE, "Software\\Callumscode\\BtCalc\\3.00", "maximised", sa, zoomed)
	WinXRegistry_WriteInt ($$HKEY_LOCAL_MACHINE, "Software\\Callumscode\\BtCalc\\3.00", "alwaysOnTop", sa, guiState.alwaysOnTop)
	
	IF WinXSplitter_GetPos (guiState.mainSeries, guiState.hLV, @position, @docked) THEN
		WinXRegistry_WriteInt ($$HKEY_LOCAL_MACHINE, "Software\\Callumscode\\BtCalc\\3.00", "leftPanePos", sa, position)
		WinXRegistry_WriteInt ($$HKEY_LOCAL_MACHINE, "Software\\Callumscode\\BtCalc\\3.00", "leftPaneDock", sa, docked)
	END IF
	IF WinXSplitter_GetPos (guiState.secondSeries, guiState.hPad, @position, @docked) THEN
		WinXRegistry_WriteInt ($$HKEY_LOCAL_MACHINE, "Software\\Callumscode\\BtCalc\\3.00", "rightPanePos", sa, position)
		WinXRegistry_WriteInt ($$HKEY_LOCAL_MACHINE, "Software\\Callumscode\\BtCalc\\3.00", "rightPaneDock", sa, docked)
	END IF
END FUNCTION
'
' ################################
' #####  RestoreEnvironment  #####
' ################################
'
'
'
FUNCTION RestoreEnvironment ()
	SHARED CONSOLESTATE conState
	SHARED GUISTATE guiState
	
	WINDOWPLACEMENT wp
	RECT rect
	SECURITY_ATTRIBUTES sa
	
	sa = WinXNewACL ($$ACL_REG_STANDARD, $$TRUE)
	
	result = calculate_getAngle ()
	WinXRegistry_ReadInt ($$HKEY_LOCAL_MACHINE, "Software\\Callumscode\\BtCalc\\3.00", "angle", $$TRUE, sa, @result)
	calculate_setAngle (result)
	
	result = calculate_getRounding (@roundParam)
	WinXRegistry_ReadInt ($$HKEY_LOCAL_MACHINE, "Software\\Callumscode\\BtCalc\\3.00", "rounding", $$TRUE, sa, @result)
	WinXRegistry_ReadInt ($$HKEY_LOCAL_MACHINE, "Software\\Callumscode\\BtCalc\\3.00", "roundParam", $$TRUE, sa, @roundParam)
	calculate_setRounding (result, roundParam)
	
	result = calculate_getOutMode ()
	WinXRegistry_ReadInt ($$HKEY_LOCAL_MACHINE, "Software\\Callumscode\\BtCalc\\3.00", "outMode", $$TRUE, sa, @result)
	calculate_setOutMode (result)
	
	result = calculate_getPrecision ()
	WinXRegistry_ReadInt ($$HKEY_LOCAL_MACHINE, "Software\\Callumscode\\BtCalc\\3.00", "precision", $$TRUE, sa, @result)
	calculate_setPrecision (result)
	
	result$ = NULL$(SIZE(LOGFONT))
	RtlMoveMemory (&result$, &conState.font, SIZE(LOGFONT))
	WinXRegistry_ReadBin ($$HKEY_LOCAL_MACHINE, "Software\\Callumscode\\BtCalc\\3.00", "font", $$TRUE, sa, @result$)
	RtlMoveMemory (&conState.font, &result$, SIZE(LOGFONT))
	
	result = conState.forCol
	WinXRegistry_ReadInt ($$HKEY_LOCAL_MACHINE, "Software\\Callumscode\\BtCalc\\3.00", "forCol", $$TRUE, sa, @result)
	conState.forCol = result
	
	result = conState.backCol
	WinXRegistry_ReadInt ($$HKEY_LOCAL_MACHINE, "Software\\Callumscode\\BtCalc\\3.00", "backCol", $$TRUE, sa, @result)
	conState.backCol = result
	
	GetWindowRect (#hMain, &rect)
	
	result$ = NULL$(SIZE(RECT))
	RtlMoveMemory (&result$, &rect, SIZE(RECT))
	WinXRegistry_ReadBin ($$HKEY_LOCAL_MACHINE, "Software\\Callumscode\\BtCalc\\3.00", "windowSize", $$TRUE, sa, @result$)
	
	result = IsZoomed (#hMain)
	WinXRegistry_ReadInt ($$HKEY_LOCAL_MACHINE, "Software\\Callumscode\\BtCalc\\3.00", "maximised", $$TRUE, sa, @result)
	RtlMoveMemory (&rect, &result$, SIZE(RECT))	
	IF result THEN
		wp.length = SIZE(WINDOWPLACEMENT)
		wp.showCmd = $$SW_SHOWMAXIMIZED
		wp.rcNormalPosition = rect
		SetWindowPlacement (#hMain, &wp)
	ELSE
		SetWindowPos (#hMain, 0, rect.left, rect.top, rect.right-rect.left, rect.bottom-rect.top, $$SWP_NOOWNERZORDER|$$SWP_NOZORDER)
	END IF
	
	result = guiState.alwaysOnTop
	WinXRegistry_ReadInt ($$HKEY_LOCAL_MACHINE, "Software\\Callumscode\\BtCalc\\3.00", "alwaysOnTop", $$TRUE, sa, @result)
	guiState.alwaysOnTop = result
	IF guiState.alwaysOnTop THEN
		SetWindowPos (#hMain, $$HWND_TOPMOST, 0, 0, 0, 0, $$SWP_NOMOVE|$$SWP_NOSIZE)
		CheckMenuItem (guiState.hMainMenu, $$CMD_ALWAYSONTOP, $$MF_BYCOMMAND|$$MF_CHECKED)
	END IF
	
	WinXSplitter_GetPos (guiState.mainSeries, guiState.hLV, @result, @docked)
	WinXRegistry_ReadInt ($$HKEY_LOCAL_MACHINE, "Software\\Callumscode\\BtCalc\\3.00", "leftPanePos", $$TRUE, sa, @result)
	WinXRegistry_ReadInt ($$HKEY_LOCAL_MACHINE, "Software\\Callumscode\\BtCalc\\3.00", "leftPaneDock", $$TRUE, sa, @docked)
	WinXSplitter_SetPos (guiState.mainSeries, guiState.hLV, result, docked)
	
	WinXSplitter_GetPos (guiState.secondSeries, guiState.hPad, @result, @docked)
	WinXRegistry_ReadInt ($$HKEY_LOCAL_MACHINE, "Software\\Callumscode\\BtCalc\\3.00", "rightPanePos", $$TRUE, sa, @result)
	WinXRegistry_ReadInt ($$HKEY_LOCAL_MACHINE, "Software\\Callumscode\\BtCalc\\3.00", "rightPaneDock", $$TRUE, sa, @docked)
	WinXSplitter_SetPos (guiState.secondSeries, guiState.hPad, result, docked)
	
	DeleteObject (conState.hFont)
	conState.hFont = CreateFontIndirectA (&conState.font)
	conState.promptWidth = WinXDraw_GetTextWidth (conState.hFont, "Enter Expression: ", -1)
	
	WinXSetWindowColour (guiState.hCon, conState.backCol)
	UpdateCaretPos (guiState.hCon, $$TRUE)
	Console_Redraw (guiState.hCon, 0, 0)
	UpdateStatus ()
	
	WinXUpdate (#hMain)
END FUNCTION
'
' ################################
' #####  onSelectionChanged  #####
' ################################
'
'
'
FUNCTION onSelectionChanged ()
	SHARED GUISTATE guiState
	SHARED CONSOLESTATE conState
	
	IF conState.selLineCount THEN
		EnableMenuItem (guiState.hMainMenu, $$CMD_COPY, $$MF_BYCOMMAND|$$MF_ENABLED)
	ELSE
		IFZ conState.selCharCount THEN 
			EnableMenuItem (guiState.hMainMenu, $$CMD_CUT, $$MF_BYCOMMAND|$$MF_GRAYED)
			EnableMenuItem (guiState.hMainMenu, $$CMD_COPY, $$MF_BYCOMMAND|$$MF_GRAYED)
		ELSE
			EnableMenuItem (guiState.hMainMenu, $$CMD_CUT, $$MF_BYCOMMAND|$$MF_ENABLED)
			EnableMenuItem (guiState.hMainMenu, $$CMD_COPY, $$MF_BYCOMMAND|$$MF_ENABLED)
		END IF
	END IF
END FUNCTION

FUNCTION onMouseDown (hWnd, button, x, y)
	SHARED GUISTATE guiState
	SHARED CONSOLESTATE conState
	SHARED currentLine$
	
	SHARED dragStartX
	SHARED dragStartY
	SHARED dragging
	SHARED lineSelection
	
	SetFocus (hWnd)
	IF hWnd = guiState.hPad THEN RETURN
	
	IF button = $$MBT_LEFT THEN
		' find the mouse position
		dragStartY = (y+conState.scrollY)\(conState.font.height)
		IF dragStartY >= (conState.lines.cItems) THEN
			vx = x+conState.scrollX-conState.promptWidth-6
			IF vx < 0 THEN dragStartX = 0 ELSE dragStartX = -WinXDraw_GetTextWidth (conState.hFont, currentLine$, vx)+1
			IF dragStartX < 0 THEN dragStartX = LEN(currentLine$)
			IF LEN(currentLine$) = 0 THEN dragStartX = 0
			conState.stringPos = dragStartX
		ELSE
			vx = x+conState.scrollX-6
			LinkedList_GetItem (conState.lines, dragStartY, @iData)
			STRING_Get (iData, @line$)
			IF vx < 0 THEN dragStartX = 0 ELSE dragStartX = -WinXDraw_GetTextWidth (conState.hFont, line$, vx)+1
			IF dragStartX < 0 THEN dragStartX = LEN(line$)
			IF LEN(line$) = 0 THEN dragStartX = 0
			
			lineSelection = $$TRUE
		END IF
		
		conState.selCharCount = 0
		conState.selLineCount = 0
		onSelectionChanged ()
		dragging = $$TRUE
		SetCapture (hWnd)
		
		UpdateCaretPos (guiState.hCon, $$FALSE)
		Console_Redraw (guiState.hCon, 0, 0)
		'InvalidateRect (hWnd, 0, $$TRUE)
	END IF
END FUNCTION 
 
FUNCTION onMouseMove (hWnd, x, y)
	SHARED GUISTATE guiState
	SHARED CONSOLESTATE conState
	SHARED currentLine$
	
	SHARED dragStartX
	SHARED dragStartY
	SHARED dragging
	SHARED lineSelection
	
	RECT rect
	
	' If the mouse is outside the window, scroll the window
	GetClientRect (hWnd, &rect)
	WinXScroll_GetPos (hWnd, $$DIR_VERT, @pos)
	ry = y
	DO WHILE (ry < 0)&&(pos>0)
		WinXScroll_Scroll (hWnd, $$DIR_VERT, $$UNIT_LINE, -1)
		WinXScroll_GetPos (hWnd, $$DIR_VERT, @pos)
		ry = ry+conState.font.height
	LOOP
	ry = y
	maxHeight = (conState.lines.cItems+1)*conState.font.height
	DO WHILE (ry > rect.bottom)&&(pos<maxHeight)
		WinXScroll_Scroll (hWnd, $$DIR_VERT, $$UNIT_LINE, +1)
		WinXScroll_GetPos (hWnd, $$DIR_VERT, @pos)
		ry = ry-conState.font.height
	LOOP
	
	IF dragging THEN
		dragY = (y+conState.scrollY)\(conState.font.height)
		IF !lineSelection THEN
			IF dragY >= (conState.lines.cItems) THEN
				vx = x+conState.scrollX-conState.promptWidth-6
				IF vx < 0 THEN dragX = 0 ELSE  dragX = -WinXDraw_GetTextWidth (conState.hFont, currentLine$, vx)+1
				IF dragX < 0 THEN dragX = LEN(currentLine$)
				IF LEN(currentLine$) = 0 THEN dragX = 0
				conState.stringPos = dragX
				
				conState.selStartChar = MIN (dragX, dragStartX)
				conState.selCharCount = ABS (dragX - dragStartX)
				onSelectionChanged ()
				
				UpdateCaretPos (guiState.hCon, $$FALSE)
				Console_Redraw (guiState.hCon, 0, 0)
			END IF
		ELSE
			IF dragY < (conState.lines.cItems) THEN
				' we have to deal with line selection
				LinkedList_GetItem (conState.lines, dragY, @iData)
				STRING_Get (iData, @line$)
				vx = x+conState.scrollX-6
				IF vx < 0 THEN dragX = 0 ELSE dragX = -WinXDraw_GetTextWidth (conState.hFont, line$, vx)+1
				IF dragX < 0 THEN dragX = LEN(line$)
				IF LEN(line$) = 0 THEN dragX = 0
				
				conState.selStartLine = MIN (dragY, dragStartY)
				conState.selLineCount = ABS (dragY - dragStartY)+1
				
				SELECT CASE TRUE
					CASE dragY > dragStartY
						conState.selStartChar = dragStartX
						conState.selCharCount = dragX
					CASE dragY < dragStartY
						conState.selStartChar = dragX
						conState.selCharCount = dragStartX
					CASE dragY = dragStartY
						conState.selStartChar = MIN (dragX, dragStartX)
						conState.selCharCount = ABS (dragX - dragStartX)
				END SELECT
				
				onSelectionChanged ()
				Console_Redraw (guiState.hCon, 0, 0)
				'InvalidateRect (guiState.hCon, 0, $$TRUE)
			END IF
		END IF
	END IF
	
END FUNCTION 

FUNCTION onMouseUp (hWnd, button, x, y)
	SHARED GUISTATE guiState
	SHARED CONSOLESTATE conState
	SHARED dragStartX
	SHARED dragStartY
	SHARED dragging
	SHARED lineSelection
	
	IF button = $$MBT_LEFT THEN
		ReleaseCapture ()
		dragging = $$FALSE
		lineSelection = $$FALSE
	END IF
END FUNCTION 
'
' #############################
' #####  RemoveSelection  #####
' #############################
' Destroy a selection
FUNCTION RemoveSelection ()
	SHARED GUISTATE guiState
	SHARED CONSOLESTATE conState
	
	conState.selStartChar = 0
	conState.selCharCount = 0
	IF conState.selLineCount THEN
		conState.selLineCount = 0
		Console_Redraw (guiState.hCon, 0, 0)
		'InvalidateRect (guiState.hCon, 0, $$TRUE)
	ELSE
		Console_Redraw (guiState.hCon, 0, 0)
	END IF
END FUNCTION
'
' ######################
' #####  onLVItem  #####
' ######################
FUNCTION onLVItem (idControl, event, parameter)
	SHARED GUISTATE guiState
	POINT pt

	hLV = GetDlgItem (#hMain, idControl)
	SELECT CASE event
		CASE $$NM_DBLCLK, $$NM_RETURN
			GetCursorPos (&pt)
			ScreenToClient (hLV, &pt)
			iItem = WinXListView_GetItemFromPoint (hLV, pt.x, pt.y)
			WinXListView_GetItemText (hLV, iItem, 1, @text$[])
			
			InsertText (text$[0])
			SetFocus (guiState.hCon)
			
			UpdateCaretPos (guiState.hCon, $$TRUE)
			Console_Redraw (guiState.hCon, 0, 0)
		CASE $$NM_RCLICK
			GetCursorPos (&pt)
			TrackPopupMenu (guiState.hListContextMenu, $$TPM_LEFTALIGN|$$TPM_TOPALIGN|$$TPM_LEFTBUTTON|$$TPM_HORPOSANIMATION|$$TPM_VERPOSANIMATION, pt.x, pt.y, 0, #hMain, 0)
			
			ScreenToClient (hLV, &pt)
			guiState.iContextItem = WinXListView_GetItemFromPoint (hLV, pt.x, pt.y)
	END SELECT
END FUNCTION
'
' ###########################
' #####  onLVLabelEdit  #####
' ###########################
FUNCTION onLVLabelEdit (control, code, item, text$)
	STATIC oldLabel$
	
	SELECT CASE code
		CASE $$EDIT_START
			WinXListView_GetItemText (GetDlgItem (#hMain, control), item, 1, @text$[])
			oldLabel$ = text$[0]
			
			IF oldLabel$ = "@" THEN RETURN $$FALSE
			RETURN $$TRUE
		CASE $$EDIT_DONE
			iExpr = calculate_parse ("LET "+text$+" = "+oldLabel$, @errorString$)
			'PRINT "LET "+text$+" = "+oldLabel$, errorString$
			IF iExpr THEN
				calculate_execute (iExpr, 0, @exception, @resultString$)
				'PRINT resultString$
				IFF (exception = $$EXCEPTION_NONE)||(exception = $$EXCEPTION_NOTNUM) THEN RETURN $$FALSE
			ELSE
				RETURN $$FALSE
			END IF
			iExpr = calculate_parse ("CLEAR "+oldLabel$, @errorString$)
			'PRINT "CLEAR "+oldLabel$, errorString$
			IF iExpr THEN
				calculate_execute (iExpr, 0, @exception, @resultString$)
				'PRINT resultString$
				IFF (exception = $$EXCEPTION_NONE)||(exception = $$EXCEPTION_NOTNUM) THEN RETURN $$FALSE
			ELSE
				RETURN $$FALSE
			END IF
			RETURN $$TRUE
	END SELECT
END FUNCTION

END PROGRAM