'
' ####################
' #####  PROLOG  #####
' ####################
'
' This DLL contains the lexer, parser and calculator compenents
'
PROGRAM "calculate"
VERSION "2.00"
$$CALCVERSION = 0x02000000
'
	IMPORT "xst_s"				' Standard library : required by most programs
	IMPORT "xsx_s"
	IMPORT "xma_s"				' maths library
	IMPORT "xcm_s"				' complex numbers
'	IMPORT "xsx"				' Extended standard library
'	IMPORT "xio"				' Console input/ouput library

'	IMPORT "xst_s.lib"
' IMPORT "xsx_s.lib"
' IMPORT "xio_s.lib"

	IMPORT "gdi32"			' gdi32.dll
	IMPORT "user32"		  ' user32.dll
	IMPORT "kernel32"	  ' kernel32.dll
'	IMPORT "shell32"		' shell32.dll
'	IMPORT "msvcrt"		  ' msvcrt.dll

TYPE TOKEN
	XLONG				.op
	XLONG				.class
	UNION
		DCOMPLEX	.number
		UBYTE			.id
	END UNION
END TYPE

EXPORT
'This data structure stores the calculator state
TYPE CALCSTATE
	XLONG			.angleMode
	XLONG			.roundingMode
	XLONG			.roundingPlaces
	XLONG			.outputMode
	XLONG			.error
	DCOMPLEX	.lastAns
END TYPE
TYPE RESULT
	XLONG			.cSolution		'number of solutions
	XLONG			.cValperSol		'number of values per solution
	XLONG			.pSolution		'pointer to an array of solutions
END TYPE
END EXPORT

TYPE SYMBOL
	XLONG			.name
	XLONG			.type
	XLONG			.value
END TYPE

EXPORT
'These are the mode identifiers
$$OMODE_DEC		= 0
$$OMODE_HEX		= 1
$$AMODE_DEG		= 0
$$AMODE_RAD		= 1
$$AMODE_GRD		= 3
$$RMODE_NONE	= 0
$$RMODE_FIX		= 1
$$RMODE_SF		= 2

'and now some maths constants
$$PIDIV180		= 0d3F91DF46A2529D39
$$PIDIV200		= 0d3F9015BF9217271A
$$1OVERLN2		= 0d3FF71547652B82FE
END EXPORT

'types for symbols
$$TYPE_ANY		= 1
$$TYPE_VAR		= 2
$$TYPE_CVAR		= 3
$$TYPE_FUNC		= 4
$$TYPE_CFUNC	= 5

'These are the operator identifiers
$$OP_NOTOKEN		= -1
$$OP_LITERAL		= 0
$$OP_PLUS				= 1			'+
$$OP_OR					= 2			'OR
$$OP_XOR				= 3			'XOR
$$OP_MULTIPLY		= 100		'*
$$OP_DIVIDE			= 101		'/
$$OP_RSHIFT			= 104		'>>		'* 2x
$$OP_LSHIFT			= 105		'<<		'/ 2x
$$OP_AND				= 106		'AND
$$OP_POWER			= 200		'^
$$OP_ROOT				= 201   'Rt
$$OP_C					= 202		'C
$$OP_P					= 203		'P
$$OP_NEGATE			= 300		'-
$$OP_NOT				= 301		'NOT
$$OP_SQR				= 302		'Sqr
$$OP_CBR				= 303		'Cbr
$$OP_SIN				= 304		'sin
$$OP_COS				= 305		'cos
$$OP_TAN				= 306		'tan
$$OP_COT				= 307		'cot
$$OP_SEC				= 308		'sec
$$OP_CSC				= 309		'cosec
$$OP_ASIN				= 310		'Asin
$$OP_ACOS				= 311		'Acos
$$OP_ATAN				= 312		'Atan
$$OP_ACOT				= 313		'Acot
$$OP_ASEC				= 314		'Asec
$$OP_ACSC				= 315		'Acosec
$$OP_SINH				= 316		'sinh
$$OP_COSH				= 317		'cosh
$$OP_TANH				= 318		'tanh
$$OP_COTH				= 319		'coth
$$OP_SECH				= 320		'sech
$$OP_CSCH				= 321		'cosech
$$OP_ASINH			= 322		'Asinh
$$OP_ACOSH			= 323		'Acosh
$$OP_ATANH			= 324		'Atanh
$$OP_ACOTH			= 325		'Acoth
$$OP_ASECH			= 326		'Asech
$$OP_ACSCH			= 327		'Acosech
$$OP_LOG				= 328		'Log
$$OP_LOGe				= 329		'Loge/ln
$$OP_FACT				= 330		'!
$$OP_INT				= 331		'int
$$OP_FRAC				= 332		'frac
$$OP_LOG2				= 333		'log2
$$OP_ASSIGN			= 400		'=
$$OP_CLS				= 401		'CLS
$$OP_MCL				= 402		'MCL
$$OP_OUTHEX			= 403		'HEX
$$OP_OUTDEC			= 404		'DEC
$$OP_SAD				= 405		'SAD
$$OP_SAR				= 406		'SAR
$$OP_SAG				= 407		'SAG
$$OP_SRN				= 408		'SRN
$$OP_SRD				= 409		'SRD
$$OP_SRS				= 410		'SRS
$$OP_COMMA			= 411		',
$$OP_OPENPAREN	= 1000	'(
$$OP_CLOSEPAREN	= 1001	')
$$OP_LASTANS		= 1002	'@
$$OP_ABS				= 1003	'|
$$OP_EQUALS			= 1004
$$OP_FUNC				= 2000	'any function
$$OP_AFUNC			= 2001	'assignment to function?
$$OP_PARAMETER	= 2026	'any parameter
$$OP_VAR				= 3000	'any variable
$$OP_AVAR				= 3001	'assignment to variable?
$$OP_CONST			= 4000	'any constant
$$OP_CONSTFUNC	= 4001	'any constant function
$$OP_SYMBOL			= 4002	'its a symbol, but what type of symbol?
$$VOP_SWAP			= 10000	'SWAP
$$VOP_PUSH			= 10001	'PUSH
$$VOP_POP				= 10002	'POP

'The level identifiers
$$LL_LINE				= 1
$$LL_EXPRESSION	= 2
$$LL_PRODUCT		= 3
$$LL_FACTOR			= 4
$$LL_TERM				= 5
$$LL_NUMBER			= 6

'Operator Classes
$$CLASS_CMD					= 1
$$CLASS_ADDOP				= 2
$$CLASS_MULOP				= 3
$$CLASS_EXPOP				= 4
$$CLASS_LAUNOP			= 5
$$CLASS_NUMBER			= 6
$$CLASS_OPENPAREN		= 7
$$CLASS_CLOSEPAREN	= 8
$$CLASS_IFUNC				= 9

EXPORT
'error ids
$$ERROR_NONE							= 0
$$ERROR_CANNOTWRITETOKEN	=	1
$$ERROR_BADSTKID					= 2
$$ERROR_STACKUNDERFLOW		= 3
$$ERROR_LEXERFAILED				= 4
$$ERROR_BADTOKEN					= 5
$$ERROR_BADDECNUMBER			= 6
$$ERROR_BADHEXNUMBER			= 7
$$ERROR_BADCHAR						= 8
$$ERROR_SYNTAX						= 9
$$ERROR_UNDEFINED					= 10
$$ERROR_EXPECTEDPARAM			= 11
$$ERROR_EXPECTEDCORP			= 12
$$ERROR_EXPECTEDEQ				= 13
$$ERROR_EXPECTEDLIT				= 14
$$ERROR_BADCOMMAND				= 15
$$ERROR_INCOMPLETEPARAM		= 16
$$ERROR_EXPECTEDOPENP			= 17
$$ERROR_EXPECTEDCOMMA			= 18
$$ERROR_EXPECTEDCLOSEP		= 19
$$ERROR_EXPECTEDNUMBER		= 20
$$ERROR_EXPECTEDABS				= 21
$$ERROR_EXPECTEDNUMORFUNC	= 22
$$ERROR_STACKOVERFLOW			= 23
$$ERROR_DIVBYZERO					= 24
END EXPORT

EXPORT
'interface functions
DECLARE FUNCTION Calc_Init ()
DECLARE FUNCTION Calc_getVersion ()
DECLARE FUNCTION Calc_RegisterIO (handleError, displayOutput)
DECLARE FUNCTION Calc_Calculate (pszInput)
END EXPORT
'internal functions
DECLARE FUNCTION lexicalScan (Input$)
DECLARE FUNCTION getToken (TOKEN @token)
DECLARE FUNCTION VOID backTrack ()
DECLARE FUNCTION outputToken (TOKEN token)
DECLARE FUNCTION stringTable_add (STRING stri)
DECLARE FUNCTION stringTable_remove (id)
DECLARE FUNCTION stringTable_get$ (id)
DECLARE FUNCTION stringTable_find (STRING stri)
DECLARE FUNCTION symbolTable_add (SYMBOL symbol)
DECLARE FUNCTION symbolTable_remove (id)
DECLARE FUNCTION symbolTable_find (STRING stri)
DECLARE FUNCTION symbolTable_get (id, SYMBOL @symbol)
DECLARE FUNCTION symbolTable_getType (id)
DECLARE FUNCTION symbolTable_getValue (id, @value)
DECLARE FUNCTION symbolTable_update (id, SYMBOL symbol)
DECLARE FUNCTION stack_push (DCOMPLEX value, stackId)
DECLARE FUNCTION stack_pop (DCOMPLEX @value, stackId)
DECLARE FUNCTION SendError (code, STRING stri)
DECLARE FUNCTION SendOutput (STRING stri)
DECLARE FUNCTION HexToNum (HexStr$)
DECLARE FUNCTION addVar (name, type, DCOMPLEX value)
DECLARE FUNCTION remVar (id)
DECLARE FUNCTION DCOMPLEX getVar (id)
DECLARE FUNCTION updateVar (id, DCOMPLEX value)
DECLARE FUNCTION addFunc (name, type, params[])
DECLARE FUNCTION getFuncParams (id, @params[])
DECLARE FUNCTION updateFunc (id, TOKEN @data[])
DECLARE FUNCTION remFunc (id)
DECLARE FUNCTION makeVar (id, type, DCOMPLEX value)
DECLARE FUNCTION makeFunc (id, type, params[])
DECLARE FUNCTION VOID dumpTokens (TOKEN @tokens[])
DECLARE FUNCTION VOID parseLine ()
DECLARE FUNCTION VOID parseExpression ()
DECLARE FUNCTION parseProduct ()
DECLARE FUNCTION parseFactor ()
DECLARE FUNCTION parseTerm ()
DECLARE FUNCTION parseNumber ()
DECLARE FUNCTION calculate (TOKEN @tokens[], DCOMPLEX @params[], func)
DECLARE FUNCTION DOUBLE factorial (DOUBLE x, DOUBLE y)
DECLARE FUNCTION handleException ()
DECLARE FUNCTION DOUBLE ccSin (DOUBLE x)
DECLARE FUNCTION DOUBLE ccCos (DOUBLE x)
DECLARE FUNCTION DOUBLE ccTan (DOUBLE x)
DECLARE FUNCTION stack_new (DCOMPLEX val)
DECLARE FUNCTION DOUBLE ccCot (DOUBLE x)
DECLARE FUNCTION stack_getTOS (stackId, DCOMPLEX @value)
'
' #######################
' #####  Calc_Init  #####
' #######################
' Initialises the calculator
' returns TRUE on success or FALSE on fail
FUNCTION Calc_Init ()
	SHARED	FUNCADDR	VOID	fSendError	(XLONG, XLONG)		'(errorCode, pszErrorString)
	SHARED	FUNCADDR	VOID	fSendOutput	(XLONG)		'(pszOutString)
	SHARED	STRING	StringTable[]
	SHARED	SYMBOL	SymbolTable[]
	SHARED	TOKEN	OutTokens[]
	SHARED	OutToken
	SHARED	TOKEN	InTokens[]
	SHARED	InToken
	SHARED	DCOMPLEX	stacks[]	'the calculation stacks
	SHARED	stackPtr[]					'the calculation stack pointer
	SHARED	DCOMPLEX	vals[]		'the values for the variables and constants
	SHARED	valsUC[]						'usage counters for the values
	SHARED	TOKEN		funcData[]	'data for the functions
	SHARED	pInfo[]							'stores the number and name of the parameters of the functions
	SHARED	CALCSTATE	calcState	'stores the state information for the calculator
	
	STATIC	registeredExceptions	'set to true once expceptions have been registered
	
	SYMBOL	symbol
	DCOMPLEX	n

	XLONGAT(&fSendError)	= 0
	XLONGAT(&fSendOutput)	= 0
	
	DIM SymbolTable[0]
	
	DIM StringTable[0]
	DIM OutTokens[0]
	DIM InTokens[0]
	OutToken = 0
	InToken = 0
	
	DIM stacks[0,31]
	DIM stackPtr[0]
	
	DIM vals[0]
	DIM valsUC[0]
	DIM funcData[0,0]	'stores function data
	DIM pInfo[0,0]		'stores the number and name of the parameters of the functions

	'add the built in constants
	n.R = $$PI
	addVar (stringTable_add("pi"), $$OP_CONST, n)
	n.R = $$E
	addVar (stringTable_add("e"), $$OP_CONST, n)
	n.R = 0
	n.I = 1
	addVar (stringTable_add("i"), $$OP_CONST, n)
	
	calcState.angleMode = $$AMODE_RAD
	calcState.roundingMode = $$RMODE_NONE
	calcState.roundingPlaces = 3
	calcState.outputMode = $$OMODE_DEC
	calcState.error = $$ERROR_NONE
	
	IF !registeredExceptions THEN
		XstSetExceptionFunction (&handleException())
		registeredExceptions = $$TRUE
	END IF

	RETURN $$TRUE
END FUNCTION
'
' #############################
' #####  Calc_getVersion  #####
' #############################
' returns the version number of the calculator dll
FUNCTION Calc_getVersion ()
	RETURN $$CALCVERSION
END FUNCTION
'
' #############################
' #####  Calc_RegisterIO  #####
' #############################
' Registers the input output functions
' handleError = pointer to the function that will be called to handle errors
' displayOutput = pointer to the function that displays calculator output
' returns TRUE on success or FALSE on fail
FUNCTION Calc_RegisterIO (handleError, displayOutput)
	SHARED	FUNCADDR	VOID	fSendError	(XLONG, XLONG)		'(errorCode, pszErrorString)
	SHARED	FUNCADDR	VOID	fSendOutput	(XLONG)		'(pszOutString)
	
	fSendError = handleError
	fSendOutput = displayOutput
	
	RETURN $$TRUE
END FUNCTION
'
' ############################
' #####  Calc_Calculate  #####
' ############################
' This function performs the calculation
' pszInput = the string containing the expression
' return value is a pointer to a RESULT structure or 0 on error
FUNCTION Calc_Calculate (pszInput)
	SHARED	TOKEN	OutTokens[]
	SHARED	OutToken
	SHARED	TOKEN	InTokens[]
	SHARED	InToken
	SHARED	CALCSTATE	calcState	'stores the state information for the calculator
	
	DCOMPLEX	params[]
	
	input$ = CSTRING$(pszInput)
	IF input$ = "" THEN RETURN 0 ELSE input$ = input$+"\xFF"
	
	'step 0, clear the token strings and error
	DIM OutTokens[0]
	DIM InTokens[0]
	OutToken = 0
	InToken = 0
	calcState.error = $$ERROR_NONE
	DIM params[]
	
	'step 1, perform a lexical scan
	lexicalScan (input$)
	
	'step 2, prepare for parsing
	REDIM OutTokens[OutToken-1]
	SWAP InTokens[], OutTokens[]
	OutToken = 0
	
	'step 3, parse
	parseLine()

	'step 4, prepare for calculation
	REDIM OutTokens[OutToken-1]
	InToken = 0
	dumpTokens (@OutTokens[])
	
	'step 5, calculate
	IF !calcState.error && OutToken > 0 THEN RETURN calculate (@OutTokens[], @params[], $$FALSE) ELSE RETURN 0
END FUNCTION
'
' #########################
' #####  lexicalScan  #####
' #########################
' The lexical scanner
' input$ = the input for the scanner
' returns TRUE on success of FALSE on fail
FUNCTION lexicalScan (input$)
	TOKEN		token
	SYMBOL	symbol
	'define the states for the parser
	$ERROR			= -1		'an error occured, this is an accepting state
	$ACCEPT 		= 0			'a good token was found
	$START 			= 1			'the starting state
	$ALPHA			= 2
	$NUMERIC		= 3
	$GT					= 4
	$LT					= 5
	$WHITESPACE	= 6
	$AFTERPOINT	= 7
	$AFTERE			= 8
	$HEXIT			= 9
	$DIGIT			= 10
	
	state = $START					'parser state
	
	pos = 0									'parser position (0 based character index)
	maxPos = UBOUND(input$)	'maximum value for position
	char = 0
	
	DO			'loop until there is no input left
		RtlFillMemory (&token, SIZE(TOKEN), 0)	'0 out the token
		token.op = $$OP_NOTOKEN
		state = $START
		DO		'loop until we have a token, or there is no input left
			char = input${pos}
			INC pos
			
			SELECT CASE state
				CASE $START
					SELECT CASE char
						CASE '('
							state = $ACCEPT
							token.op = $$OP_OPENPAREN
							token.class = $$CLASS_NUMBER
						CASE ')'
							state = $ACCEPT
							token.op = $$OP_CLOSEPAREN
							token.class = $$CLASS_CLOSEPAREN
						CASE '@'
							state = $ACCEPT
							token.op = $$OP_LASTANS
							token.class = $$CLASS_NUMBER
						CASE '+'
							state = $ACCEPT
							token.op = $$OP_PLUS
							token.class = $$CLASS_ADDOP
						CASE '-'
							state = $ACCEPT
							token.op = $$OP_NEGATE
							token.class = $$CLASS_IFUNC
						CASE '*'
							state = $ACCEPT
							token.op = $$OP_MULTIPLY
							token.class = $$CLASS_MULOP
						CASE '/'
							state = $ACCEPT
							token.op = $$OP_DIVIDE
							token.class = $$CLASS_MULOP
						CASE '^'
							state = $ACCEPT
							token.op = $$OP_POWER
							token.class = $$CLASS_EXPOP
						CASE '|'
							state = $ACCEPT
							token.op = $$OP_ABS
							token.class = $$CLASS_NUMBER
						CASE '>'
							state = $GT
						CASE '<'
							state = $LT
						CASE 'a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z', _
								 'A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z'
							detail$ = CHR$(char)
							state = $ALPHA
						CASE '0','1','2','3','4','5','6','7','8','9'
							detail$ = CHR$(char)
							state = $NUMERIC
						CASE '!'
							state = $ACCEPT
							token.op = $$OP_FACT
							token.class = $$CLASS_LAUNOP
						CASE ','
							state = $ACCEPT
							token.op = $$OP_COMMA
						CASE ' ', '\t','\v','\f'
							state = $WHITESPACE
						CASE '='
							state = $ACCEPT
							token.op = $$OP_EQUALS
						CASE 255		'this is the end character
							state = $ACCEPT
						CASE ELSE
							SendError ($$ERROR_BADCHAR, "Bad character \""+CHR$(char)+"\" at position "+STRING$(pos))
							state = $ACCEPT
					END SELECT
				CASE $LT
					IF char = '<' THEN
						token.op = $$OP_LSHIFT
						token.class = $$CLASS_MULOP
						state = $ACCEPT
					ELSE
						DEC pos
						state = $ERROR
					END IF
				CASE $GT
					IF char = '>' THEN
						token.op = $$OP_RSHIFT
						token.class = $$CLASS_MULOP
						state = $ACCEPT
					ELSE
						DEC pos
						state = $ERROR
					END IF
				CASE $WHITESPACE
					IFF (char = ' ')||(char = '\t')||(char = '\v')||(char = '\f') THEN 'the whitespace is over
						DEC pos
						state = $START
					END IF
				CASE $ALPHA
					SELECT CASE char
						CASE 'a','b','c','d','e','f','g','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z', _
								 'A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z', _
								 '0','1','2','3','4','5','6','7','8','9'
							detail$ = detail$ + CHR$(char)
						CASE 'h'
							'do we have a hex number?
							hex = $$TRUE		'assume we do
							FOR i = 0 TO UBOUND(detail$)
								c = detail${i}
								IFF (((c >= '0')&&(c <= '9'))||((c >= 'A')&&(c <= 'F'))) THEN hex = $$FALSE
							NEXT
							IF hex THEN
								state = $ACCEPT
								token.op = $$OP_LITERAL
								token.number.R = HexToNum (detail$)
								token.class = $$CLASS_NUMBER
							ELSE
								detail$ = detail$ + "h"
							END IF
						CASE ELSE
							state = $ACCEPT
							DEC pos
							SELECT CASE detail$
								CASE "OR"
									token.op = $$OP_OR
									token.class = $$CLASS_ADDOP
								CASE "XOR"
									token.op = $$OP_XOR
									token.class = $$CLASS_ADDOP
								CASE "AND"
									token.op = $$OP_AND
									token.class = $$CLASS_ADDOP
								CASE "Rt"
									token.op = $$OP_ROOT
									token.class = $$CLASS_EXPOP
								CASE "C"
									token.op = $$OP_C
									token.class = $$CLASS_MULOP
								CASE "P"
									token.op = $$OP_P
									token.class = $$CLASS_MULOP
								CASE "NOT"
									token.op = $$OP_NOT
									token.class = $$CLASS_IFUNC
								CASE "sqr"
									token.op = $$OP_SQR
									token.class = $$CLASS_IFUNC
								CASE "cbr"
									token.op = $$OP_CBR
									token.class = $$CLASS_IFUNC
								CASE "sin"
									token.op = $$OP_SIN
									token.class = $$CLASS_IFUNC
								CASE "cos"
									token.op = $$OP_COS
									token.class = $$CLASS_IFUNC
								CASE "tan"
									token.op = $$OP_TAN
									token.class = $$CLASS_IFUNC
								CASE "cot"
									token.op = $$OP_COT
									token.class = $$CLASS_IFUNC
								CASE "sec"
									token.op = $$OP_SEC
									token.class = $$CLASS_IFUNC
								CASE "cosec"
									token.op = $$OP_CSC
									token.class = $$CLASS_IFUNC
								CASE "Asin"
									token.op = $$OP_ASIN
									token.class = $$CLASS_IFUNC
								CASE "Acos"
									token.op = $$OP_ACOS
									token.class = $$CLASS_IFUNC
								CASE "Atan"
									token.op = $$OP_ATAN
									token.class = $$CLASS_IFUNC
								CASE "Acot"
									token.op = $$OP_ACOT
									token.class = $$CLASS_IFUNC
								CASE "Asec"
									token.op = $$OP_ASEC
									token.class = $$CLASS_IFUNC
								CASE "Acosec"
									token.op = $$OP_ACSC
									token.class = $$CLASS_IFUNC
								CASE "sinh"
									token.op = $$OP_SINH
									token.class = $$CLASS_IFUNC
								CASE "cosh"
									token.op = $$OP_COSH
									token.class = $$CLASS_IFUNC
								CASE "tanh"
									token.op = $$OP_TANH
									token.class = $$CLASS_IFUNC
								CASE "coth"
									token.op = $$OP_COTH
									token.class = $$CLASS_IFUNC
								CASE "sech"
									token.op = $$OP_SECH
									token.class = $$CLASS_IFUNC
								CASE "cosech"
									token.op = $$OP_CSCH
									token.class = $$CLASS_IFUNC
								CASE "Asinh"
									token.op = $$OP_ASINH
									token.class = $$CLASS_IFUNC
								CASE "Acosh"
									token.op = $$OP_ACOSH
									token.class = $$CLASS_IFUNC
								CASE "Atanh"
									token.op = $$OP_ATANH
									token.class = $$CLASS_IFUNC
								CASE "Acoth"
									token.op = $$OP_ACOTH
									token.class = $$CLASS_IFUNC
								CASE "Asech"
									token.op = $$OP_ASECH
									token.class = $$CLASS_IFUNC
								CASE "Acosech"
									token.op = $$OP_ACSCH
									token.class = $$CLASS_IFUNC
								CASE "log10","log"
									token.op = $$OP_LOG
									token.class = $$CLASS_IFUNC
								CASE "log2"
									token.op = $$OP_LOG2
									token.class = $$CLASS_IFUNC
								CASE "loge","ln"
									token.op = $$OP_LOGe
									token.class = $$CLASS_IFUNC
								CASE "int"
									token.op = $$OP_INT
									token.class = $$CLASS_IFUNC
								CASE "frac"
									token.op = $$OP_FRAC
									token.class = $$CLASS_IFUNC
								CASE "CLS"
									token.op = $$OP_CLS
									token.class = $$CLASS_CMD
								CASE "MCL"
									token.op = $$OP_MCL
									token.class = $$CLASS_CMD
								CASE "HEX"
									token.op = $$OP_OUTHEX
									token.class = $$CLASS_CMD
								CASE "DEC"
									token.op = $$OP_OUTDEC
									token.class = $$CLASS_CMD
								CASE "SAD"
									token.op = $$OP_SAD
									token.class = $$CLASS_CMD
								CASE "SAR"
									token.op = $$OP_SAR
									token.class = $$CLASS_CMD
								CASE "SAG"
									token.op = $$OP_SAG
									token.class = $$CLASS_CMD
								CASE "SRN"
									token.op = $$OP_SRN
									token.class = $$CLASS_CMD
								CASE "SRD"
									token.op = $$OP_SRD
									token.class = $$CLASS_CMD
								CASE "SRS"
									token.op = $$OP_SRS
									token.class = $$CLASS_CMD
								CASE ELSE
									token.op = $$OP_SYMBOL	'we have a symbol
									'does it exist yet?
									s = symbolTable_find (detail$)
									IF s > -1 THEN 'the symbol exists
										symbolTable_get (s, @symbol)
										token.op = symbol.type
										token.id = s
									ELSE	'the symbol doesn't exist, so add a stand in
										symbol.name = stringTable_add (detail$)
										symbol.type = $$OP_SYMBOL
										token.id = symbolTable_add (symbol)
									END IF
									token.class = $$CLASS_NUMBER
							END SELECT
					END SELECT
				CASE $NUMERIC
					SELECT CASE char
						CASE '0','1','2','3','4','5','6','7','8','9'
							detail$ = detail$+CHR$(char)
						CASE 'h'
							state = $ACCEPT
							token.op = $$OP_LITERAL
							token.number.R = HexToNum (detail$)
							token.class = $$CLASS_NUMBER
						CASE '.'
							state = $AFTERPOINT
							detail$ = detail$+"."
						CASE 'e'
							state = $AFTERE
							detail$ = detail$+"d"
						CASE 'A','B','C','D','E','F'
							state = $HEXIT
							detail$ = detail$+CHR$(char)
						CASE ELSE
							'the number is complete
							state = $ACCEPT
							DEC pos
							token.op = $$OP_LITERAL
							token.number.R = DOUBLE (detail$)
							token.class = $$CLASS_NUMBER
					END SELECT
				CASE $AFTERPOINT
					SELECT CASE char
						CASE '0','1','2','3','4','5','6','7','8','9'
							detail$ = detail$ + CHR$(char)
						CASE 'e'
							state = $AFTERE
							detail$ = detail$+"d"
						CASE ELSE
							state = $ACCEPT
							DEC pos
							token.op = $$OP_LITERAL
							token.number.R = DOUBLE (detail$)
							token.class = $$CLASS_NUMBER
					END SELECT
				CASE $AFTERE
					SELECT CASE char
						CASE '+','-','0','1','2','3','4','5','6','7','8','9'
							state = $DIGIT
							detail$ = detail$ + CHR$(char)
						CASE ELSE
							SendError ($$ERROR_BADDECNUMBER, "malformed decimal number") 
							state = $ACCEPT
							DEC pos
					END SELECT
				CASE $HEXIT
					SELECT CASE char
						CASE '0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'
							detail$ = detail$ + CHR$(char)
						CASE 'h'
							state = $ACCEPT
							token.op = $$OP_LITERAL
							token.number.R = HexToNum (detail$)
							token.class = $$CLASS_NUMBER
						CASE ELSE
							SendError ($$ERROR_BADHEXNUMBER, "malformed hexadecimal number") 
							state = $ACCEPT
							DEC pos
					END SELECT
				CASE $DIGIT
					IF (char >= '0') || (char <= '9') THEN
						detail$ = detail$ + CHR$(char)
					ELSE
						state = $ACCEPT
						DEC pos
						token.op = $$OP_LITERAL
						token.number.R = DOUBLE (detail$)
						token.class = $$CLASS_NUMBER
					END IF
			END SELECT
		LOOP UNTIL (state = $ACCEPT) || (state = $ERROR) || (pos > maxPos)
		
		IF state = $ACCEPT THEN
			IF token.op > -1 THEN outputToken (token)
		ELSE
			SendError ($$ERROR_BADTOKEN, "Bad token \""+detail$+"\"")
		END IF
	LOOP UNTIL pos > maxPos
	
	IF state != $ACCEPT THEN RETURN $$FALSE ELSE RETURN $$TRUE
END FUNCTION
'
' ######################
' #####  getToken  #####
' ######################
' gets a token from the input tokens
' token = the variable to put the token in
' returns FALSE if there is no token, TRUE if there is
FUNCTION getToken (TOKEN token)
	SHARED	TOKEN	InTokens[]
	SHARED	InToken

'	PRINT InToken
	
	IF InToken > UBOUND(InTokens[]) THEN 
		token.op = $$OP_NOTOKEN
	ELSE
		token = InTokens[InToken]
		INC InToken
	END IF

	IF token.op = $$OP_NOTOKEN THEN RETURN $$FALSE ELSE RETURN $$TRUE
END FUNCTION
'
' #######################
' #####  backTrack  #####
' #######################
' backtracks on the input tokens
FUNCTION VOID backTrack ()
	SHARED	TOKEN	InTokens[]
	SHARED	InToken
	
	IF InToken > 0 THEN DEC InToken
END FUNCTION
'
' #########################
' #####  outputToken  #####
' #########################
' Adds a token to the output token array
' token = the token to add
' returns TRUE on success or FALSE on fail
FUNCTION outputToken (TOKEN token)
	SHARED	TOKEN	OutTokens[]
	SHARED	OutToken
	
	'allocate more memmory if we need it
	IF OutToken > UBOUND(OutTokens[]) THEN REDIM OutTokens[((UBOUND(OutTokens[])+1)<<1)-1]
	
	OutTokens[OutToken] = token
	INC OutToken
	
	RETURN $$TRUE
END FUNCTION
'
' #############################
' #####  stringTable_add  #####
' #############################
' Adds a string to the string table
' stri = the string to add
' returns the id of the string
FUNCTION stringTable_add (STRING stri)
	SHARED	STRING	StringTable[]
	
	FOR i = 0 TO UBOUND(StringTable[])
		IF StringTable[i] = "" THEN
			StringTable[i] = stri
			RETURN i
		END IF
	NEXT
	
	'we need more memmory
	REDIM StringTable[((UBOUND(StringTable[])+1)<<1)-1]

	'assume i hasn't been reset
	StringTable[i] = stri
	RETURN i
END FUNCTION
'
' ################################
' #####  stringTable_remove  #####
' ################################
' removes a string from the string table
' id = the id of the string to remove
' returns true on success otherwise false
FUNCTION stringTable_remove (id)
	SHARED	STRING	StringTable[]
	
	IF id < 0 || id > UBOUND(StringTable[]) THEN RETURN $$FALSE
	StringTable[id] = ""
	RETURN $$TRUE
END FUNCTION
'
' ##############################
' #####  stringTable_get$  #####
' ##############################
' gets the value of a string in the string table
' id = the id of the string to get
' returns the value of the string or an empty string on fail
FUNCTION stringTable_get$ (id)
	SHARED	STRING	StringTable[]
	
	IF id < 0 || id > UBOUND(StringTable[]) THEN RETURN ""
	RETURN StringTable[id]
END FUNCTION
'
' ##############################
' #####  stringTable_find  #####
' ##############################
' Finds a string in the string table
' stri = the string to find
' returns the id of the string or -1 if it can't be found
FUNCTION stringTable_find (STRING stri)
	SHARED	STRING	StringTable[]
	
	FOR i = 0 TO UBOUND(StringTable[])
		IF StringTable[i] = stri THEN RETURN i
	NEXT
	RETURN -1
END FUNCTION
'
' #############################
' #####  symbolTable_add  #####
' #############################
' adds a symbol to the symbol table
' symbol = the symbol to add
' returns the id of the new symbol
FUNCTION symbolTable_add (SYMBOL symbol)
	SHARED	SYMBOL	SymbolTable[]

	FOR i = 0 TO UBOUND(SymbolTable[])
		IF SymbolTable[i].type = 0 THEN
			SymbolTable[i] = symbol
			RETURN i
		END IF
	NEXT
	
	'we need more memmory
	REDIM SymbolTable[((UBOUND(SymbolTable[])+1)<<1)-1]
	
	'assume i hasn't beed reset
	SymbolTable[i] = symbol
	RETURN i
END FUNCTION
'
' ################################
' #####  symbolTable_remove  #####
' ################################
' remove a symbol from the symbol table
' id = the id of the symbol to remove
' returns TRUE on success or FALSE on fail
FUNCTION symbolTable_remove (id)
	SHARED	SYMBOL	SymbolTable[]
	
	IF id < 0 || id > UBOUND(SymbolTable[]) THEN RETURN $$FALSE
	
	SymbolTable[id].type = 0
	RETURN $$TRUE
END FUNCTION
'
' ##############################
' #####  symbolTable_find  #####
' ##############################
' finds a symbol in the symbol table
' stri = the name of the symbol to find
' returns the id of the symbol or -1 if it can't be found
FUNCTION symbolTable_find (STRING stri)
	SHARED	SYMBOL	SymbolTable[]
	
	FOR i = 0 TO UBOUND(SymbolTable[])
		IF stringTable_get$(SymbolTable[i].name) = stri THEN RETURN i
	NEXT
	RETURN -1
END FUNCTION
'
' #############################
' #####  symbolTable_get  #####
' #############################
' gets a symbol from the symbol table
' id = the id of the symbol to get
' symbol = the variable to place the symbol in
' returns TRUE on success or FALSE on fail
FUNCTION symbolTable_get (id, SYMBOL symbol)
	SHARED	SYMBOL	SymbolTable[]
	
	IF id < 0 || id > UBOUND(SymbolTable[]) THEN RETURN $$FALSE
	
	symbol = SymbolTable[id]
	RETURN $$TRUE
END FUNCTION
'
' #################################
' #####  symbolTable_getType  #####
' #################################
' retrives the type of a symbol
' id = the id of the symbol to get the type for
' returns the type of the symbol or 0 on fail
FUNCTION symbolTable_getType (id)
	SHARED	SYMBOL	SymbolTable[]
	
	IF id < 0 || id > UBOUND(SymbolTable[]) THEN RETURN 0
	
	RETURN SymbolTable[id].type
END FUNCTION
'
' ##################################
' #####  symbolTable_getValue  #####
' ##################################
' retreives the value of a symbol
' id = the symbol to get the value for
' value = the variable to place the value in
' returns TRUE on success or FALSE on fail
FUNCTION symbolTable_getValue (id, value)
	SHARED	SYMBOL	SymbolTable[]
	
	IF id < 0 || id > UBOUND(SymbolTable[]) THEN RETURN $$FALSE
	
	value = SymbolTable[id].value
	RETURN $$TRUE
END FUNCTION
'
' ################################
' #####  symbolTable_update  #####
' ################################
' updates a symbol in the symbol table
' id = the id of the symbol to update
' symbol = the new version of the symbol
' returns TRUE on success or FALSE on fail
FUNCTION symbolTable_update (id, SYMBOL symbol)
	SHARED	SYMBOL	SymbolTable[]
	
	'bounds checking
	IF id < 0 || id > UBOUND(SymbolTable[]) THEN RETURN $$FALSE
	
	SymbolTable[id] = symbol
	RETURN $$TRUE
END FUNCTION
'
' ########################
' #####  stack_push  #####
' ########################
' pushes a value onto one of the calculation stacks
' value = the value to push
' stackId = the id (0 based) of the stack to push onto
' returns true on success or false on fail
FUNCTION VOID stack_push (DCOMPLEX value, stackId)
	SHARED	DCOMPLEX	stacks[]	'the calculation stacks
	SHARED	stackPtr[]					'the calculation stack pointers
	
	IF stackId < 0 || stackId > UBOUND(stacks[]) THEN
		SendError($$ERROR_BADSTKID,"")
		RETURN $$FALSE
	END IF
	
	IF stackPtr[stackId] > UBOUND(stacks[0,]) THEN	'allocate more memmory
		REDIM stacks[UBOUND(stacks[]),((UBOUND(stacks[0,])+1)<<1)-1]
	END IF
	
	stacks[stackId, stackPtr[stackId]] = value
	INC stackPtr[stackId]
	RETURN $$TRUE
END FUNCTION
'
' #######################
' #####  stack_pop  #####
' #######################
' pops a value off the stack
' value = the variable to place the value in
' stackId = the id of the stack to pop the value from
' returns true on success or false on fail
FUNCTION stack_pop (DCOMPLEX value, stackId)
	SHARED	DCOMPLEX	stacks[]	'the calculation stacks
	SHARED	stackPtr[]					'the calculation stack pointers
	
	IF stackId < 0 || stackId > UBOUND(stacks[]) THEN
		SendError($$ERROR_BADSTKID,"")
		RETURN $$FALSE
	END IF
	
	IF stackPtr[stackId] < 1 THEN
		SendError($$ERROR_STACKUNDERFLOW,"")
		RETURN $$FALSE
	END IF
	
	DEC stackPtr[stackId]
	value = stacks[stackId, stackPtr[stackId]]
	RETURN $$TRUE
END FUNCTION
'
' #######################
' #####  SendError  #####
' #######################
' Sends an error to the host application
' stri = the error string
FUNCTION VOID SendError (code, STRING stri)
	SHARED	FUNCADDR	VOID	fSendError	(XLONG, XLONG)		'(errorCode, pszErrorString)
	STATIC	STRING	sstri
	
	IF sstri = "" THEN sstri = "INTERNAL ERROR NUMBER:"+HEX$(code)
	sstri = stri
	@fSendError(code, &sstri)
	RETURN
END FUNCTION
'
' ########################
' #####  SendOutput  #####
' ########################
' Sends output to the host application
' stri = the output to send
FUNCTION SendOutput (STRING stri)
	SHARED	CALCSTATE	calcState	'stores the state information for the calculator
	SHARED	FUNCADDR	VOID	fSendOutput	(XLONG)		'(pszOutString)
	STATIC	STRING	sstri

	calcState.error = $$TRUE
	sstri = stri
	@fSendOutput(&sstri)
	RETURN
END FUNCTION
'
' ######################
' #####  HexToNum  #####
' ######################
' converts hex strings to numbers
' HexStr$ = the hex string to convert
' returns the number
FUNCTION HexToNum (HexStr$)
	ret = 0
	j = -1
	FOR i = UBOUND(HexStr$) TO 0 STEP -1
		INC j
		C = HexStr${i}
		IF C >= '0' && C <= '9' THEN N = C-'0'
		IF C >= 'A' && C <= 'F' THEN N = C-55	' ('A'-10)
		ret = ret+(N*(16**j))
	NEXT
	RETURN ret
END FUNCTION
'
' ####################
' #####  addVar  #####
' ####################
' adds a variable or constant to the system
' name = the string id of the name
' type = the type of varaible to create (const or var)
' value = the initial value for the variable
' returns the id in the symbol table of the new variable
FUNCTION addVar (name, type, DCOMPLEX value)
	SHARED	DCOMPLEX	vals[]		'the values for the variables and constants
	SHARED	valsUC[]						'usage counters for the values
	
	SYMBOL symbol
	
	symbol.name = name
	symbol.type = type
	
	slot = -1
	FOR i = 0 TO UBOUND(valsUC[])
		IF valsUC[i] = 0 THEN
			slot = i
			EXIT FOR
		END IF
	NEXT
	
	IF slot = -1 THEN 'allocate more memmory if we need it
		REDIM valsUC[((UBOUND(valsUC[])+1)<<1)-1]
		REDIM vals[UBOUND(valsUC[])]
	END IF
	
	'assume i hasn't been reset
	slot = i
	
	vals[slot] = value
	valsUC[slot] = 1
	symbol.value = slot
	
	RETURN symbolTable_add (symbol)
END FUNCTION
'
' ####################
' #####  remVar  #####
' ####################
' removes a variable from the system
' id = the id of the variable in the symbol table
' returns TRUE on success or FALSE on fail
FUNCTION remVar (id)
	SHARED	valsUC[]						'usage counters for the values
	
	SYMBOL	symbol
	
	'bounds checking
	IFZ symbolTable_get (id, @symbol) THEN RETURN $$FALSE
	IF (symbol.value < 0) || (symbol.value > UBOUND(valsUC[])) THEN RETURN $$FALSE
	
	valsUC[symbol.value] = 0
	RETURN symbolTable_remove (id)
END FUNCTION
'
' ####################
' #####  getVar  #####
' ####################
' retreives the value of a variable or constant
' id = the id of the variable in the symbol table
' returns the value of the variable
FUNCTION DCOMPLEX getVar (id)
	SHARED	DCOMPLEX	vals[]		'the values for the variables and constants
	SHARED	valsUC[]						'usage counters for the values
	
	SYMBOL		symbol
	DCOMPLEX	ret
	
	'bounds checking
	IFZ symbolTable_get (id, @symbol) THEN RETURN ret	
	IF (symbol.value < 0) || (symbol.value > UBOUND(valsUC[])) THEN RETURN ret
	
	RETURN vals[symbol.value]
END FUNCTION
'
' #######################
' #####  updateVar  #####
' #######################
' updates the value of a variable
' id = the id of the variable to update
' value = the new value for the variable
' returns TRUE on success or FALSE on fail
FUNCTION updateVar (id, DCOMPLEX value)
	SHARED	DCOMPLEX	vals[]		'the values for the variables and constants
	SHARED	valsUC[]						'usage counters for the values
	
	SYMBOL	symbol
	
	'bounds checking
	IFZ symbolTable_get (id, @symbol) THEN RETURN $$FALSE
	IF (symbol.value < 0) || (symbol.value > UBOUND(valsUC[])) THEN RETURN $$FALSE
	
	vals[symbol.value] = value
	RETURN $$TRUE
END FUNCTION
'
' #####################
' #####  addFunc  #####
' #####################
' adds a function to the system
' name = the string table id of the name of the function
' type = the type of function
' params = an array containing the number of parameters in the first element
' and the types of those parameters in the remaining elements
' returns the symbol table id of the new function
FUNCTION addFunc (name, type, params[])
	SHARED	TOKEN		funcData[]	'data for the functions
	SHARED	pInfo[]							'stores the number and name of the parameters of the functions
	
	SYMBOL	symbol
	
	symbol.name = name
	symbol.type = type
	
	'find an empty slot
	slot = -1
	FOR i = 0 TO UBOUND(pInfo[])
		IF pInfo[i,0] = 0 THEN
			slot = i
			EXIT FOR
		END IF
	NEXT
	
	IF slot = -1 THEN	'allocate more memmory
		REDIM pInfo[((UBOUND(pInfo[])+1)<<1)-1,]
		REDIM funcData[UBOUND(pInfo[]),]
	END IF
	
	slot = i
	
	symbol.value = slot
	ATTACH params[] TO pInfo[slot,]
	RETURN symbolTable_add (symbol)
END FUNCTION
'
' ###########################
' #####  getFuncParams  #####
' ###########################
' gets the number of parameters of a function
' id = the id of the function in the symbol table
' params[] = an array to contain the parameters
' returns TRUE on success of FAlSE on error
FUNCTION getFuncParams (id, params[])
	SHARED	pInfo[]
	
	SYMBOL	symbol
	
	'bounds checking
	IFZ symbolTable_get (id, @symbol) THEN RETURN $$FALSE
	IF (symbol.value < 0) || (symbol.value > UBOUND(pInfo[])) THEN RETURN $$FALSE
	
	DIM params[UBOUND(pInfo[id,])]
	FOR i = 0 TO UBOUND(params[])
		params[i] = pInfo[id,i]
	NEXT
	
	RETURN $$TRUE
END FUNCTION
'
' ########################
' #####  updateFunc  #####
' ########################
' updates the value of a function
' id = the id of the function to update
' data = the array containing the data for the new function, this will be emptied
' returns TRUE on success or FALSE on fail
FUNCTION updateFunc (id, TOKEN data[])
	SHARED	TOKEN		funcData[]	'data for the functions
	SHARED	pCount[]						'contains the number of paramets to each function, 0 if the slot is blank
	
	SYMBOL	symbol
	
	'bounds checking
	IFZ symbolTable_get (id, @symbol) THEN RETURN $$FALSE
	IF (symbol.value < 0) || (symbol.value > UBOUND(pCount[])) THEN RETURN $$FALSE
	
	ATTACH data[] TO funcData[symbol.value,]
	RETURN $$TRUE
END FUNCTION
'
' #####################
' #####  remFunc  #####
' #####################
' removes a function from the system
' id = the id of the function to remove
' returns $$TRUE on success or $$FALSE on fail
FUNCTION remFunc (id)
	SHARED	pCount[]						'contains the number of paramets to each function, 0 if the slot is blank
	
	SYMBOL	symbol
	
	'bounds checking
	IFZ symbolTable_get (id, @symbol) THEN RETURN $$FALSE
	IF (symbol.value < 0) || (symbol.value > UBOUND(pCount[])) THEN RETURN $$FALSE
	
	pCount[symbol.value] = 0
	RETURN $$TRUE
END FUNCTION
'
' #####################
' #####  makeVar  #####
' #####################
' makes an untyped symbol into a var
' id = the id of the symbol
' type = the type to translate into
' value = the initial value for the new variable
' returns TRUE on success or FALSE on fail
FUNCTION makeVar (id, type, DCOMPLEX value)
	SHARED	DCOMPLEX	vals[]		'the values for the variables and constants
	SHARED	valsUC[]						'usage counters for the values
	
	SYMBOL symbol
	
	IFF symbolTable_get (id, @symbol) THEN RETURN $$FALSE
	
	symbol.type = type
	
	slot = -1
	FOR i = 0 TO UBOUND(valsUC[])
		IF valsUC[i] = 0 THEN
			slot = i
			EXIT FOR
		END IF
	NEXT
	
	IF slot = -1 THEN 'allocate more memmory if we need it
		REDIM valsUC[((UBOUND(valsUC[])+1)<<1)-1]
		REDIM vals[UBOUND(valsUC[])]
	END IF
	
	'assume i hasn't been reset
	slot = i
	
	vals[slot] = value
	valsUC[slot] = 1
	symbol.value = slot
	
	symbolTable_update (id, symbol)
END FUNCTION
'
' ######################
' #####  makeFunc  #####
' ######################
' turns a symbol into a function
' id = the id of the symbol to change
' type = the type of function
' params = an array containing the number of parameters in the first element
' and the types of those parameters in the remaining elements
' returns the symbol table id of the new FUNCTION or -1 on error
FUNCTION makeFunc (id, type, params[])
	SHARED	TOKEN		funcData[]	'data for the functions
	SHARED	pInfo[]							'stores the number and name of the parameters of the functions
	
	SYMBOL	symbol
	
	IFF symbolTable_get (id, @symbol) THEN RETURN -1
	
	symbol.type = type

	'find an empty slot
	slot = -1
	FOR i = 0 TO UBOUND(pInfo[])
		IF pInfo[i,0] = 0 THEN
			slot = i
			EXIT FOR
		END IF
	NEXT
	
	IF slot = -1 THEN	'allocate more memmory
		REDIM pInfo[((UBOUND(pInfo[])+1)<<1)-1,]
		REDIM funcData[UBOUND(pInfo[]),]
	END IF
	
	slot = i
	
	symbol.value = slot
	ATTACH params[] TO pInfo[slot,]
	RETURN symbolTable_update (id, symbol)
END FUNCTION
'
' ########################
' #####  dumpTokens  #####
' ########################
' dumps a list of tokens to the screen
' tokens = an array containing the tokens to dump
FUNCTION VOID dumpTokens (TOKEN tokens[])
	SYMBOL	symbol
	
	FOR i = 0 TO UBOUND(tokens[])
		SELECT CASE tokens[i].op
			CASE $$OP_NOTOKEN
			CASE $$OP_LITERAL
				PRINT STRING(tokens[i].number.R);" ";
			CASE $$OP_PLUS
				PRINT "+ ";
			CASE $$OP_OR
				PRINT "OR ";
			CASE $$OP_XOR
				PRINT "XOR ";
			CASE $$OP_MULTIPLY
				PRINT "* ";
			CASE $$OP_DIVIDE
				PRINT "/ ";
			CASE $$OP_RSHIFT
				PRINT ">> ";
			CASE $$OP_LSHIFT
				PRINT "<< ";
			CASE $$OP_AND
				PRINT "AND ";
			CASE $$OP_POWER
				PRINT "^ ";
			CASE $$OP_ROOT
				PRINT "Rt ";
			CASE $$OP_C
				PRINT "C ";
			CASE $$OP_P
				PRINT "P ";
			CASE $$OP_NEGATE
				PRINT "- ";
			CASE $$OP_NOT
				PRINT "NOT ";
			CASE $$OP_SQR
				PRINT "sqr ";
			CASE $$OP_CBR
				PRINT "cbr ";
			CASE $$OP_SIN
				PRINT "sin ";
			CASE $$OP_COS
				PRINT "cos ";
			CASE $$OP_TAN
				PRINT "tan ";
			CASE $$OP_COT
				PRINT "cot ";
			CASE $$OP_SEC
				PRINT "sec ";
			CASE $$OP_CSC
				PRINT "cosec ";
			CASE $$OP_ASIN
				PRINT "Asin ";
			CASE $$OP_ACOS
				PRINT "Acos ";
			CASE $$OP_ATAN
				PRINT "Atan ";
			CASE $$OP_ACOT
				PRINT "Acot ";
			CASE $$OP_ASEC
				PRINT "Asec ";
			CASE $$OP_ACSC
				PRINT "Acosec ";
			CASE $$OP_SINH
				PRINT "sinh ";
			CASE $$OP_COSH
				PRINT "cosh ";
			CASE $$OP_TANH
				PRINT "tanh ";
			CASE $$OP_COTH
				PRINT "coth ";
			CASE $$OP_SECH
				PRINT "sech ";
			CASE $$OP_CSCH
				PRINT "cosech ";
			CASE $$OP_ASINH
				PRINT "Asinh ";
			CASE $$OP_ACOSH
				PRINT "Acosh ";
			CASE $$OP_ATANH
				PRINT "Atanh ";
			CASE $$OP_ACOTH
				PRINT "Acoth ";
			CASE $$OP_ASECH
				PRINT "Asech ";
			CASE $$OP_ACSCH
				PRINT "Acosech ";
			CASE $$OP_LOG
				PRINT "log ";
			CASE $$OP_LOGe
				PRINT "ln ";
			CASE $$OP_LOG2
				PRINT "log2 ";
			CASE $$OP_FACT
				PRINT "! ";
			CASE $$OP_INT
				PRINT "int ";
			CASE $$OP_FRAC
				PRINT "frac ";
			CASE $$OP_CLS
				PRINT "CLS ";
			CASE $$OP_MCL
				PRINT "MCL ";
			CASE $$OP_OUTHEX
				PRINT "HEX ";
			CASE $$OP_OUTDEC
				PRINT "DEC ";
			CASE $$OP_SAD
				PRINT "SAD ";
			CASE $$OP_SAR
				PRINT "SAR ";
			CASE $$OP_SAG
				PRINT "SAG ";
			CASE $$OP_SRN
				PRINT "SRN ";
			CASE $$OP_SRD
				PRINT "SRD ";
			CASE $$OP_SRS
				PRINT "SRS ";
			CASE $$OP_COMMA
				PRINT ", ";
			CASE $$OP_OPENPAREN
				PRINT "( ";
			CASE $$OP_CLOSEPAREN
				PRINT ") ";
			CASE $$OP_LASTANS
				PRINT "@ ";
			CASE $$OP_ABS
				PRINT "abs ";
			CASE $$OP_EQUALS
				PRINT "= ";
			CASE $$OP_FUNC,$$OP_VAR,$$OP_CONST,$$OP_CONSTFUNC,$$OP_SYMBOL
				symbolTable_get (tokens[i].id, @symbol)
				PRINT stringTable_get$ (symbol.name);" ";
			CASE $$OP_AFUNC,$$OP_AVAR
				symbolTable_get (tokens[i].id, @symbol)
				PRINT ">";stringTable_get$ (symbol.name);" ";
			CASE $$OP_PARAMETER
				PRINT "P";tokens[i].id;" ";
			CASE $$VOP_SWAP
				PRINT "SWAP ";
			CASE $$VOP_PUSH
				PRINT "PUSH ";
			CASE $$VOP_POP
				PRINT "POP ";
			CASE ELSE
				PRINT "TOKEN:";tokens[i].op;";ID:";tokens[i].id;" ";
		END SELECT
	NEXT
	PRINT "\r\n"
END FUNCTION
'
' #######################
' #####  parseLine  #####
' #######################
' Parses a line
FUNCTION VOID parseLine ()
	SHARED	CALCSTATE	calcState	'stores the state information for the calculator
	
	TOKEN 	token
	SYMBOL	assignTo
	SYMBOL	symbol
	DCOMPLEX	n

	'define the states for the parser
	$START				= 1	'starting state
	$EXPRESSION		= 2	'start parsing an expression
	$PLACES				= 4	'looking for command parameter
	$FUNCORVAR		= 5	'are we dealing with a function or variable definition
	$PARADEF			= 6	'get parameter name
	$COMMAORDONE	= 7	'if there's a comma, continue
	$EQUALS				= 8	'looking for an = sign
	
	DIM	params[]		'lists the symbol table ids of the parameters
	DIM pArray[]		'contains the parameter types
	
	state = $START
	defFunc = $$FALSE		'this variable tells us if we are defining a function
	assignToId = -1				'this variable store the id of the symbol we are assigning to
	command = -1				'this variable stores the command
	
	DO WHILE getToken (@token)
		SELECT CASE state
			CASE $START
				SELECT CASE token.op
					CASE $$OP_SYMBOL
						state = $FUNCORVAR
						assignToId = token.id
					CASE $$OP_OUTHEX
						calcState.outputMode = $$OMODE_HEX
					CASE $$OP_OUTDEC
						calcState.outputMode = $$OMODE_DEC
					CASE $$OP_SAR
						calcState.angleMode = $$AMODE_RAD
					CASE $$OP_SAD
						calcState.angleMode = $$AMODE_DEG
					CASE $$OP_SAG
						calcState.angleMode = $$AMODE_GRD
					CASE $$OP_SRN
						calcState.roundingMode = $$RMODE_NONE
					CASE $$OP_SRD
						calcState.roundingMode = $$RMODE_FIX
						state = $PLACES
					CASE $$OP_SRS
						calcState.roundingMode = $$RMODE_SF
						state = $PLACES
					CASE $$OP_CLS
						SendOutput ("\eCLS")
					CASE ELSE
						backTrack()
						parseExpression()
'						PRINT getToken(@token)
				END SELECT
			CASE $FUNCORVAR
				SELECT CASE token.op
					CASE $$OP_OPENPAREN
						state = $PARADEF
						defFunc = $$TRUE
						DIM pArray[0]
					CASE $$OP_EQUALS
						parseExpression()
						n.R = 0
						n.I = 0
						makeVar (assignToId, $$OP_VAR, n)
						token.op = $$OP_AVAR
						token.id = assignToId
						outputToken (token)
					CASE ELSE
						state = $EXPRESSION
						backTrack()
				END SELECT
			CASE $PARADEF
				SELECT CASE token.op
					CASE $$OP_SYMBOL
						'we need to sort out this parameter
						symbolTable_get (token.id, @symbol)	'get the symbol
						symbol.type = $$OP_PARAMETER				'set the type
						symbol.value = pArray[0]						'the parameter's number
						symbolTable_update (token.id, symbol)	'put the symbol back
						REDIM params[pArray[0]]				'allocate more room in the parameter list
						params[pArray[0]] = token.id	'and add the id of the token
						INC pArray[0]									'allocate more room in the parameter array
						REDIM pArray[pArray[0]]				
						pArray[pArray[0]] = $$OP_VAR	'and add the parameter type
					CASE ELSE
						SendError ($$ERROR_EXPECTEDPARAM, "expected a parameter declaration")
				END SELECT
			CASE $COMMAORDONE
				SELECT CASE token.op
					CASE $$OP_COMMA
						state = $PARADEF
					CASE $$OP_CLOSEPAREN
						state = $EQUALS
					CASE ELSE
						SendError ($$ERROR_EXPECTEDCORP, "expected a comma or )")
				END SELECT
			CASE $EXPRESSION
				parseExpression()
			CASE $EQUALS
				IF token.op = $$OP_EQUALS THEN
					parseExpression()
				ELSE
					SendError($$ERROR_EXPECTEDEQ, "expected an =")
				END IF
			CASE $PLACES
				IF token.op = $$OP_LITERAL THEN
					calcState.roundingPlaces = token.number.R
				ELSE
					SendError ($$ERROR_EXPECTEDLIT, "expected a numeric parameter")
				END IF
		END SELECT
	LOOP
	
	
END FUNCTION
'
' #############################
' #####  parseExpression  #####
' #############################
' parses an expression
FUNCTION VOID parseExpression ()
	TOKEN token
	
'	PRINT "EXPRESSION"

	parseProduct()
	
	'get the other products
	DO WHILE getToken (@token)
		IF token.class = $$CLASS_ADDOP THEN
			parseProduct()
			outputToken (token)
		ELSE	'special cases
			SELECT CASE token.op
				CASE $$OP_NEGATE
					backTrack()		'include the - in the product
					parseProduct()
					token.op = $$OP_PLUS
					outputToken(token)
				CASE ELSE
					backTrack()
					RETURN
			END SELECT
		END IF
	LOOP
END FUNCTION
'
' ##########################
' #####  parseProduct  #####
' ##########################
' parses a product
FUNCTION parseProduct ()
	TOKEN	token
	
'	PRINT "PRODUCT"
	parseFactor()
	
	DO WHILE getToken (@token)
		SELECT CASE token.class
			CASE $$CLASS_MULOP
				parseFactor()
				outputToken(token)
			CASE $$CLASS_NUMBER
				backTrack()
				parseFactor()
				token.op = $$OP_MULTIPLY
				token.class = $$CLASS_MULOP
				outputToken (token)
			CASE ELSE
				backTrack()
				RETURN
		END SELECT
	LOOP
END FUNCTION
'
' #########################
' #####  parseFactor  #####
' #########################
' parses a factor
FUNCTION parseFactor ()
	TOKEN token
	
'	PRINT "FACTOR"
	parseTerm()
	
	DO WHILE getToken(@token)
		IF token.class = $$CLASS_EXPOP THEN
			parseTerm()
			outputToken(token)
		ELSE
			backTrack()
			RETURN
		END IF
	LOOP
END FUNCTION
'
' #######################
' #####  parseTerm  #####
' #######################
' parses a term
FUNCTION parseTerm ()
	TOKEN	token
	TOKEN funcCall
	
	$OPEN		= 1		'states for the parameter list parser
	$COMMA	= 2
	$CLOSE	=	3
	
'	PRINT "TERM"
	IFF getToken(@token) THEN RETURN
	
	SELECT CASE token.class
		CASE $$CLASS_IFUNC
			parseTerm()
			outputToken (token)
		CASE $$CLASS_NUMBER
			IF token.op = $$OP_FUNC THEN
				funcCall = token
				getFuncParams (token.id, @params[])
				moreToGo = params[0]
				state = $OPEN
				FOR i = 1 TO (2*moreToGo+1)
					DEC moreToGo
					IFF getToken(@token) THEN 
						SendError ($$ERROR_INCOMPLETEPARAM, "incomplete parameter list")
						RETURN
					END IF
					SELECT CASE state
						CASE $OPEN
							IF token.op = $$OP_OPENPAREN THEN
								parseExpression()
								IF moreToGo THEN state = $COMMA ELSE state = $CLOSE
							ELSE
								SendError ($$ERROR_EXPECTEDOPENP, "expected a (")
								RETURN
							END IF
						CASE $COMMA
							IF token.op = $$OP_COMMA THEN
								parseExpression()
							ELSE
								SendError ($$ERROR_EXPECTEDCOMMA, "expected a ,")
								RETURN
							END IF
						CASE $CLOSE
							IF token.op = $$OP_CLOSEPAREN THEN
								outputToken (funcCall)
							ELSE
								SendError($$ERROR_EXPECTEDCLOSEP, "expected a )")
							END IF
					END SELECT
				NEXT
			ELSE
				backTrack()
				parseNumber()
				IFF getToken (@token) THEN RETURN
				IF token.class = $$CLASS_LAUNOP THEN outputToken(token) ELSE backTrack()
			END IF
		CASE ELSE
			SendError($$ERROR_EXPECTEDNUMORFUNC, "expected a number or a function")
			RETURN
	END SELECT
	
END FUNCTION
'
' #########################
' #####  parseNumber  #####
' #########################
' parses a number
FUNCTION parseNumber ()
	TOKEN		token
	SYMBOL	symbol
	
'	PRINT "NUMBER"
	IFF getToken(@token) THEN
		SendError($$ERROR_EXPECTEDNUMBER, "expected a number, variable or function")
		RETURN
	END IF
	
	SELECT CASE token.op
		CASE $$OP_LITERAL,$$OP_VAR,$$OP_CONST
			outputToken (token)
		CASE $$OP_OPENPAREN
			parseExpression()
			IFF (getToken(@token))||(token.op = $$OP_CLOSEPAREN) THEN
				SendError ($$ERROR_EXPECTEDCLOSEP, "expected a )")
				RETURN
			END IF
		CASE $$OP_ABS
			'is this an open abs
			IFF getToken(@token) THEN RETURN
			backTrack()
			IF (token.class=$$CLASS_NUMBER)||(token.class=$$CLASS_IFUNC)||(token.op=$$OP_OPENPAREN) THEN	'its an open
				parseExpression()
				'get the close abs
				IFF (getToken(@token))||(token.op=$$OP_ABS) THEN
					SendError($$ERROR_EXPECTEDABS, "expected a |")
					RETURN
				ELSE
					outputToken (token)
				END IF
			END IF
		CASE $$OP_SYMBOL
			'report the bad symbol
			symbolTable_get (token.id, @symbol)
			SendError ($$ERROR_UNDEFINED, "undefined symbol "+stringTable_get$ (symbol.name))
			'and remove it
			symbolTable_remove (token.id)
	END SELECT
END FUNCTION
'
' #######################
' #####  calculate  #####
' #######################
' This is the function that does the actual calculation
' tokens[] = an array of tokens
' params[] = an array of parameter values
' func = TRUE if executing a function or FALSE if executing an entire expression
' returns a pointer to a RESULT structure or 0 on fail
FUNCTION calculate (TOKEN tokens[], DCOMPLEX params[], func)
	SHARED	DCOMPLEX	stacks[]	'the calculation stacks
	SHARED	stackPtr[]					'the calculation stack pointer
	SHARED	TOKEN		funcData[]	'data for the functions
	SHARED	CALCSTATE	calcState	'stores the state information for the calculator
	
	'use to store tempory results
	DCOMPLEX	source
	DCOMPLEX	dest
	DCOMPLEX	n
	
	DCOMPLEX passParms[]		'this array contains parameters for function calling
	
	'clean the stack
	DIM stacks[0,31]
	DIM stackPtr[0]
	
	cStacks = 0		'number of stacks - 1
	
	FOR token = 0 TO UBOUND(tokens[])
		SELECT CASE tokens[token].op
			CASE $$OP_NOTOKEN
				SendError($$ERROR_BADTOKEN, "")
				RETURN 0
			CASE $$OP_LITERAL
				FOR s = 0 TO cStacks
					IFF stack_push (tokens[token].number, s) THEN RETURN 0
				NEXT
			CASE $$OP_PLUS
				FOR s = 0 TO cStacks
					IFF stack_pop (@source, s) THEN RETURN 0
					IFF stack_pop (@dest, s) THEN RETURN 0
					dest.R = dest.R+source.R
					dest.I = dest.I+source.I
					IFF stack_push (dest, s) THEN RETURN 0
				NEXT
			CASE $$OP_OR
				FOR s = 0 TO cStacks
					IFF stack_pop (@source, s) THEN RETURN 0
					IFF stack_pop (@dest, s) THEN RETURN 0
					dest.R = GIANT(dest.R) OR GIANT(source.R)
					dest.I = 0
					IFF stack_push (dest, s) THEN RETURN 0
				NEXT
			CASE $$OP_XOR
				FOR s = 0 TO cStacks
					IFF stack_pop (@source, s) THEN RETURN 0
					IFF stack_pop (@dest, s) THEN RETURN 0
					dest.R = GIANT(dest.R) XOR GIANT(source.R)
					dest.I = 0
					IFF stack_push (dest, s) THEN RETURN 0
				NEXT
			CASE $$OP_MULTIPLY
				FOR s = 0 TO cStacks
					IFF stack_pop (@source, s) THEN RETURN 0
					IFF stack_pop (@dest, s) THEN RETURN 0
					IF (source.I = 0.0)&&(dest.I = 0.0) THEN
						dest.R = dest.R*source.R
					ELSE
						dest.R = dest.R*source.R-dest.I*source.I
						dest.I = source.R*dest.I+source.I*dest.R
					END IF
					IFF stack_push (dest, s) THEN RETURN 0
				NEXT
			CASE $$OP_DIVIDE
				FOR s = 0 TO cStacks
					IFF stack_pop (@source, s) THEN RETURN 0
					IFF stack_pop (@dest, s) THEN RETURN 0
					IF (source.I = 0.0)&&(dest.I = 0.0) THEN
						IF source.R = 0.0 THEN
							SendError ($$ERROR_DIVBYZERO, "divide by 0")
							RETURN 0
						END IF
						dest.R = dest.R/source.R
					ELSE
						n# = source.R*source.R + source.I*source.I
						dest.R = (dest.R*source.R+dest.I*source.I)/n#
						dest.I = (dest.I*source.R-dest.R*source.I)/n#
					END IF
					IFF stack_push (dest, s) THEN RETURN 0
				NEXT
			CASE $$OP_RSHIFT
				FOR s = 0 TO cStacks
					IFF stack_pop (@source, s) THEN RETURN 0
					IFF stack_pop (@dest, s) THEN RETURN 0
					dest.R = XLONG(dest.R) >> XLONG(source.R)
					dest.I = 0.0
					IFF stack_push (dest, s) THEN RETURN 0
				NEXT
			CASE $$OP_LSHIFT
				FOR s = 0 TO cStacks
					IFF stack_pop (@source, s) THEN RETURN 0
					IFF stack_pop (@dest, s) THEN RETURN 0
					dest.R = XLONG(dest.R) << XLONG(source.R)
					dest.I = 0.0
					IFF stack_push (dest, s) THEN RETURN 0
				NEXT
			CASE $$OP_AND
				FOR s = 0 TO cStacks
					IFF stack_pop (@source, s) THEN RETURN 0
					IFF stack_pop (@dest, s) THEN RETURN 0
					dest.R = XLONG(dest.R) AND XLONG(source.R)
					dest.I = 0.0
					IFF stack_push (dest, s) THEN RETURN 0
				NEXT
			CASE $$OP_POWER
				FOR s = 0 TO cStacks
					IFF stack_pop (@source, s) THEN RETURN 0
					IFF stack_pop (@dest, s) THEN RETURN 0
					IF source.I = 0.0 THEN
						dest = Dcpowercr (dest, source.R)
					ELSE
						IF dest.I = 0.0 THEN
							dest = Dcpowerrc (dest.R, source)
						ELSE
							dest = Dcpowercc (dest, source)
						END IF
					END IF
					IFF stack_push (dest, s) THEN RETURN 0
				NEXT
			CASE $$OP_ROOT	'source Rt dest
				FOR s = 0 TO cStacks
					IFF stack_pop (@dest, s) THEN RETURN 0
					IFF stack_pop (@source, s) THEN RETURN 0
					IF source.I = 0.0 THEN
						IF source.R = 0.0 THEN 
							SendError($$ERROR_DIVBYZERO, "divide by 0")
							RETURN 0
						END IF
						source.R = 1/source.R
						dest = Dcpowercr (dest, source.R)
					ELSE
						'multiplicative inverse of source
						n# = source.R*source.R + source.I*source.I		'n cannot be 0 as source.I != 0
						source.R = source.R/n#
						source.I = -source.I/n#
						IF dest.I = 0.0 THEN
							dest = Dcpowerrc (dest.R, source)
						ELSE
							dest = Dcpowercc (dest, source)
						END IF
					END IF
					IFF stack_push (dest, s) THEN RETURN 0
				NEXT
			CASE $$OP_C
				FOR s = 0 TO cStacks
					IFF stack_pop (@source, s) THEN RETURN 0
					IFF stack_pop (@dest, s) THEN RETURN 0
					IF (dest.I!=0)||(source.I!=0)||(dest.R<1)||(source.R<1)|| _
						(INT(dest.R)!=dest.R)||(INT(source.R)!=source.R) THEN
						SendError($$ERROR_UNDEFINED, "undefined")
						RETURN 0
					END IF
					n# = factorial(dest.R - source.R, 1)
					dest.R = factorial(dest.R, source.R)/n#
					IFF stack_push (dest, s) THEN RETURN 0
				NEXT
			CASE $$OP_P
				FOR s = 0 TO cStacks
					IFF stack_pop (@source, s) THEN RETURN 0
					IFF stack_pop (@dest, s) THEN RETURN 0
					IF (dest.I!=0)||(source.I!=0)||(dest.R<1)||(source.R<1)|| _
						(INT(dest.R)!=dest.R)||(INT(source.R)!=source.R) THEN
						SendError($$ERROR_UNDEFINED, "undefined")
						RETURN 0
					END IF
					n# = dest.R - source.R
					dest.R = factorial(dest.R, n#)
					IFF stack_push (dest, s) THEN RETURN 0
				NEXT
			CASE $$OP_NEGATE
				FOR s = 0 TO cStacks
					IFF stack_pop (@dest, s) THEN RETURN 0
					dest.R = -dest.R
					dest.I = -dest.I
					IFF stack_push (dest, s) THEN RETURN 0
				NEXT
			CASE $$OP_NOT
				FOR s = 0 TO cStacks
					IFF stack_pop (@dest, s) THEN RETURN 0
					dest.R = NOT(XLONG(dest.R))
					dest.I = 0.0
					IFF stack_push (dest, s) THEN RETURN 0
				NEXT
			CASE $$OP_SQR
				newcStacks = cStacks
				FOR s = 0 TO cStacks
					IFF stack_pop (@dest, s) THEN RETURN 0
					IF dest.I = 0.0 THEN
						IF dest.R < 0.0 THEN
							dest.I = (-dest.R)**(0.5)
							INC newcStacks
							n.R = 0
							n.I = -dest.I
							stack_new (n)
						ELSE
							dest.R = dest.R**(0.5)
							INC newcStacks
							n.R = -dest.R
							n.I = 0
							stack_new(n)
						END IF
					ELSE
						dest = Dcpowercr(dest, 0.5)
						INC newcStacks
						n.R = -dest.R
						n.I = -dest.I
						stack_new (n)
					END IF
					IFF stack_push (dest, s) THEN RETURN 0
				NEXT
				cStacks = newcStacks
			CASE $$OP_CBR
				newcStacks = cStacks
				FOR s = 0 TO cStacks
					IFF stack_pop (@dest, s) THEN RETURN 0
					IF dest.I = 0.0 THEN
						dest.R = dest.R**(1/3)
					ELSE
						dest = Dcpowercr(dest, 1/3)
					END IF
					'generate the alternate solutions
					newcStacks = newcStacks+2
					arg# = Dcarg (dest)+(2*$$PI/3)
					abs# = Dcabs (dest)
					n = Dcpolor(abs#, arg#)
					stack_new(n)
					arg# = arg#+(2*$$PI/3)
					n = Dcpolor(abs#, arg#)
					stack_new(n)
					IFF stack_push (dest, s) THEN RETURN 0
				NEXT
				cStacks = newcStacks
			CASE $$OP_SIN
				FOR s = 0 TO cStacks
					IFF stack_pop (@dest, s) THEN RETURN 0
					IF dest.I = 0.0 THEN
						SELECT CASE calcState.angleMode
							CASE $$AMODE_DEG
								dest.R = dest.R*$$PIDIV180
							CASE $$AMODE_GRD
								dest.R = dest.R*$$PIDIV200
						END SELECT
						dest.R = ccSin(dest.R)
					ELSE
						SELECT CASE calcState.angleMode
							CASE $$AMODE_DEG
								dest = Dcrmul(dest, $$PIDIV180)
							CASE $$AMODE_GRD
								dest = Dcrmul(dest, $$PIDIV200)
						END SELECT
						dest = Dcsin(dest)
					END IF
					IFF stack_push (dest, s) THEN RETURN 0
				NEXT
			CASE $$OP_COS
				FOR s = 0 TO cStacks
					IFF stack_pop (@dest, s) THEN RETURN 0
					IF dest.I = 0.0 THEN
						SELECT CASE calcState.angleMode
							CASE $$AMODE_DEG
								dest.R = dest.R*$$PIDIV180
							CASE $$AMODE_GRD
								dest.R = dest.R*$$PIDIV200
						END SELECT
						dest.R = ccCos(dest.R)
					ELSE
						SELECT CASE calcState.angleMode
							CASE $$AMODE_DEG
								dest = Dcrmul(dest, $$PIDIV180)
							CASE $$AMODE_GRD
								dest = Dcrmul(dest, $$PIDIV200)
						END SELECT
						dest = Dccos(dest)
					END IF
					IFF stack_push (dest, s) THEN RETURN 0
				NEXT
			CASE $$OP_TAN
				FOR s = 0 TO cStacks
					IFF stack_pop (@dest, s) THEN RETURN 0
					IF dest.I = 0.0 THEN
						SELECT CASE calcState.angleMode
							CASE $$AMODE_DEG
								dest.R = dest.R*$$PIDIV180
							CASE $$AMODE_GRD
								dest.R = dest.R*$$PIDIV200
						END SELECT
						dest.R = ccTan(dest.R)
						IF dest.R = $$PINF THEN
							SendError($$ERROR_DIVBYZERO, "divide by 0")
							RETURN 0
						END IF
					ELSE
						SELECT CASE calcState.angleMode
							CASE $$AMODE_DEG
								dest = Dcrmul(dest, $$PIDIV180)
							CASE $$AMODE_GRD
								dest = Dcrmul(dest, $$PIDIV200)
						END SELECT
						dest = Dctan(dest)
					END IF
					IFF stack_push (dest, s) THEN RETURN 0
				NEXT
			CASE $$OP_COT
				FOR s = 0 TO cStacks
					IFF stack_pop (@dest, s) THEN RETURN 0
					IF dest.I = 0.0 THEN
						SELECT CASE calcState.angleMode
							CASE $$AMODE_DEG
								dest.R = dest.R*$$PIDIV180
							CASE $$AMODE_GRD
								dest.R = dest.R*$$PIDIV200
						END SELECT
						dest.R = ccCot(dest.R)
						IF dest.R = $$PINF THEN
							SendError($$ERROR_DIVBYZERO, "divide by 0")
							RETURN 0
						END IF
					ELSE
						SELECT CASE calcState.angleMode
							CASE $$AMODE_DEG
								dest = Dcrmul(dest, $$PIDIV180)
							CASE $$AMODE_GRD
								dest = Dcrmul(dest, $$PIDIV200)
						END SELECT
						dest = Dctan(dest)
						n# = dest.R*dest.R + dest.I*dest.I
						dest.R = dest.R/n#
						dest.I = -dest.I/n#
					END IF
					IFF stack_push (dest, s) THEN RETURN 0
				NEXT
			CASE $$OP_SEC
				FOR s = 0 TO cStacks
					IFF stack_pop (@dest, s) THEN RETURN 0
					IF dest.I = 0.0 THEN
						SELECT CASE calcState.angleMode
							CASE $$AMODE_DEG
								dest.R = dest.R*$$PIDIV180
							CASE $$AMODE_GRD
								dest.R = dest.R*$$PIDIV200
						END SELECT
						dest.R = ccCos(dest.R)
						IF dest.R = 0.0 THEN 
							SendError($$ERROR_DIVBYZERO, "divide by 0")
							RETURN 0
						END IF
						dest.R = 1.0/dest.R
					ELSE
						SELECT CASE calcState.angleMode
							CASE $$AMODE_DEG
								dest = Dcrmul(dest, $$PIDIV180)
							CASE $$AMODE_GRD
								dest = Dcrmul(dest, $$PIDIV200)
						END SELECT
						dest = Dccos(dest)
						n# = dest.R*dest.R + dest.I*dest.I
						dest.R = dest.R/n#
						dest.I = -dest.I/n#
					END IF
					IFF stack_push (dest, s) THEN RETURN 0
				NEXT
			CASE $$OP_CSC
				FOR s = 0 TO cStacks
					IFF stack_pop (@dest, s) THEN RETURN 0
					IF dest.I = 0.0 THEN
						SELECT CASE calcState.angleMode
							CASE $$AMODE_DEG
								dest.R = dest.R*$$PIDIV180
							CASE $$AMODE_GRD
								dest.R = dest.R*$$PIDIV200
						END SELECT
						dest.R = ccSin(dest.R)
						IF dest.R = 0.0 THEN
							SendError($$ERROR_DIVBYZERO, "divide by 0")
							RETURN 0
						END IF
						dest.R = 1.0/dest.R
					ELSE
						SELECT CASE calcState.angleMode
							CASE $$AMODE_DEG
								dest = Dcrmul(dest, $$PIDIV180)
							CASE $$AMODE_GRD
								dest = Dcrmul(dest, $$PIDIV200)
						END SELECT
						dest = Dcsin(dest)
						n# = dest.R*dest.R + dest.I*dest.I
						dest.R = dest.R/n#
						dest.I = -dest.I/n#
					END IF
					IFF stack_push (dest, s) THEN RETURN 0
				NEXT
			CASE $$OP_ASIN
				FOR s = 0 TO cStacks
					IFF stack_pop (@dest, s) THEN RETURN 0
					IF dest.I = 0.0 THEN
						dest.R = Asin(dest.R)
						SELECT CASE calcState.angleMode
							CASE $$AMODE_DEG
								dest.R = dest.R*$$PIDIV180
							CASE $$AMODE_GRD
								dest.R = dest.R*$$PIDIV200
						END SELECT
					ELSE
						dest = Dcasin(dest)
						SELECT CASE calcState.angleMode
							CASE $$AMODE_DEG
								dest = Dcrmul(dest, $$PIDIV180)
							CASE $$AMODE_GRD
								dest = Dcrmul(dest, $$PIDIV200)
						END SELECT
					END IF
					IFF stack_push (dest, s) THEN RETURN 0
				NEXT
			CASE $$OP_ACOS
				FOR s = 0 TO cStacks
					IFF stack_pop (@dest, s) THEN RETURN 0
					IF dest.I = 0.0 THEN
						dest.R = Acos(dest.R)
						SELECT CASE calcState.angleMode
							CASE $$AMODE_DEG
								dest.R = dest.R*$$PIDIV180
							CASE $$AMODE_GRD
								dest.R = dest.R*$$PIDIV200
						END SELECT
					ELSE
						dest = Dcacos(dest)
						SELECT CASE calcState.angleMode
							CASE $$AMODE_DEG
								dest = Dcrmul(dest, $$PIDIV180)
							CASE $$AMODE_GRD
								dest = Dcrmul(dest, $$PIDIV200)
						END SELECT
					END IF
					IFF stack_push (dest, s) THEN RETURN 0
				NEXT
			CASE $$OP_ATAN
				FOR s = 0 TO cStacks
					IFF stack_pop (@dest, s) THEN RETURN 0
					IF dest.I = 0.0 THEN
						dest.R = Atan(dest.R)
						SELECT CASE calcState.angleMode
							CASE $$AMODE_DEG
								dest.R = dest.R*$$PIDIV180
							CASE $$AMODE_GRD
								dest.R = dest.R*$$PIDIV200
						END SELECT
					ELSE
						dest = Dcatan(dest)
						SELECT CASE calcState.angleMode
							CASE $$AMODE_DEG
								dest = Dcrmul(dest, $$PIDIV180)
							CASE $$AMODE_GRD
								dest = Dcrmul(dest, $$PIDIV200)
						END SELECT
					END IF
					IFF stack_push (dest, s) THEN RETURN 0
				NEXT
			CASE $$OP_ACOT
			CASE $$OP_ASEC
			CASE $$OP_ACSC
			CASE $$OP_SINH
			CASE $$OP_COSH
			CASE $$OP_TANH
			CASE $$OP_COTH
			CASE $$OP_SECH
			CASE $$OP_CSCH
			CASE $$OP_ASINH
			CASE $$OP_ACOSH
			CASE $$OP_ATANH
			CASE $$OP_ACOTH
			CASE $$OP_ASECH
			CASE $$OP_ACSCH
			CASE $$OP_LOG
				FOR s = 0 TO cStacks
					IFF stack_pop (@dest, s) THEN RETURN 0
					IF dest.I = 0.0 THEN
						IF dest.R <= 0 THEN
							SendError($$ERROR_UNDEFINED, "x <= 0 is undefined for log functions")
							RETURN 0
						END IF
						dest.R = Log10 (dest.R)
					ELSE
						IF (dest.R <= 0) && (dest.I <= 0) THEN
							SendError($$ERROR_UNDEFINED, "x <= 0 is undefined for log functions")
							RETURN 0
						END IF
						dest = Dclog10(dest)
					END IF
					IFF stack_push (dest, s) THEN RETURN 0
				NEXT
			CASE $$OP_LOGe
				FOR s = 0 TO cStacks
					IFF stack_pop (@dest, s) THEN RETURN 0
					IF dest.I = 0.0 THEN
						IF dest.R <= 0 THEN
							SendError($$ERROR_UNDEFINED, "x <= 0 is undefined for log functions")
							RETURN 0
						END IF
						dest.R = Log (dest.R)
					ELSE
						IF (dest.R <= 0) && (dest.I <= 0) THEN
							SendError($$ERROR_UNDEFINED, "x <= 0 is undefined for log functions")
							RETURN 0
						END IF
						dest = Dclog(dest)
					END IF
					IFF stack_push (dest, s) THEN RETURN 0
				NEXT
			CASE $$OP_LOG2
				FOR s = 0 TO cStacks
					IFF stack_pop (@dest, s) THEN RETURN 0
					IF dest.I = 0.0 THEN
						IF dest.R <= 0 THEN
							SendError($$ERROR_UNDEFINED, "x <= 0 is undefined for log functions")
							RETURN 0
						END IF
						dest.R = Log (dest.R) * $$1OVERLN2
					ELSE
						IF (dest.R <= 0) && (dest.I <= 0) THEN
							SendError($$ERROR_UNDEFINED, "x <= 0 is undefined for log functions")
							RETURN 0
						END IF
						dest = Dclog(dest)
						dest.R = dest.R * $$1OVERLN2
						dest.I = dest.I * $$1OVERLN2
					END IF
					IFF stack_push (dest, s) THEN RETURN 0
				NEXT
			CASE $$OP_FACT
				FOR s = 0 TO cStacks
					IFF stack_pop (@dest, s) THEN RETURN 0
					IF (dest.I != 0)||(dest.R < 0)||(INT(dest.R) != dest.R) THEN
						SendError($$ERROR_UNDEFINED, "factorial is defined only for whole numbers")
						RETURN 0
					END IF
					dest.R = factorial(dest.R, 1)
					IFF stack_push (dest, s) THEN RETURN 0
				NEXT
			CASE $$OP_INT
			CASE $$OP_FRAC
			CASE $$OP_ASSIGN
			CASE $$OP_LASTANS
			CASE $$OP_ABS
			CASE $$OP_FUNC
			CASE $$OP_AFUNC
			CASE $$OP_PARAMETER
			CASE $$OP_VAR
				FOR s = 0 TO cStacks
					IFF stack_push (getVar(tokens[token].id), s) THEN RETURN 0
				NEXT
			CASE $$OP_AVAR
				IFF stack_getTOS(0, @n) THEN RETURN 0
				updateVar (tokens[token].id, n)
			CASE $$OP_CONST
'			CASE $$VOP_SWAP
'			CASE $$VOP_PUSH
'			CASE $$VOP_POP
			CASE ELSE
		END SELECT
	NEXT
	
	
END FUNCTION
'
' #######################
' #####  factorial  #####
' #######################
' efficient factorial algorithm to calculate x!/y!
FUNCTION DOUBLE factorial (DOUBLE x, DOUBLE y)
	DOUBLE r
	DOUBLE n
	DOUBLE a
	DOUBLE b

	IF (x = y) THEN RETURN 1.0
	IF x > y THEN
		r = x
		a = x-1
		b = y+1
		FOR n = a TO b
			r = r*n
		NEXT
	ELSE
		r = 1.0/y
		a = y-1
		b = x+1
		FOR n = a TO b
			r = r/n
		NEXT
	END IF
	
	RETURN r
END FUNCTION
'
' #############################
' #####  handleException  #####
' #############################
' handles excpetions
FUNCTION handleException ()
	XstGetException (@exception)
	XstExceptionNumberToName (exception, @exception$)
	program$ = XstGetProgramFileName$ ()
	MessageBoxA (0, &exception$, &program$, $$MB_OK|$$MB_ICONSTOP)
	RETURN $$ExceptionTerminate 
END FUNCTION
'
' ###################
' #####  ccSin  #####
' ###################
' an improved sin calculating function
FUNCTION DOUBLE ccSin (DOUBLE x)
	SHARED	CALCSTATE	calcState
	
	'take the meaningfull part
	x = Fmod (x, $$TWOPI)
	
	'select the range
	IF x <= $$PIDIV2 THEN RETURN Sin(x)
	x = x - $$PIDIV2
	IF x <= $$PIDIV2 THEN RETURN Sin($$PIDIV2-x)
	x = x - $$PIDIV2
	IF x <= $$PIDIV2 THEN RETURN -Sin(x)
	x = x - $$PIDIV2
	RETURN -Sin($$PIDIV2-x)
END FUNCTION
'
' ###################
' #####  ccCos  #####
' ###################
' an improved cos calculating function
FUNCTION DOUBLE ccCos (DOUBLE x)
	RETURN ccSin($$PIDIV2-x)
END FUNCTION
'
' ###################
' #####  ccTan  #####
' ###################
' calculates the tangent, returning $$PINF on div by 0
FUNCTION DOUBLE ccTan (DOUBLE x)
	d# = ccCos(x)
	IF d# = 0.0 THEN RETURN $$PINF ELSE RETURN ccSin(x)/d#
END FUNCTION
'
' #######################
' #####  stack_new  #####
' #######################
' Creates a new stack and pushes a value onto it
'	returns the id of the new stack
FUNCTION stack_new (DCOMPLEX val)
	SHARED	DCOMPLEX	stacks[]	'the calculation stacks
	SHARED	stackPtr[]					'the calculation stack pointers
	
	s = UBOUND(stackPtr[])+1
	REDIM stackPtr[s]
	REDIM stacks[s, UBOUND(stacks[0,])]

	stackPtr[s]	= stackPtr[s-1]
	stacks[s, stackPtr] = val
	INC stackPtr[s]
	
	RETURN s
END FUNCTION
'
' ###################
' #####  ccCot  #####
' ###################
' calculates the cotangent, returning $$PINF on div by 0
FUNCTION DOUBLE ccCot (DOUBLE x)
	d# = ccSin(x)
	IF d# = 0.0 THEN RETURN $$PINF ELSE RETURN ccCos(x)/d#
END FUNCTION
'
' ##########################
' #####  stack_getTOS  #####
' ##########################
' reads the value on the top of the stack
'	stackId =  the id of the stack to get the value from
' value = the variable to place the value in
' returns true on success or false on fail
FUNCTION stack_getTOS (stackId, DCOMPLEX value)
	SHARED	DCOMPLEX	stacks[]	'the calculation stacks
	SHARED	stackPtr[]					'the calculation stack pointers
	
	IF stackId < 0 || stackId > UBOUND(stacks[]) THEN
		SendError($$ERROR_BADSTKID,"")
		RETURN $$FALSE
	END IF
	
	IF stackPtr[stackId] < 1 THEN
		SendError($$ERROR_STACKUNDERFLOW,"")
		RETURN $$FALSE
	END IF
	
	value = stacks[stackId, stackPtr[stackId]-1]
	RETURN $$TRUE
END FUNCTION

END PROGRAM