'
' ####################
' #####  PROLOG  #####
' ####################
'
' A console program template
'
PROGRAM "cheapCalc"
VERSION "2.00"
CONSOLE
'
	IMPORT  "xst_s"				' Standard library : required by most programs
'	IMPORT  "xsx"				' Extended standard library
	IMPORT  "xio_s"				' Console input/ouput library
' IMPORT	"gdi32"			' gdi32.dll
'	IMPORT  "user32"		' user32.dll
'	IMPORT  "kernel32"	' kernel32.dll
'	IMPORT  "shell32"		' shell32.dll
'	IMPORT  "msvcrt"		' msvcrt.dll
	IMPORT	"calculate"	' Caculate.dll

'
DECLARE FUNCTION Entry ()
DECLARE FUNCTION VOID handleError (erroCode, pszErrorString)
DECLARE FUNCTION VOID displayOutput (pszOutString)
'
'
' ######################
' #####  Entry ()  #####
' ######################
'
FUNCTION Entry ()
	DCOMPLEX Answers[]
	
	#hStdOut = XioGetStdOut ()
	
	IFF Calc_Init() || Calc_RegisterIO (&handleError(), &displayOutput()) THEN
		PRINT "Initialisation failed"
		RETURN
	END IF
	
	ver = Calc_getVersion()
	ver$ = STRING$((ver>>24) AND 0x000000FF)+"."+STRING$((ver>>16) AND 0x000000FF) _
	+"."+STRING$((ver>>8) AND 0x000000FF)+"."+STRING$(ver AND 0x000000FF)
	
	PRINT "Using calculation engine version: ";ver$
	
	
	DO
		IN$ = INLINE$ ("Enter Expression: ")
		SELECT CASE UCASE$(IN$)
			CASE "QUIT"
				EXIT DO
			CASE "VER"
				PRINT "cheapCalc Version ";VERSION$(0);"\nCalculation Engine Version ";ver$;"\n(C) Callum Lowcay 2006"
			CASE "HELP"
				PRINT "not implemented yet"
			CASE ELSE
				pRes = Calc_Calculate(&IN$)
		END SELECT
	LOOP WHILE $$TRUE
	
	
END FUNCTION
'
' #########################
' #####  handleError  #####
' #########################
' this function outputs error messages to the screen
' errorCode = the error code
' pszErrorString = a pointer to a string version of the error
' returns VOID
FUNCTION VOID handleError (errorCode, pszErrorString)
	PRINT CSTRING$(pszErrorString)
END FUNCTION
'
' ###########################
' #####  displayOutput  #####
' ###########################
' this function outputs data to the screen
' pszOutString = a pointer to the output string
' returns VOID
FUNCTION VOID displayOutput (pszOutString)
	OutString$ =  CSTRING$(pszOutString)
	IF OutString$ = "\eCLS" THEN XioClearConsole (#hStdOut) ELSE PRINT OutString$
END FUNCTION
END PROGRAM