'
' ####################
' #####  PROLOG  #####
' ####################
'
' A console program template
'
VERSION "0.0001"
CONSOLE
'
	IMPORT "xst"				' Standard library : required by most programs
'	IMPORT "xsx"				' Extended standard library
'	IMPORT "xio"				' Console input/ouput library

'	IMPORT "xst_s.lib"
' IMPORT "xsx_s.lib"
' IMPORT "xio_s.lib"

' IMPORT "gdi32"			' gdi32.dll
'	IMPORT "user32"		  ' user32.dll
	IMPORT "kernel32"	  ' kernel32.dll
'	IMPORT "shell32"		' shell32.dll
'	IMPORT "msvcrt"		  ' msvcrt.dll
	IMPORT "gmp"
	IMPORT "calculate"

DECLARE FUNCTION Entry ()
DECLARE FUNCTION CountBrackets (in$)
'
'
' ######################
' #####  Entry ()  #####
' ######################
'
FUNCTION Entry ()
	SHARED	countC
	SHARED	countS
	SHARED	countP
	GIANT start
	GIANT end
	
	calculate_init ()
	
	DO
		countC = 0
		countS = 0
		IF go THEN line$ = "mkv(1,3)" ELSE line$ = INLINE$ ("Enter Expression: ")
		IF line$ = "go" THEN go = $$TRUE
		
		in$ = line$
		SELECT CASE UCASE$(in$)
			CASE ""
				EXIT DO
			CASE "Q", "QUIT", "EXIT"
				EXIT DO
			CASE "H", "?", "HELP"
				PRINT "See manual for help with expressions"
				PRINT "CheapCalc adds extra commands to those available in BetterCalc"
				PRINT "Note that they are case insensitive, like BetterCalc expressions"
				PRINT 
				PRINT "BLANKLINE, quit, q and exit - quit CheapCalc"
				PRINT "h, ?, help - display this help message"
				PRINT "ver, version - display the CheapCalc version number"
				PRINT "dump, show, list - list all user defined symbols"
				PRINT
				PRINT "You can enter multiline expressions.  If there are unmatched brackets"
				PRINT "and you press return, you will be able to enter additional lines.  To"
				PRINT "cancel the multiline command just enter a blank line"
			CASE "VER", "VERSION"
				PRINT "CheapCalc v"; VERSION$(0)
			CASE "DUMP","SHOW", "LIST"
				PRINT calculate_getSymbols$()
			CASE ELSE
				DO WHILE CountBrackets (line$)
					line$ = INLINE$ (" ")
					IF line$ = "" THEN DO DO 2
					in$ = in$+line$
				LOOP
				
				expr = calculate_parse (in$, @errors$)
				IF errors$ THEN
					PRINT errors$ 
				ELSE 
					QueryPerformanceCounter(&start)
					calculate_execute (expr, 0, @exception, @out$)
					QueryPerformanceCounter(&end)
					'PRINT "Computation took ";STRING(end-start);" counts"
					SELECT CASE exception
						CASE $$EXCEPTION_UNDEFINED
							PRINT "Undefined"
						CASE ELSE
							PRINT out$
					END SELECT
					calculate_clearExpression (expr)
				END IF
		END SELECT
	LOOP

END FUNCTION
'
' ###########################
' #####  CountBrackets  #####
' ###########################
FUNCTION CountBrackets (in$)
	SHARED	countC
	SHARED	countS
	SHARED	countP
	
	FOR i = 0 TO UBOUND(in$)
		SELECT CASE in${i}
			CASE '{'
				INC countC
			CASE '}'
				DEC countC
			CASE '['
				INC countS
			CASE ']'
				DEC countS
			CASE '('
				INC countP
			CASE ')'
				DEC countP
		END SELECT
	NEXT
	IFZ (countC|countS|countP) THEN RETURN $$FALSE ELSE RETURN $$TRUE
END FUNCTION
END PROGRAM